dnl Local macros for use in the LINSOL package

dnl LS_TRY_F_RUN(PROGRAM, [ACTION-IF-TRUE [, ACTION-IF-FALSE
dnl            [, ACTION-IF-CROSS-COMPILING]]])
AC_DEFUN(LS_TRY_F_RUN,
[if test "$cross_compiling" = yes; then
  ifelse([$4], ,
    [errprint(__file__:__line__: warning: [LS_TRY_F_RUN] called without default to allow cross compiling
)dnl
  AC_MSG_ERROR(can not run test program while cross compiling)],
  [$4])
else
  LS_TRY_F_RUN_NATIVE([$1], [$2], [$3])
fi
])

dnl Like LS_F_TRY_RUN but assumes a native-environment (non-cross) compiler.
dnl LS_F_TRY_RUN_NATIVE(PROGRAM, [ACTION-IF-TRUE [, ACTION-IF-FALSE]])
AC_DEFUN(LS_TRY_F_RUN_NATIVE,
[cat > conftest.$ac_ext <<EOF
C line __oline__ "configure"
[$1]
EOF
if AC_TRY_EVAL(ac_link) && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
then
dnl Don't remove the temporary files here, so they can be examined.
  ifelse([$2], , :, [$2])
else
  echo "configure: failed program was:" >&AC_FD_CC
  cat conftest.$ac_ext >&AC_FD_CC
ifelse([$3], , , [  rm -fr conftest*
  $3
])dnl
fi
rm -fr conftest*])


dnl LS_F_CHECK_SIZEOF(TYPE, ZEROVAL [, CROSS-SIZE])
AC_DEFUN(LS_F_CHECK_SIZEOF,
[changequote(<<, >>)dnl
dnl The name to #define.
define(<<LS_TYPE_NAME>>, translit(sizeof_f_$1, [a-z *], [A-Z_x]))dnl
dnl The cache variable name.
define(<<LS_CV_NAME>>, translit(ls_cv_sizeof_f_$1, [ *], [_x]))dnl
changequote([, ])dnl
AC_MSG_CHECKING(size of Fortran data type $1)
AC_CACHE_VAL(LS_CV_NAME,
[LS_TRY_F_RUN([      PROGRAM BLA
      character*1 ch(64)
      integer i
      $1 testvar
      EQUIVALENCE(ch, testvar)

      open(7,FILE='conftestval')
      do 1 i=1, 64
         ch(i)=char(204)
 1    continue
      testvar=$2
      do 2 i=1, 64
         if (ch(i) .eq. char(204)) goto 3
 2    continue
 3    write (7,*) i-1
      close(7)
      END
], LS_CV_NAME=`cat conftestval | sed -e's/\r//g'`, LS_CV_NAME=0, ifelse([$3], , , LS_CV_NAME=$3))])dnl
AC_MSG_RESULT($LS_CV_NAME)
AC_DEFINE_UNQUOTED(LS_TYPE_NAME, $LS_CV_NAME)
LS_TYPE_NAME=$LS_CV_NAME dnl Define shell variable with the same name
undefine([LS_TYPE_NAME])dnl
undefine([LS_CV_NAME])dnl
])
