      program exam01s

      implicit none

      integer    nproc,l,lmat,lindex,ia1,ia2,nilin,nrlin
      parameter (l=8,lmat=23,lindex=9,ia1=5,ia2=7,nilin=50,nrlin=10)
      parameter (nproc=1)
      real*8     MAT(lmat)
      real*8     x(l),rhs(l),rlin(nrlin)
      integer    index(lindex),info(ia1,ia2)
      integer    ilin(nilin)
      integer    lmatbk(nproc),tids(nproc)
      integer    i,j,ierr,iconv
      logical    lsym

!
!*** The dimension (= number of unknowns) of the linear system is l=8.
!*** You find further information related to this example (exam01)
!*** in the manual pages <matrix> and <lsolp>!!!
!

!
!*** Creation of array <MAT>
!
      do i=1,l
	mat(i) =  4.d0    ! << Main diagonal
      enddo

      do i=l+1,l+4
	mat(i) = -1.d0    ! << Full diagonal
      enddo

      mat(l+5) =  2.d0    !
      mat(l+6) =  3.d0    ! << Packed diagonal
      mat(l+7) =  3.d0    !

      mat(l+8) =  5.d0    !
      mat(l+9) = -2.d0    ! << Starry sky
      mat(l+10)=  3.d0    !

      do i=l+11,l+15
	mat(i) =  1.d0    ! << Full row
      enddo


!                  | 4.  0   2.  3.  0   0   5.  0. |
!                  | 0   4. -1.  3.  0   0   0   0. |
!                  | 2. -1.  4. -1.  0  -2.  0   1. |
!           MAT =  | 3.  3. -1.  4. -1.  0   0   1. |
!                  | 0   0   0  -1.  4. -1.  3.  1. |
!                  | 0   0  -2.  0  -1.  4.  0   1. |
!                  | 5.  0   0   0   3.  0   4.  1. |
!                  | 0   0   1.  1.  1.  1.  1.  4. |
!
!
!*** Creation of array <index>
!
      index(1) = 1        !
      index(2) = 2        ! << Packed diagonal
      index(3) = 5        !

      index(4) = 7        ! << Column indices of the vector term
      index(5) = 6        ! << Starry Sky
      index(6) = 1        !
      index(7) = 1        ! << Row indices of the vector term (vt)
      index(8) = 3        ! << Starry Sky
      index(9) = 4        !

!
!*** Creation of matrix information array <info> with 5 vector terms
!
      do j=1,ia2
        do i=1,ia1
	  info(i,j) = 0
        enddo
      enddo

!*** Creation of matrix information entries for the 1st vt - main diagonal
      info(1,1) = 1
      info(1,2) = 0
      info(1,3) = l

!*** Creation of matrix information entries for the 2nd vt - full diagonal
      info(2,1) = 2
      info(2,2) = l
      info(2,3) = 4
      info(2,4) = 2
      info(2,5) = 1

!*** Creation of matrix information entries for the 3rd vt - packed diagonal
      info(3,1) = 3
      info(3,2) = l+4
      info(3,3) = 3
      info(3,4) = 2
      info(3,5) = 0
      info(3,6) = 0

!*** Creation of matrix information entries for the 4th vt - starry sky
      info(4,1) = 6
      info(4,2) = l+4+3
      info(4,3) = 3
      info(4,6) = 3
      info(4,7) = 6

!*** Creation of matrix information entries for the 5th vt - full row
      info(5,1) = 7
      info(5,2) = l+4+3+3
      info(5,3) = 5
      info(5,4) = 2
      info(5,5) = 7

!
!*** Creation of right hand side so that x(i) = i holds.
!
      rhs(1) = 57.d0
      rhs(2) = 17.d0
      rhs(3) =  4.d0
      rhs(4) = 25.d0
      rhs(5) = 39.d0
      rhs(6) = 21.d0
      rhs(7) = 56.d0
      rhs(8) = 57.d0

!
!*** For one processor is lmatbk(1) equal to l.
!
      lmatbk(1) = l

!
!*** The matrix is non-symmetric.
!
      lsym = .true.

!
!*** Relative stopping criterion.
!
      rlin(1) = 1.d-8

!
!*** Parameters controlling LSOLP are set in the array <ilin>.
!
      do i=1,nilin
	ilin(i) = 0
      enddo

      ilin(1) = 200
      ilin(2) = 10000
!*** Remark: if ilin(4) = -1, solution is computed automatically.
!     ilin(4) = -1     
      ilin(5) = 5
      ilin(12)= 6
      ilin(13)= 2
      ilin(15)= 1
      ilin(17)= 1
      ilin(18)= 1

      iconv = 0
      ierr  = 0

      call LSOLP(lmat,lindex,l,nproc,lsym,ia1,info,MAT,x,rhs,index,
     &           rlin,ilin,lmatbk,tids,iconv,ierr)

      if (iconv == 1) then
	print *,' Convergence of LSOLP'
      else
	print *,' Warning: see manual page <lsolp>'
      endif

      if (ierr == 0) then
	print *,' Solution vector x:'
	print *,(x(i),i=1,l)
        print *,' '
	print *,' '
      else
	print *,' ERROR: there is something wrong either with library'
	print *,'        <liblinsol.a> !!!'
        print *,' '
	print *,' '
      endif

!-----END of exam01s--------------------------------------------
      end
