C:::::      ,,,,,MPGATH.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine MPGATH(ROUTIN,swork,svect,lstr,myproc,
     #                  nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      M P G A T H   performs the reduce operation on the         ***
C**                    routine <ROUTIN>.                            ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer            lstr,myproc,nproc,nmsg 
      integer            tids(nproc)
C**                                                                 ***
      character*1        swork(lstr),svect(lstr)                
      external           ROUTIN
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ROUTIN I  C   I in  I  name of the routine to be called            
C--------I------I-----I------------------------------------------------
C swork  I  C*1 I in  I  string work vector for routine <ROUTIN>          
C--------I------I-----I------------------------------------------------
C svect  I  C*1 I i/o I  string vector for routine <ROUTIN>          
C--------I------I-----I------------------------------------------------
C lstr   I  I   I in  I  length of the above mentioned vectors in Bytes 
C--------I------I-----I------------------------------------------------
C myproc I  I   I in  I  process(or) id
C--------I------I-----I------------------------------------------------
C nproc  I  I   I in  I  number of processes (processors)
C--------I------I-----I------------------------------------------------
C tids   I  I   I in  I  set of tids                array : tids(nproc)
C--------I------I-----I------------------------------------------------
C nmsg   I  I   I i/o I  global message counter, must have the same
C        I      I     I  value on all processes (processors) on entry
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           j,a,b,totid,info,msgtp,frpid,mids,midr
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      msgtp=0
      a=1
      b=0
   20 continue
      if (a .lt. nproc) then
        msgtp=msgtp+1
	j=(myproc-b)/(2*a)
	if (a*2*j+b .eq. myproc) then
	  totid=tids(a*(2*j-1)+b)
	  call MPSNDA(totid,nmsg+msgtp,lstr,svect,mids,info)
	  call MPSNDW(totid,nmsg+msgtp,lstr,svect,mids,info)
        endif
	j=(myproc-b+a)/(2*a)
	if (a*(2*j-1)+b .eq. myproc) then
	  frpid=a*2*j+b
	  if (frpid .le. nproc) then
	    call MPRCVA(tids(frpid),nmsg+msgtp,lstr,swork,midr,
     #                  info)
	    call MPRCVW(tids(frpid),nmsg+msgtp,lstr,swork,midr,
     #                  info)
	    call ROUTIN(swork,svect,lstr)
          endif
	endif
	b=b-a
	a=2*a
        goto 20
      endif
 
      nmsg = nmsg+msgtp
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF MPGATH---------------------------------------------------
      e    n    d
