C:::::      ,,,,,MPRCVA...
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine  MPRCVA(frtid,msgtyp,lmsg,msg,mid,err)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      MPRCVA  asynchronous recieve of character*1 array msg      ***
C**              with message type msgtyp from process frtid.       ***
C**              msg may not be used until the call MPRCVW.         ***
C**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      integer           frtid,msgtyp,lmsg,mid,err

      character*1       msg(lmsg)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C frtid  I  I   I in  I  physical processor ID of the sending process
C--------I------I-----I------------------------------------------------
C msgtyp I  I   I in  I  message type
C--------I------I-----I------------------------------------------------
C lmsg   I  I   I in  I  length of the message (in bytes)
C--------I------I-----I------------------------------------------------
C msg    I  C*1 I     I  the message                  array : msg(lmsg)
C--------I------I-----I------------------------------------------------
C mid    I  I   I out I  message id (has to be handed over to MPRCVW)
C--------I------I-----I------------------------------------------------
C err    I  I   I out I  error number
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      include  'mpif.h'
C
C
C**** START OF CALCULATION
C     --------------------
C
C     err=0
      if (msgtyp .ne. -1) then
        if (frtid .ne. -1) then
          call MPI_IRECV(msg,lmsg,MPI_CHARACTER,frtid,msgtyp,
     *                   MPI_COMM_WORLD,mid,err)
        else
          call MPI_IRECV(msg,lmsg,MPI_CHARACTER,MPI_ANY_SOURCE,
     *                   msgtyp,MPI_COMM_WORLD,mid,err)
        endif
      else
        if (frtid .ne. -1) then
          call MPI_IRECV(msg,lmsg,MPI_CHARACTER,frtid,MPI_ANY_TAG,
     *                   MPI_COMM_WORLD,mid,err)
        else
          call MPI_IRECV(msg,lmsg,MPI_CHARACTER,MPI_ANY_SOURCE,
     *                   MPI_ANY_TAG,MPI_COMM_WORLD,mid,err)
        endif
      endif
C
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF MPRCVA----------------------------------------------------
      e    n    d
