C:::::      ,,,,,MPSNDA...
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine  MPSNDA(totid,msgtyp,lmsg,msg,mid,err)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      MPSNDA nonblocking send of integer array <msg>             ***
C**             to the processes/or totid.                          ***
C**             msg may not be reused until the call of MPSNDW.     ***
C**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      integer           totid,msgtyp,lmsg,mid,err

      integer           msg(lmsg)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C totid  I  I   I in  I  physical processor ID of the target process
C--------I------I-----I------------------------------------------------
C msgtyp I  I   I in  I  message type
C--------I------I-----I------------------------------------------------
C lmsg   I  I   I in  I  length of the message (in Bytes)
C--------I------I-----I------------------------------------------------
C msg    I  I   I in  I  the message                  array : msg(lmsg)
C--------I------I-----I------------------------------------------------
C mid    I  I   I out I  message id (has to be handed over to MPSNDW)
C--------I------I-----I------------------------------------------------
C err    I  I   I out I  error number
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      include  'mpif.h'
C
C
C**** START OF CALCULATION
C     --------------------
C
C     err=0
      call MPI_ISEND(msg,lmsg,MPI_INTEGER,totid,msgtyp,
     *               MPI_COMM_WORLD,mid,err)
C
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF MPSNDA----------------------------------------------------
      e    n    d
