C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine CSRLIN(ia,l,info,ia1)
C**                                                                 ***
C**                     in in out in                                ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    C S R L I N   converts csr-matrix-storage format to LINSOL   ***
C**                  format                                         ***
C**                                                                 ***
C**                  (nrow must be equal l)                         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1996 University Karlsruhe                    ***
C**      PROGRAMMER : H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer          ia1,l
      integer          ia(l+1),info(ia1,ia2)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ia     I  I   I in  I  array storing locations of first entry of rows
C--------I------I-----I------------------------------------------------
C info   I  I   I out I  array with matrix-structure-information
C--------I------I-----I------------------------------------------------
C ia1    I  I   I in  I  first dimension of info-array
C--------I------I-----I------------------------------------------------
C l      I  I   I in  I  dimension of matrix
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer   icount,ipos,i
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
       ipos = 0
C
C  convert packed columns
C
       do 10 i=1,l
         icount = ia(i+1)-ia(i)
         info(i,1) = 9
         info(i,2) = ipos
         info(i,3) = icount
         info(i,4) = 0
         info(i,5) = i-1
         info(i,6) = ipos
         info(i,7) = 0
         ipos = ipos + icount
10     continue  

C
C**** END OF CALCULATION
C     ------------------
C
      return
C-----END OF CSRLIN---------------------------------------------------
      end
