C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine distribute_hb_matrix(myproc,nproc,tids,nmsg,
     #           mat,lmat,index,lindex,info,ia1,ilin,l,nvt,ierr,
     #           lmatbk,ptrmbk)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***

C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1996 University Karlsruhe                    ***
C**      PROGRAMMER:    H. Haefner                                  ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer myproc,nproc,nmsg,lmat,lindex,ia1,nvt,ierr,
     #        tids(nproc),index(lindex),info(ia1,ia2),l,
     #        lmatbk(nproc),ptrmbk(nproc+1),ilin(nilin)
      double precision mat(lmat)

C**                                                                 ***
C**      LOCAL VARIABLES :                                          ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           mids,midr,to,from,lvt,i,j
      integer           ibuf(ia2)
      integer           endmat,endind,ivt,iertag

c**********************************************************************
c**    Start of calculation                                         ***
c**********************************************************************

      endmat = 0
      endind = 0
      iertag = 0
      ivt    = 1

      if (myproc == 1) then
        do i=2,nproc
          to = tids(i)
          do j=1,lmatbk(i)
            ibuf(1) = info(ptrmbk(i)+j,3)
            ibuf(2) = info(ptrmbk(i)+j,5)
            call MPSNDA(to,nmsg+i-1,2*iint,ibuf(1),mids,ierr)
            call MPSNDW(to,nmsg+i-1,2*iint,ibuf(1),mids,ierr)
            ibuf(3) = info(ptrmbk(i)+j,2)+1
            ibuf(4) = info(ptrmbk(i)+j,6)+1
            call MPSNDA(to,nmsg+i-1,ibuf(1)*ireal,
     #                  mat(ibuf(3)),mids,ierr)
            call MPSNDW(to,nmsg+i-1,ibuf(1)*ireal,
     #                  mat(ibuf(3)),mids,ierr)
            call MPSNDA(to,nmsg+i-1,ibuf(1)*iint,
     #                  index(ibuf(4)),mids,ierr)
            call MPSNDW(to,nmsg+i-1,ibuf(1)*iint,
     #                  index(ibuf(4)),mids,ierr)
          enddo
        enddo
      else
        from = tids(1)
        do j=1,lmatbk(myproc)
          call MPRCVA(from,nmsg+myproc-1,2*iint,
     #                ibuf(1),midr,ierr)
          call MPRCVW(from,nmsg+myproc-1,2*iint,
     #                ibuf(1),midr,ierr)
          if ((iertag == 0) .and.
     #        (endmat+ibuf(1) > lmat .or. ivt > ia1 .or.
     #         endind+ibuf(1) > lindex)) then
	    iertag = myproc + 900000
          endif
          if (iertag /= 0) then
            call MPRCVA(from,nmsg+myproc-1,ibuf(1)*ireal,
     #                  mat,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(1)*ireal,
     #                  mat,midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(1)*iint,
     #                  index,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(1)*iint,
     #                  index,midr,ierr)
	  else
            call MPRCVA(from,nmsg+myproc-1,ibuf(1)*ireal,
     #                  mat(endmat+1),midr,ierr)
            info(ivt,1) = 9
            info(ivt,2) = endmat
            info(ivt,3) = ibuf(1)
            info(ivt,4) = 0
            info(ivt,5) = ibuf(2)
            info(ivt,6) = endind
            info(ivt,7) = 0
            call MPRCVW(from,nmsg+myproc-1,ibuf(1)*ireal,
     #                  mat(endmat+1),midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(1)*iint,
     #                  index(endind+1),midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(1)*iint,
     #                  index(endind+1),midr,ierr)
	  endif
          endmat = endmat+ibuf(1)
          endind = endind+ibuf(1)
          ivt = ivt+1
        enddo
      endif
      nmsg = nmsg+nproc-1

      if (myproc == 1) then
        nvt = lmatbk(myproc)
      else
        nvt = ivt -1
      endif
      ilin(39) = iertag
      ilin(33) = endmat
      ilin(34) = endind

      r e t u r n
c---- END OF DISTRIBUTE_HB_MATRIX ------------------------------------
      e n d
