C**********************************************************************
C       1         2         3         4         5         6         7 *
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine DISTRIBUTE_RANDOM_MATRIX(myproc,nproc,tids,nmsg,
     #           mat,lmat,index,lindex,info,ia1,ilin,l,nvt,nvtloc,ierr,
     #           lmatbk,ptrmbk)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***

C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1996 University Karlsruhe                    ***
c**      PROGRAMMER:    M.Geisel                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer myproc,nproc,nmsg,lmat,lindex,ia1,nvt,nvtloc,ierr,
     #        tids(nproc),index(lindex),info(ia1,ia2),ilin(nilin),
     #        lmatbk(nproc),ptrmbk(nproc+1),l
      double precision mat(lmat)

C**                                                                 ***
C**      LOCAL VARIABLES :                                          ***
C**      -----------------                                          ***
C**                                                                 ***
      integer iounit,mids,midr,to,from,ityp,iar,iac,lvt,nvec,i,k,
     #        j,indc,indr,adda 
      integer ibuf(ia2),endmat,endind,ivt,iertag
      integer ::  indbuf(l), irbuf(l)
      double precision :: buf(l)

c**********************************************************************
c**    Start of calculation                                         ***
c**********************************************************************


      ivt    = 1
      endmat = 0
      endind = 0
      iertag = 0

      if (myproc == 1) then

	 k = 0
	 ityp = 1
	 nvec = 0

c   begin of main loop(mit ityp = 2 !!!!!)

 100     ityp = ityp+1
	 
	 if (ityp == 10) then
	     ityp = 11
         endif
	 if (ityp > 11) then
	     ityp = 1
         endif
	 k = k+nvec
	 
	 if (k >= nvt) then 
	   goto 999
         endif
	 nvec = 0
	 do i=1,nvt
	   if (info(i,1) == ityp) then 
             nvec = nvec+1
           endif
         enddo
         
	 ibuf(1) = ityp
         ibuf(2) = nvec

c   tell every processor the number of LTSEP.. - Calls
   
         do i=2,nproc
            to = tids(i)
            call MPSNDA(to,nmsg+i,2*iint,ibuf(1),mids,ierr)
            call MPSNDW(to,nmsg+i,2*iint,ibuf(1),mids,ierr)
         enddo
         nmsg = nmsg+nproc-1

c   read nvec-times one of the different storage types,
c   fill buffer with information and call separation-routine

         ibuf(1) = ityp
         ibuf(2) = 0
         ibuf(6) = 0
         ibuf(7) = 0
         do j=1,nvec
            if (ityp.eq.1) then
	       adda    = info(k+j,2)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
              
               ibuf(4) = 0
               ibuf(5) = 0
               call LINSP1(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat)

            elseif (ityp.eq.2) then
	       adda    = info(k+j,2)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP2(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat)

            elseif (ityp.eq.3) then
	       adda    = info(k+j,2)
	       indc    = info(k+j,6)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indc)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP3(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat,
     #                     index,lindex,endind,indbuf)

            elseif (ityp.eq.4) then
	       adda    = info(k+j,2)
	       indc    = info(k+j,6)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indc)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP4(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat,
     #                     index,lindex,endind,indbuf)

            elseif (ityp.eq.5) then
	       adda    = info(k+j,2)
	       indr    = info(k+j,7)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indr)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP5(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat,index,
     #                     lindex,endind,indbuf)

            elseif (ityp.eq.6) then
	       adda    = info(k+j,2)
	       indc    = info(k+j,6)
	       indr    = info(k+j,7)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indc)
	         irbuf(i)  = index(i+indr)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = 0
               ibuf(5) = 0
               call LINSP6(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat,index,
     #                     lindex,endind,indbuf,irbuf)

            elseif (ityp.eq.7) then
	       adda    = info(k+j,2)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP7(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk, nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat)

            elseif (ityp.eq.8) then
	       adda    = info(k+j,2)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP8(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk, nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat)

            elseif (ityp.eq.9) then
	       adda    = info(k+j,2)
	       indc    = info(k+j,6)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indc)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP9(mat,lmat,info,ivt,ia1,tids,
     #                     lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                     ierr,iertag,buf,l,ibuf,endmat,
     #                     index,lindex,endind,indbuf)

            elseif (ityp.eq.11) then
	       adda    = info(k+j,2)
	       indr    = info(k+j,7)
	       do i=1,info(k+j,3)
	         buf(i) = mat(i+adda)
	       enddo
	       do i=1,info(k+j,3)
	         indbuf(i) = index(i+indr)
	       enddo

               ibuf(3) = info(k+j,3)
               ibuf(4) = info(k+j,4)
               ibuf(5) = info(k+j,5)
               call LINSP11(mat,lmat,info,ivt,ia1,tids,
     #                      lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                      ierr,iertag,buf,l,ibuf,endmat,
     #                      index,lindex,endind,indbuf)

            endif
         enddo

         goto 100
    
c   tell the other processors that matrix-reading complete
        
 999     ibuf(1) = 0
 
	 do i=2,nproc
            to = tids(i)
            call MPSNDA(to,nmsg+i,2*iint,ibuf(1),mids,ierr)
            call MPSNDW(to,nmsg+i,2*iint,ibuf(1),mids,ierr)
         enddo
         nmsg = nmsg+nproc-1

      else

c*********************************************************
c   Get matrix in LINSOL-format from processor 1
c*********************************************************


 200     call MPRCVA(from,nmsg+myproc,2*iint,ibuf(1),midr,ierr)
         call MPRCVW(from,nmsg+myproc,2*iint,ibuf(1),midr,ierr)
         nmsg = nmsg+nproc-1
         ityp = ibuf(1)
         nvec = ibuf(2)
         if (ityp == 0) then 

c   matrix reading and separating finished

            goto 500
         else
            do i=1,nvec
               if (ityp.eq.1) then
                  call LINSP1(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat)
               elseif (ityp.eq.2) then
                  call LINSP2(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk, nproc,myproc,
     #                        nmsg,ierr,iertag,buf,l,ibuf,endmat)
               elseif (ityp.eq.3) then
                  call LINSP3(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat,
     #                        index,lindex,endind,indbuf)
               elseif (ityp.eq.4) then
                  call LINSP4(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat,
     #                        index,lindex,endind,indbuf)
               elseif (ityp.eq.5) then
                  call LINSP5(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat,index,
     #                        lindex,endind,indbuf)
               elseif (ityp.eq.6) then
                  call LINSP6(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat,index,
     #                        lindex,endind,indbuf,irbuf)
               elseif (ityp.eq.7) then
                  call LINSP7(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk, nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat)
               elseif (ityp.eq.8) then
                  call LINSP8(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk, nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat)
               elseif (ityp.eq.9) then
                  call LINSP9(mat,lmat,info,ivt,ia1,tids,
     #                        lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                        ierr,iertag,buf,l,ibuf,endmat,
     #                        index,lindex,endind,indbuf)
               elseif (ityp.eq.11) then
                  call LINSP11(mat,lmat,info,ivt,ia1,tids,
     #                         lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                         ierr,iertag,buf,l,ibuf,endmat,
     #                         index,lindex,endind,indbuf)
               endif
            enddo
            goto 200          
         endif
 500     continue
      endif

      nvtloc = ivt-1      
      ilin(39) = iertag
      ilin(33) = endmat
      ilin(34) = endind

      r e t u r n
C-----END OF DISTRIBUTE_RANDOM_MATRIX----------------------------------
      e    n    d
