!***********************************************************************
!        1         2         3         4         5         6         7 *
!***********************************************************************
!**                                                                  ***
!**                                                                  ***
      subroutine XXXXX(l,MAT,lmat,index,lindex,lsym,info,ia1,
     &                 lin,nvt,ierr,myproc,idoku,lout)
!**                                                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    X X X X X   loads a matrix in LINSOL-format                   ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    Copyright (C) YYYY University Karlsruhe                       ***
!**    PROGRAMMER : H. Haefner                                       ***
!**                                                                  ***
!**    This file is part of LINSOL.                                  ***
!**    LINSOL is free software; you can redistribute it and/or       ***
!**    modify it under the terms of the GNU General Public License   ***
!**    as published by the Free Software Foundation; either          ***
!**    version 2 of the License, or (at your option) any later       ***
!**    version.                                                      ***
!**                                                                  ***
!**    LINSOL is distributed in the hope that it will be useful,     ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty   ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.       ***
!**    See the GNU General Public License for more details.          ***
!**                                                                  ***
!**    You should have received a copy of the GNU General Public     ***
!**    License along with LINSOL; if not, write to the Free          ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,       ***
!**    Boston, MA  02111-1307, USA.                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
       implicit none
!**                                                                  *** 
!***********************************************************************
!**                                                                  ***
!**    Formal Parameters :                                           ***
!**                                                                  ***
!***********************************************************************
       include          'const.h'
       integer          l,lmat,lindex,nvt,ia1,lin,ierr,myproc,idoku,lout
       integer          info(ia1,ia2),index(lindex)
       double precision MAT(lmat)
       logical          lsym
!***********************************************************************
!**                                                                  ***
!**    List of Formal Parameters :                                   ***
!**                                                                  ***
!**                                                                  ***
!---------I------I-----I------------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I------------------------------------------------
! l       I int  I in  I dimension of the matrix
!---------I------I-----I------------------------------------------------
! lmat    I int  I in  I number of nonzero elements
!---------I------I-----I------------------------------------------------
! lindex  I int  I in  I number of indices
!---------I------I-----I------------------------------------------------
! nvt     I int  I out I total number of vector-terms
!---------I------I-----I------------------------------------------------
! ia1     I int  I in  I 1.dimension of info-array
!---------I------I-----I------------------------------------------------
! ia2     I int  I in  I 2.dimension of info-array
!---------I------I-----I------------------------------------------------
! info    I int  I out I array with matrix-structure-information
!---------I------I-----I------------------------------------------------
! index   I int  I out I array with indices
!---------I------I-----I------------------------------------------------
! MAT     I real I out I array with nonzero matrix-elements
!---------I------I-----I------------------------------------------------
! lsym    I l    I out I indicates if matrix is symmetrical
!---------I------I-----I------------------------------------------------
! lin     I int  I in  I i/o-unit to read from
!---------I------I-----I------------------------------------------------
! ierr    I int  I out I error-indication
!---------I------I-----I------------------------------------------------
!**                                                                  ***
!**                                                                  ***
!**    Local Variables :                                             ***
!**                                                                  ***
       integer          i,j,ityp
       double precision buf

!***********************************************************************
!**                                                                  ***
!**    List of Local Variables :                                     ***
!**                                                                  ***
!**                                                                  ***
!---------I------I-----I------------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I------------------------------------------------
!         I int  I in  I 
!---------I------I-----I------------------------------------------------
!         I int  I in  I
!---------I------I-----I------------------------------------------------
!***********************************************************************


!***********************************************************************
!**    Start of Calculation                                          ***
!***********************************************************************

!**                                                                  
!**    init local variables
!**
       ptrmat=0
       ptrind=0
       infpos = 1
       ierr=0

!***********************************************************************
!**    End of Calculation                                            ***
!***********************************************************************

 1000  format(' xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')
 1001  format(' X      L I N I N - Version 1.0 (22.01.96)           X')
 1002  format(' xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')
 1003  format(' ERROR : set ia1 to ',i4)
 1004  format(' ERROR : set lmat to ',i4)
 1005  format(' ERROR : set lindex to ',i4)

       r e t u r n
!-----END OF XXXXX----------------------------------------------------
       e    n    d
