c***********************************************************************
c        1         2         3         4         5         6         7 *
c***********************************************************************
c**                                                                  ***
c**                                                                  ***
      subroutine INIT_LINSOL_PARAM(lmatbk,ptrmbk,llocal,l,nproc)
c**                                                                  ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
c**    INIT_LINSOL_PARAM  initializes parameters for LINSOL on all   ***
c**                       processors                                 ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
c**    Copyright (C) 1996 University Karlsruhe                       ***
c**    PROGRAMMER : H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
      implicit none
c**                                                                  *** 
c***********************************************************************
c**                                                                  ***
c**    Formal Parameters :                                           ***
c**                                                                  ***
c***********************************************************************
      integer          llocal,l,nproc
      integer          lmatbk(nproc),ptrmbk(nproc+1)

c***********************************************************************
c**                                                                  ***
c**    List of Formal Parameters :                                   ***
c**                                                                  ***
c**                                                                  ***
c---------I------I-----I------------------------------------------------
c NAME    I TYPE I I/O I MEANING
c---------I------I-----I------------------------------------------------
c llocal  I int  I out I dimension of the distributed matrices
c---------I------I-----I------------------------------------------------
c   l     I int  I in  I dimension of the matrix
c---------I------I-----I------------------------------------------------
c**                                                                  ***
c**                                                                  ***
c**    Local Variables :                                             ***
c**                                                                  ***
       integer  i,nr,diff,dist,middle


c***********************************************************************
c**    Start of Calculation                                          ***
c***********************************************************************

      if (nproc .gt. 1) then
        nr = l / nproc
        diff = mod(l,nproc)
        do i=1,nproc
          lmatbk(i) = nr
        enddo
        middle = nproc/2
        dist = 0
        if (diff.eq.0) goto 27
	lmatbk(middle) = lmatbk(middle) + 1
  26    diff = diff-1
        dist = dist+1
        if (diff.eq.0) goto 27
        lmatbk(middle+dist) = lmatbk(middle+dist) + 1
        diff = diff-1
        if (diff.eq.0) goto 27
        lmatbk(middle-dist) = lmatbk(middle-dist) + 1
        goto 26
 27     continue
        ptrmbk(1) = 0
        do i=2,nproc+1
          ptrmbk(i) = ptrmbk(i-1) + lmatbk(i-1)
        enddo

        llocal = lmatbk(middle)
      else
	llocal    = l
	lmatbk(1) = l
	ptrmbk(1) = 0
	ptrmbk(2) = l
      endif

c***********************************************************************
c**    End of Calculation                                            ***
c***********************************************************************

       r e t u r n
C---- END OF INIT_LINSOL_PARAM -----------------------------------------
       e    n    d
