C:::::      ,,,,,LINASX.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINASX(mat,x1,b1,l,nvt,lmat,lindex,ia1,info,index)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N A S X   computes a matrix-vector-multiplication      ***
C**                    with thw symmetric matrix MAT                ***
C**                    b1 = b1 + MAT * x1                           ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1996 University Karlsruhe                    ***
C**      PROGRAMMER : H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declares explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           nvt, lmat, lindex, ia1
      integer           info(ia1,ia2), index(lindex)
      integer           l
      double precision  b1(l), x1(l), mat(lmat)
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i,k,iac,iar,jc,jr
      integer           typ,adda,lvt,indc,indr
      double precision  zero
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0.)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
C**                                                                 ***
      do   100   k = 1,nvt
C**                                                                 ***
         typ   =info(k,1)
         adda  =info(k,2)
         lvt   =info(k,3)
         iac   =info(k,4)
         iar   =info(k,5)
         indc  =info(k,6)
         indr  =info(k,7)
C**                                                                 ***
         if (typ .eq. 1) then
            do   110   i = 1,lvt
               b1(i+iar) = b1(i+iar) + mat(i+adda) * x1(i+iac)
  110       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 2) then
            do   120   i = 1,lvt
               b1(i+iar) = b1(i+iar) + mat(i+adda) * x1(i+iac)
  120       continue
            do   121   i = 1,lvt
               b1(i+iac) = b1(i+iac) + mat(i+adda) * x1(i+iar)
  121       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 3) then
         include "norec.h"
            do   130   i = 1,lvt
	       jc = index(i+indc)
               b1(jc+iar) = b1(jc+iar) + mat(i+adda) * x1(jc+iac)
  130       continue
         include "norec.h"
	    do   131   i = 1,lvt
	       jc = index(i+indc)
               b1(jc+iac) = b1(jc+iac) + mat(i+adda) * x1(jc+iar)
  131       continue
            goto 100
         endif
C**                                                                 ***
	 if (typ .eq. 4) then
           do   140   i = 1,lvt
             jc = index(i+indc)
             b1(i+iar) = b1(i+iar) + mat(i+adda) * x1(jc)
 140       continue
           do   141   i = 1,lvt
             jc = index(i+indc)
             b1(jc) = b1(jc) + mat(i+adda) * x1(i+iar)
 141       continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 5) then
            do   150   i = 1,lvt
	       jr = index(i+indr)
               b1(jr) = b1(jr) + mat(i+adda) * x1(i+iac)
  150       continue
            do   151   i = 1,lvt
	       jr = index(i+indr)
               b1(i+iac) = b1(i+iac) + mat(i+adda) * x1(jr)
  151       continue
            goto 100
         endif
C**
         if (typ .eq. 6) then
            do   160   i = 1,lvt
	       jc = index(i+indc)
	       jr = index(i+indr)
               b1(jr) = b1(jr)+mat(i+adda)*x1(jc)
  160       continue
            do   161   i = 1,lvt
	       jc = index(i+indc)
	       jr = index(i+indr)
               b1(jc) = b1(jc)+mat(i+adda)*x1(jr)
  161       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 7) then
	    do 171 i = 1,lvt
	      b1(iar+1) = b1(iar+1) + mat(i+adda)*x1(iac+i)
  171       continue
	    do 172 i = 1,lvt
	      b1(iac+i) = b1(iac+i) + mat(i+adda)*x1(iar+1)
  172       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 8) then
	    do 181 i = 1,lvt
	      b1(iar+i) = b1(iar+i) + mat(i+adda)*x1(iac+1)
  181       continue
	    do 182 i = 1,lvt
	      b1(iac+1) = b1(iac+1) + mat(i+adda)*x1(iar+i)
  182       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 9) then
	    do 191 i = 1,lvt
	      jc = index(i+indc)
	      b1(iar+1) = b1(iar+1) + mat(i+adda)*x1(jc)
  191       continue
            include "norec.h"
	    do 192 i = 1,lvt
	      jc = index(i+indc)
	      b1(jc) = b1(jc) + mat(i+adda)*x1(iar+1)
  192       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 11) then
            include "norec.h"
	    do 211 i = 1,lvt
	      jr = index(i+indr)
	      b1(jr) = b1(jr) + mat(i+adda)*x1(iac+1)
  211       continue
	    do 212 i = 1,lvt
	      jr = index(i+indr)
	      b1(iac+1) = b1(iac+1) + mat(i+adda)*x1(jr)
  212       continue
            goto 100
         endif
C**                                                                 ***
 100  continue
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LINASX----------------------------------------------------
      e    n    d
