C:::::      ,,,,,LINAX.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINAX(mat,x,b,l,nvt,lmat,lindex,ia1,info,index)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N A X     is the kernel routine for the matrix-        ***
C**                    vector-multiplication:                       ***
C**                    b = b + MAT * x .                            ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1996 University Karlsruhe                    ***
C**      PROGRAMMER :  H. Haefner                                   ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           nvt, lmat, lindex, ia1
      integer           info(ia1,ia2), index(lindex)
      integer           l
      double precision  b(l), x(l), mat(lmat)
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i, k, jc, jr
      integer           typ,adda,lvt,iac,iar,iac1,iar1,indc,indr
      double precision  zero
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0.)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      do 100 k=1,nvt
C**                                                                 ***
         typ   =info(k,1)
         adda  =info(k,2)
         lvt   =info(k,3)
         iac   =info(k,4)
         iar   =info(k,5)
         indc  =info(k,6)
         indr  =info(k,7)
C**                                                                 ***
         if ((typ .eq. 2).or.(typ .eq. 1)) then
            do   120   i = 1,lvt
              b(i+iar) = b(i+iar) + mat(i+adda) * x(i+iac)
  120       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 3) then
         include "norec.h"
            do   130   i = 1,lvt
              jc = index(i+indc)
              b(jc+iar) = b(jc+iar) + mat(i+adda) * x(jc+iac)
  130       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 4) then
            do   140   i = 1,lvt
              jc = index(i+indc)
              b(i+iar) = b(i+iar) + mat(i+adda) * x(jc)
  140       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 5) then
            do   150   i = 1,lvt
	      jr = index(i+indr)
              b(jr) = b(jr) + mat(i+adda)*x(i+iac)
  150       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 6) then
            do   160   i = 1,lvt
              jr = index(i+indr)
	      jc = index(i+indc)
              b(jr)=b(jr) + mat(i+adda)*x(jc)
  160       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 7) then
	    do 170 i = 1,lvt
	      b(iar+1) = b(iar+1) + mat(i+adda)*x(iac+i) 
  170       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 8) then
	    do 180 i = 1,lvt
	      b(iar+i) = b(iar+i) + mat(i+adda)*x(iac+1)
  180       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 9) then
	    do 190 i = 1,lvt
	      jc = index(i+indc)
	      b(iar+1) = b(iar+1) + mat(i+adda)*x(jc) 
  190       continue
            goto 100
         endif
C**                                                                 ***
         if (typ .eq. 11) then
         include "norec.h"
	    do 200 i = 1,lvt
	      jr = index(i+indr)
	      b(jr) = b(jr) + mat(i+adda)*x(iac+1)
  200       continue
            goto 100
         endif
C**                                                                 ***
 100  continue
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LINAX----------------------------------------------------
      e    n    d
