C:::::      ,,,,,LINJMP.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINJMP(jump,info,ia1,nvt,index,lindex,lsym,ptrmbk,
     *                  myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N J M P   sets the jump vector for a distributed       ***
C**                    matrix.                                      ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1998 University Karlsruhe                    ***
C**      PROGRAMMER :     H. Haefner                                ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           ia1,lindex,myproc,nproc,nmsg,nvt
      integer           info(ia1,ia2),tids(nproc),jump(maxnpe)
      integer           index(lindex),ptrmbk(nproc+1)
      logical           lsym
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           iac,indc,ityp,iwork,ione,njump,s
      integer           iw(2*nproc),i,j,k
C**                                                                 ***
      iwork = nproc+1
      ione  = 1
C**                                                                 ***
      do 100 i = 1,nproc
	iw(i) = 0
	j = myproc-i+1
	if (j .lt. 1) j = j+nproc
	do k=1,nvt
	  ityp = info(k,1)
	  iac  = info(k,4)
	  indc = info(k,6)
          if (ityp == 1 .or. ityp == 2 .or.
     *        ityp == 7 .or. ityp == 8) then
	    if (iac >= ptrmbk(j) .and. iac < ptrmbk(j+1)) then
	      iw(i) = 1
	      exit
	    endif
	  endif
          if (ityp == 5 .or. ityp == 11) then
	    if (iac >= ptrmbk(j) .and. iac < ptrmbk(j+1)) then
	      iw(i) = 1
	      exit
	    endif
	  endif
          if (ityp == 3) then
	    if (iac+index(indc+1) > ptrmbk(j) .and.
     *          iac+index(indc+1) <= ptrmbk(j+1)) then
	      iw(i) = 1
	      exit
	    endif
	  endif
          if (ityp == 4 .or. ityp == 6 .or. ityp == 9) then
	    if (index(indc+1) > ptrmbk(j) .and.
     *          index(indc+1) <= ptrmbk(j+1)) then
	      iw(i) = 1
	      exit
	    endif
	  endif
	enddo
  100 continue
C**                                                                 ***
      call LL4INM(ione,nproc,ione,iw(1),jump,iw(iwork),myproc,
     &            nproc,tids,nmsg)
C**                                                                 ***
      if (lsym) then
	j = 0
	do 110 i=2,(nproc+1)/2
	  jump(i) = max(jump(i),jump(nproc-j))
	  jump(nproc-j) = jump(i)
	  j = j+1
  110   continue
      endif

      s=1
      njump=1
      include "norec.h"
      do 202 i=2,nproc
        if (jump(i) .eq. 1) then
	  njump=njump+1
	  jump(njump-1)=s
          s=1
        else
          s=s+1
        endif
  202 continue

      jump(njump)=s

      do 203 i=njump+1,maxnpe
        jump(i)=0
  203 continue

C**                                                                 ***

      R E T U R N
C-----END OF LINJMP----------------------------------------------------
      E    N    D
