C:::::      ,,,,,LINRSA.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINRSA(l,lmat,mat,lindex,index,prec,ia1,info,nvt)
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N R S A   computes the row sum of the nonsymmetrical   ***
C**                    matrix (part) mat on 1 processor.            ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C)1996  University Karlsruhe                    ***
C**      PROGRAMMERS : H.Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           lmat,l,lindex,ia1,nvt
      double precision  prec(l),mat(lmat)
      integer           info(ia1,ia2),index(lindex)
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i,k,jc,jr
      integer           typ,adda,lvt,iar,indc,indr
      double precision  zero,one
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0., one = 1.)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      do 10 i = 1,l
         prec(i) = zero
   10 continue
C**                                                                 ***
      do 100 k = 1,nvt
C**                                                                 ***
         typ   =info(k,1)
         adda  =info(k,2)
         lvt   =info(k,3)
         iar   =info(k,5)
         indc  =info(k,6)
         indr  =info(k,7)
C**                                                                 ***
         if ((typ .eq. 1) .or. (typ .eq. 2)) then
            do 120 i = 1,lvt
               prec(i+iar) = prec(i+iar) + abs(mat(i+adda))
  120       continue
         endif
C**                                                                 ***
         if (typ .eq. 3) then
      include "norec.h"
            do 130 i = 1,lvt
	       jc = index(i+indc)
               prec(jc+iar) = prec(jc+iar) + abs(mat(i+adda))
  130       continue
         endif
C**                                                                 ***
         if (typ .eq. 4) then
            do 140 i = 1,lvt
               prec(i+iar) = prec(i+iar) + abs(mat(i+adda))
  140       continue
         endif
C**                                                                 ***
         if (typ .eq. 5) then
      include "norec.h"
            do 150 i = 1,lvt
	       jr = index(i+indr)
               prec(jr) = prec(jr) + abs(mat(i+adda))
  150       continue
         endif
C**                                                                 ***
         if ((typ .eq. 6) .or. (typ .eq. 11)) then
      include "norec.h"
            do 160 i = 1,lvt
	       jr = index(i+indr)
               prec(jr) = prec(jr) + abs(mat(i+adda))
  160       continue
         endif
C**                                                                 ***
         if ((typ .eq. 7) .or. (typ .eq. 9)) then
            do 170 i = 1,lvt
               prec(iar+1) = prec(iar+1) + abs(mat(i+adda))
  170       continue
         endif
C**                                                                 ***
         if (typ .eq. 8) then
            do 180 i = 1,lvt
                prec(iar+i) = prec(iar+i) + abs(mat(i+adda))
  180       continue
         endif
 100  continue

C**                                                                 ***
C**                                                                 ***
C**** END OF CALCULATION                                            ***
C**   ------------------                                            ***
C**                                                                 ***
      r e t u r n
C-----END OF LINRSA----------------------------------------------------
      e    n    d
