C:::::      ,,,,,LINRST.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINRST(l,lmat,mat,prec,lindex,index,ia1,info,nvt)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 5 R S T   computes the row sum                         ***
C**                    of the symmetrical matrix part on            ***
C**                    processor 1 (matrix mat_transposed).         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) UNIVERSITAET KARLSRUHE RECHENZENTRUM  1996       ***
C**      PROGRAMMER : H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           l,lmat,lindex,nvt,ia1
      integer           info(ia1,ia2),index(lindex)
      double precision  prec(l),mat(lmat)
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
C
      integer           i,k,jc
      integer           typ,adda,lvt,iac,indc
      double precision  zero
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0.)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      do 100 k=1,nvt
C**                                                                 ***
        typ   =info(k,1)
        adda  =info(k,2)
        lvt   =info(k,3)
        iac   =info(k,4)
        indc  =info(k,6)
C**                                                                 ***
        if ((typ.eq.2).or.(typ.eq.5).or.(typ .eq. 7)) then
          do 120 i = 1,lvt
            prec(i+iac) = prec(i+iac) + abs(mat(i+adda))
  120     continue 
          goto 100
        endif
C**                                                                 ***
        if (typ.eq.3) then
      include "norec.h"
          do 130 i = 1,lvt
	    jc = index(i+indc)
            prec(jc+iac) = prec(jc+iac) + abs(mat(i+adda))
  130     continue
          goto 100
        endif
C**                                                                 ***
        if ((typ.eq.4).or.(typ.eq.6).or.(typ.eq.9)) then
      include "norec.h"
          do 140 i = 1,lvt
	    jc = index(i+indc)
            prec(jc) = prec(jc) + abs(mat(i+adda))
  140     continue
          goto 100
        endif
C**                                                                 ***
        if ((typ.eq.8).or.(typ.eq.11)) then
	  do 180 i = 1,lvt
	    prec(iac+1) = prec(iac+1) + abs(mat(i+adda))
  180     continue
          goto 100
        endif
 100  continue
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LINRST----------------------------------------------------
      e    n    d
