C:::::      ,,,,,LINSP1.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINSP1(mat,lmat,info,ivt,ia1,tids,lmatbk,ptrmbk,nproc,
     #                  myproc,nmsg,ierr,iertag,buf,l,ibuf,endmat)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N S P 1   separates main diagonal into <nproc>         ***
C**                    parts and sends part i to process(or) i.     ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1995 University Karlsruhe                    ***
c**      PROGRAMMER:    H. Haefner                                  ***
C**                     M. Peter                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***

      integer    lmat,ia1,ivt,nproc,myproc,nmsg,ierr,l,endmat,iertag
      integer    info(ia1,ia2),tids(nproc),lmatbk(nproc),
     #           ptrmbk(nproc+1),ibuf(ia2)
C**                                                                 ***
      double precision   mat(lmat),buf(l)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays mat(lmat),info(ia1,ia2),tids(nproc),lmatbk(nproc),     ***
C**          ptrmbk(nproc+1) and                                    ***
C**   Variables lmat,ia1,nproc,myproc,nmsg,ierr,l:                  ***
C**              see Manual-Pages <linsol>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C buf    I  R   I in  I  buffer for one vector term    array: buf(l)
C--------I------I-----I------------------------------------------------
C ibuf   I  I   I in  I  buffer for one entry in info  array: ibuf(ia2)
C--------I------I-----I------------------------------------------------
C endmat I  I   I in  I  pointer to the end of the local array MAT
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C iertag I  I   I i/o I  iertag /= 0 ==> no correct matrix creation
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,mids,midr,from,to,s_addr
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      if (myproc .eq. 1) then
        ibuf(3) = lmatbk(1)

        if ((iertag == 0) .and.
     #      (ivt > ia1 .or. endmat+ibuf(3) > lmat)) then
          iertag = myproc + 100000
        endif

        if (iertag == 0) then
          do i=1,ia2
            info(ivt,i) = ibuf(i)
          enddo
          info(ivt,2) = endmat
          do i=1,info(ivt,3)
            mat(endmat+i) = buf(i)
          enddo
        endif
        endmat = endmat+lmatbk(1)
        ivt = ivt+1
        do i=2,nproc
          to = tids(i)
          ibuf(3) = lmatbk(i)
          ibuf(4) = ptrmbk(i)
          ibuf(5) = ptrmbk(i)
          s_addr = ptrmbk(i)+1
          call MPSNDA(to,nmsg+i-1,7*iint,ibuf(1),mids,ierr)
          call MPSNDW(to,nmsg+i-1,7*iint,ibuf(1),mids,ierr)
          call MPSNDA(to,nmsg+i-1,ibuf(3)*ireal,
     #                buf(s_addr),mids,ierr)
          call MPSNDW(to,nmsg+i-1,ibuf(3)*ireal,
     #                buf(s_addr),mids,ierr)
        enddo
      else
        from = tids(1)
        call MPRCVA(from,nmsg+myproc-1,7*iint,ibuf(1),midr,ierr)
        call MPRCVW(from,nmsg+myproc-1,7*iint,ibuf(1),midr,ierr)

        if ((iertag == 0) .and.
     #      (ivt > ia1 .or. endmat+ibuf(3) > lmat)) then
          iertag = myproc + 100000
        endif

        if (iertag /= 0) then
          call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                mat,midr,ierr)
          call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                mat,midr,ierr)
	else
          call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                mat(endmat+1),midr,ierr)
          do i=1,ia2
            info(ivt,i) = ibuf(i)
          enddo
          info(ivt,2) = endmat
          call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                mat(endmat+1),midr,ierr)
	endif
        endmat = endmat+ibuf(3)
        ivt = ivt+1
      endif

      nmsg = nmsg+nproc-1
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LINSP1---------------------------------------------------
      e    n    d
