C:::::      ,,,,,LINSP6.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINSP6(mat,lmat,info,ivt,ia1,tid,lmatbk,ptrmbk,nproc,
     #                  myproc,nmsg,ierr,iertag,buf,l,ibuf,endmat,
     #                  index,lindex,endind,icbuf,irbuf)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N S P 6   separates "starry sky" patterns into <nproc> ***
C**                    parts and sends part i to process(or) i.     ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1995 University Karlsruhe                    ***
c**      PROGRAMMER:    H. Haefner                                  ***
C**                     M. Peter                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    lmat,ia1,ivt,nproc,myproc,nmsg,ierr,l,
     #           endmat,endind,lindex,iertag
      integer    info(ia1,ia2),tid(nproc),lmatbk(nproc),ibuf(ia2),
     #           ptrmbk(nproc+1),index(lindex),icbuf(l),irbuf(l)
C**                                                                 ***
      double precision   mat(lmat),buf(l)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays mat(lmat),info(ia1,ia2),tid(nproc),lmatbk(nproc),      ***
C**          ptrmbk(nproc+1) and                                      ***
C**   Variables lmat,ia1,ia2,nproc,myproc,nmsg,ierr,l:              ***
C**              see Manual-Pages <linsol>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C buf    I  R   I in  I  buffer for one vector term    array: buf(l)
C--------I------I-----I------------------------------------------------
C ibuf   I  I   I in  I  buffer for one entry in info  array: ibuf(ia2)
C--------I------I-----I------------------------------------------------
C icbuf  I  I   I in  I  buffer with column-indices for one vector term
C--------I------I-----I------------------------------------------------
C irbuf  I  I   I in  I  buffer with row-indices for one vector term
C--------I------I-----I------------------------------------------------
C endmat I  I   I in  I  pointer to the end of the local array MAT
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C endind I  I   I in  I  pointer to the end of the local array index
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C iertag I  I   I i/o I  iertag /= 0 ==> no correct matrix creation
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,j,mids,midr,from,to,glvt,row,nr
      integer :: cbuf(l), rbuf(l)
C**                                                                 ***
      double precision :: matbuf(l)
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      if (myproc .eq. 1) then
        glvt = ibuf(3)
        do 10 i=1,nproc
          nr = 0
          do j=1,glvt
            row = irbuf(j)
            if ((row.gt.ptrmbk(i)).and.(row.le.ptrmbk(i+1))) then
              nr = nr + 1
              cbuf(nr) = icbuf(j)
              rbuf(nr) = row
              matbuf(nr) = buf(j)
            endif
          enddo
          ibuf(3) = nr
          if (i == 1) then
            if ((iertag == 0) .and.
     &          (ivt > ia1 .or. endmat+nr > lmat .or.
     &           endind+2*nr > lindex)) then
	      iertag = myproc + 600000
            endif
            if (iertag == 0) then
              info(ivt,1) = ibuf(1)
              info(ivt,2) = endmat
              info(ivt,3) = nr
              info(ivt,4) = ibuf(4)
              info(ivt,5) = ibuf(5)
              info(ivt,6) = endind
              info(ivt,7) = endind + nr
              do j=1,nr
                mat(endmat+j) = matbuf(j)
                index(endind+j) = cbuf(j)
                index(endind+nr+j) = rbuf(j)
              enddo
            endif
            endmat = endmat+nr
            endind = endind+2*nr
            ivt = ivt+1
          else
            to = tid(i)
            call MPSNDA(to,nmsg+i-1,ia2*iint,ibuf(1),mids,ierr)
            call MPSNDW(to,nmsg+i-1,ia2*iint,ibuf(1),mids,ierr)
            if (nr > 0) then
              call MPSNDA(to,nmsg+i-1,ibuf(3)*ireal,matbuf(1),
     #                    mids,ierr)
              call MPSNDW(to,nmsg+i-1,ibuf(3)*ireal,matbuf(1),
     #                    mids,ierr)
              call MPSNDA(to,nmsg+i-1,ibuf(3)*iint,cbuf(1),
     #                    mids,ierr)
              call MPSNDW(to,nmsg+i-1,ibuf(3)*iint,cbuf(1),
     #                    mids,ierr)
              call MPSNDA(to,nmsg+i-1,ibuf(3)*iint,rbuf(1),
     #                    mids,ierr)
              call MPSNDW(to,nmsg+i-1,ibuf(3)*iint,rbuf(1),
     #                    mids,ierr)
            endif
          endif
 10     continue
      else
        from = tid(1)
        call MPRCVA(from,nmsg+myproc-1,ia2*iint,ibuf(1),midr,ierr)
        call MPRCVW(from,nmsg+myproc-1,ia2*iint,ibuf(1),midr,ierr)
        if (ibuf(3) > 0) then
          if ((iertag == 0) .and.
     &        (ivt > ia1 .or. endmat+ibuf(3) > lmat .or.
     &         endind+2*ibuf(3) > lindex)) then
	    iertag = myproc + 600000
          endif
          if (iertag /= 0) then
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat,midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index,midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index,midr,ierr)
          else
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat(endmat+1),midr,ierr)
            do i=1,ia2
              info(ivt,i) = ibuf(i)
            enddo
            info(ivt,2) = endmat
            info(ivt,6) = endind
            info(ivt,7) = endind + ibuf(3)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat(endmat+1),midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index(endind+1),midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index(endind+1),midr,ierr)
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index(endind+ibuf(3)+1),midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*iint,
     #                  index(endind+ibuf(3)+1),midr,ierr)
          endif
          endmat = endmat + ibuf(3)
          endind = endind + 2*ibuf(3)
          ivt = ivt + 1
        endif
      endif

      nmsg = nmsg+nproc-1
C
C**** END OF CALCULATION
C     ------------------
      r e t u r n
C-----END OF LINSP6---------------------------------------------------
      e    n    d
