C:::::      ,,,,,LINSP7.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LINSP7(mat,lmat,info,ivt,ia1,tid,lmatbk,ptrmbk,nproc,
     #                  myproc,nmsg,ierr,iertag,buf,l,ibuf,endmat)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L I N S P 7   no separation for full-row storage type      ***
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1995 University Karlsruhe                    ***
c**      PROGRAMMER:    H. Haefner                                  ***
C**                     M. Peter                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    lmat,ia1,ivt,nproc,myproc,nmsg,ierr,l,endmat,iertag
      integer    info(ia1,ia2),tid(nproc),lmatbk(nproc),
     #           ptrmbk(nproc+1),ibuf(ia2)
C**                                                                 ***
      double precision   mat(lmat),buf(l)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays mat(lmat),info(ia1,ia2),tid(nproc),lmatbk(nproc),      ***
C**          ptrmbk(nproc+1) and                                      ***
C**   Variables lmat,ia1,ia2,nproc,myproc,nmsg,ierr,l:              ***
C**              see Manual-Pages <linsol>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C buf    I  R   I in  I  buffer for one vector term    array: buf(l)
C--------I------I-----I------------------------------------------------
C ibuf   I  I   I in  I  buffer for one entry in info  array: ibuf(ia2)
C--------I------I-----I------------------------------------------------
C endmat I  I   I in  I  pointer to the end of the local array MAT
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C iertag I  I   I i/o I  iertag /= 0 ==> no correct matrix creation
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,j,mids,midr,to,from,iar
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      if (myproc == 1) then
        do i=2,nproc
          to = tid(i)
          call MPSNDA(to,nmsg+i-1,ia2*iint,ibuf(1),mids,ierr)
          call MPSNDW(to,nmsg+i-1,ia2*iint,ibuf(1),mids,ierr)
        enddo
        iar = ibuf(5)
        i = 1
 20     if (iar >= ptrmbk(i+1)) then
          i = i+1
          goto 20
        endif
        if (i == 1) then
          if ((iertag == 0) .and.
     #        (endmat+ibuf(3) > lmat .or. ivt > ia1)) then
               iertag = myproc + 700000
          endif
          if (iertag == 0) then
            do j=1,ia2
              info(ivt,j) = ibuf(j)
            enddo
            info(ivt,2) = endmat
            do j=1,ibuf(3)
              mat(endmat+j) = buf(j)
            enddo
          endif
          endmat = endmat+ibuf(3)
          ivt = ivt+1
        else
          to = tid(i)
          call MPSNDA(to,nmsg+i-1,ibuf(3)*ireal,
     #                buf(1),mids,ierr)
          call MPSNDW(to,nmsg+i-1,ibuf(3)*ireal,
     #                buf(1),mids,ierr)
        endif
      else
        from = tid(1)
        call MPRCVA(from,nmsg+myproc-1,ia2*iint,ibuf(1),midr,ierr)
        call MPRCVW(from,nmsg+myproc-1,ia2*iint,ibuf(1),midr,ierr)
        iar = ibuf(5)
        if ((iar >= ptrmbk(myproc)).and.
     #      (iar < ptrmbk(myproc+1))) then
          if ((iertag == 0) .and.
     #        (endmat+ibuf(3) > lmat .or. ivt > ia1)) then
            iertag = myproc + 700000
          endif
          if (iertag /= 0) then
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat,midr,ierr)
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat,midr,ierr)
          else
            call MPRCVA(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat(endmat+1),midr,ierr)
            do i=1,ia2
              info(ivt,i) = ibuf(i)
            enddo
            info(ivt,2) = endmat
            call MPRCVW(from,nmsg+myproc-1,ibuf(3)*ireal,
     #                  mat(endmat+1),midr,ierr)
          endif
          endmat = endmat+ibuf(3)
          ivt = ivt+1
        endif
      endif

      nmsg = nmsg+nproc-1

C
C**** END OF CALCULATION
C     ------------------
      r e t u r n
C-----END OF LINSP7---------------------------------------------------
      e    n    d
