C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine MSRLIN(l,lmat,ja,info,ia1,ia2,index,lindex)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    M S R L I N   converts msr-matrix-storage format to linsol   ***
C**                  format                                         ***
C**                  IMPORTANT : ia1 = l+1, lindex = lmat-l         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1994 University Karlsruhe                    ***
C**      PROGRAMMER : M.Peter                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer l,lmat,ia1,ia2,lindex
      integer ja(lmat),info(ia1,ia2),index(lindex)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ja     I  I   I in  I  array with pointers
C--------I------I-----I------------------------------------------------
C info   I  I   I out I  array with matrix-structure-information
C--------I------I-----I------------------------------------------------
C index  I  I   I out I  array with indizes
C--------I------I-----I------------------------------------------------
C lindex I  I   I in  I  size of index-array
C--------I------I-----I------------------------------------------------
C ia1    I  I   I in  I  1. dimension of info-array
C--------I------I-----I------------------------------------------------
C ia2    I  I   I in  I  ia2 = 7
C--------I------I-----I------------------------------------------------
C l      I  I   I in  I  matrix-dimension
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer iptr,jptr,icount,ipos,i,j
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
C
C  convert main diagonal
C
       icount = l
       ipos = 0
       info(1,1) = 1
       info(1,2) = ipos
       info(1,3) = icount
       info(1,4) = 0
       info(1,5) = 0
       info(1,6) = 0
       info(1,7) = 0
       ipos = ipos + icount
       iptr = 0
       jptr = l + 1 
C
C  convert packed rows
C
       do 10 i=2,l+1
         icount = ja(i)-ja(i-1)
         info(i,1) = 9
         info(i,2) = ipos
         info(i,3) = icount
         info(i,4) = 0
         info(i,5) = i-2
         info(i,6) = iptr
         info(i,7) = 0
         ipos = ipos + icount
         do 20 j = 1,icount
           index(iptr+j) = ja(jptr+j)
20       continue
         iptr = iptr + icount
         jptr = jptr + icount
10     continue  
C
C**** END OF CALCULATION
C     ------------------
C
      return
C-----END OF MSRLIN---------------------------------------------------
      end
