!:::::      ,,,,,RANDOM.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 *** 
!**                                                                 *** 
      subroutine RANDOM(lmat,mat,lindex,index,ia1,nvt,
     &                  lout,info,l,lsym,ilin,inrannam,ierr)
!**                                                                 *** 
!**                                                                 *** 
!**********************************************************************
!**                                                                 ***
!**   RANDOM : Using vector terms described in the LINSOL matrix    ***
!**           storing scheme a matrix of any order L can be built.  ***
!**           All types of vector terms can be used, the structures *** 
!**           of vector terms belonging to one type can be varied   ***
!**           within a predefined scheme.                           ***
!**           All built vector terms are be checked.                ***
!**           The built matrix can be used in a linear system       ***
!**           solved by LINSOL.                                     ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   Copyright (C) 1995 University Karlsruhe                       ***
!**   PROGRAMMER: H.Haefner   F.Seegmueller   M.Geisel              ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!********************************************************************** 
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
!**********************************************************************
      USE constants

      implicit none

!**********************************************************************
!**                                                                 ***
!**   LIST OF PARAMETERS                                            ***
!**   ------------------                                            ***
!**                                                                 ***
!**   (see manual pages <linsol> and manual pages <exam10>          *** 
!**                                                                 ***
!**   FORMAL PARAMETERS                                             ***  
!**                                                                 ***
      integer lmat,lindex,ia1,nvt,lout,l,ilin(nilin),ierr
      integer, pointer :: index(:),info(:,:)
      double precision, pointer :: mat(:),prec(:)
      character*72 inrannam
      logical lsym       
!**                                                                 *** 
!**   LOCAL PARAMETERS                                              ***
!**                                                                 ***
      integer i,j,k,nvt1,ierr2,
     &        laenge,anzahl,pos,posidx,length,
     &        row,column,ir,ic,
     &        llout,typ,vtstep,vtband,dstride,iounit 
      double precision vtwert,
     &                 z1,z2,s,
     &                 vt10,vt20,vt30,vt40,vt50,vt60,vt70,vt80,
     &                 vt90,vt100,
     &                 fac10,ufac,lfac,fac60,second
      logical lmattyp2,lmattyp3,lmattyp4,lmattyp5,
     &        lmattyp6,lmattyp7,lmattyp8,lmattyp9,lmattyp11,intest,
     &        ladd,test1,test2,test3
!      character*72 inname
!**                                                                 ***
!**********************************************************************
!**   Start of calculation                                          ***
!**********************************************************************
!**                                                                 ***
!**   Setting of the desired vector term typs:                      ***
!**   lmattyp<i> = .true. ==> vector terms of type i will be built. ***
!**   (Main diagonal (type 1) will be set always and automatically) ***
!**                                                                 ***
!**   Reading the Random - parameters out of the file specified by  *** 
!**   FILE='...'                                                    ***  
!**                                                                 ***
      ierr = 0
      iounit = 10 
!      inname = 'random_input_param_file'
      open (UNIT=iounit,FILE=inrannam,FORM='FORMATTED')
      
      write(lout,1005) inrannam,iounit 
      
      read (iounit,*) lmattyp2 
      read (iounit,*) lmattyp3 
      read (iounit,*) lmattyp4 
      read (iounit,*) lmattyp5 
      read (iounit,*) lmattyp6 
      read (iounit,*) lmattyp7 
      read (iounit,*) lmattyp8 
      read (iounit,*) lmattyp9 
      read (iounit,*) lmattyp11 
!**                                                                 ***
      read (iounit,*) l
      read (iounit,*) vtband
!**                                                                 ***
!**   Initialisation of parameters used for the structure of the    ***
!**   matrix and the vector terms (see manual page <exam10>).       ***
!**                                                                 ***
      read (iounit,*) vt10 
      read (iounit,*) fac10 
      read (iounit,*) vt20
      read (iounit,*) vt30 
      read (iounit,*) vt40 
      read (iounit,*) vt50 
      read (iounit,*) vt60 
      read (iounit,*) fac60 
      read (iounit,*) vt70 
      read (iounit,*) vt80 
      read (iounit,*) vt90 
      read (iounit,*) vt100 
      read (iounit,*) lfac 
      read (iounit,*) ufac 
!**                                                                 ***
      read (iounit,*) vtstep
      read (iounit,*) dstride
      close (iounit)
!**                                                                 ***
!**                                                                 ***
!      ia1 = 5*vtband+2*l+2 
!      ia1 = 5*vtband+2*l+5 
      ia1 = 10*vtband+2*l+5 
      lmat = 2*l*ia1/3 
      lindex = lmat 
!**                                                                 ***
!**                                                                 ***
      allocate (info(ia1,ia2),index(lindex),stat=ierr)
      allocate (mat(lmat),prec(l),stat=ierr)

      if (ierr > 0) then
        write(lout,1200)
        write(lout,1201)
        write(lout,1300)
        goto 9999
      endif

!**                                                                 ***
!********************************************************************** 
!**   Start of constructing the matrix                              ***
!********************************************************************** 
!**                                                                 ***
      write(lout,500)
!**                                                                 ***
      pos    = 0
      posidx = 0
      nvt    = 0
      ierr2  = 0
      info   = 0
      index  = 0
      mat    = 0
      prec   = 0
!**                                                                 ***
!**   Constructing VTBAND vector terms of type 2 (full diagonal)    ***
!**                                                                 ***
      if (lmattyp2) then
!
!--   Initialisation of the vector term elements in the upper tri-  ---
!--   angle.                                                        ---
!
	 vtwert = vt20
	 nvt1   = nvt + 1
!
!--   Number of vector terms in the upper triangle                  ---
!
	 if (real(vtband/2) .ne. (real(vtband)/2.)) then
            anzahl = vtband/2 + 1
         else
	    anzahl = vtband/2
         endif
!	 
	 if (1+anzahl*(1+vtstep) .gt. l) then
            anzahl = l/(vtstep+1)
         endif
!
!--   Start of constructing the vector terms for upper triangle     --- 
!
	 do i=1,anzahl
	    nvt    = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    column = 1 + i * (vtstep + 1)     
            laenge = l + 1 - column
	    if (pos+laenge .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    info(nvt,1) = 2
            info(nvt,2) = pos
            info(nvt,3) = laenge
            info(nvt,4) = column-1
	    do j=1,laenge 
	       mat(pos+j) = vtwert
            end do
	    pos  = pos + laenge
            vtwert =  vtwert * ufac
         end do 
!
!--   Output of user-specifications                                 ---
!
	 write(lout,522) anzahl
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
!
!--   Initialisation the vector term elements of lower triangle     ---
!
         vtwert = vt20   
	 nvt1   = nvt + 1
!
!--   Number of vector terms of lower triangle                      ---
! 
	 anzahl = vtband/2
	 if (1+anzahl*(1+vtstep) .gt. l)
     &      anzahl = l/(vtstep+1)
!
!--   Start of constructing the vector term for lower triangle      ---
!
         do 30 i=1,anzahl
            nvt    = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    row    = 1 + i * (vtstep + 1)     
            laenge = l + 1 - row
	    if (pos+laenge .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    info(nvt,1) = 2 
            info(nvt,2) = pos
            info(nvt,3) = laenge
            info(nvt,5) = row - 1
            do 35 j=1,laenge
               mat(pos+j) = vtwert
 35         continue
            pos   = pos + laenge
            vtwert = vtwert * lfac
 30      continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,525) anzahl
         write(lout,523) (info(k,3), k=nvt1,nvt)
      
      endif 
!**                                                                 ***
!**   Constructing VTBAND vector terms of type 3 (packed diagonal)  ***
!**                                                                 ***
      if (lmattyp3) then
!
!--   Initialisation of vector term elements in the upper triangle  ---
!
         vtwert = vt30
	 nvt1   = nvt + 1
!
!--   Number of vector terms in the upper triangle                  ---
!
	 if (real(vtband/2) .ne. (real(vtband)/2.)) then
            anzahl = vtband/2 + 1
         else
	    anzahl = vtband/2
         endif
!
	 if (1+anzahl*(1+vtstep) .gt. l)
     &      anzahl = l/(vtstep+1)
	 
!
!--   Start of construction vector terms for the upper triangle     ---
!
         do 40 i=1,anzahl
	    nvt    = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    column = 1 + i * (vtstep + 1)
!
!--   Maximum number of elements in this vector term                ---
!
            laenge = l + 1 - column
! 
!--   Number of non-zero elements in this vector term               ---
!
    	    length = laenge / (dstride + 1) 
!
	    if (length*(dstride+1) .ne. laenge) 
     &         length = length + 1
	    if (pos+length .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    if (posidx+length .gt. lindex) then
	       ierr2 = 3
	       goto 9999
            endif
!
            info(nvt,1) = 3
            info(nvt,2) = pos
 	    info(nvt,3) = length
       	    info(nvt,4) = column - 1
	    info(nvt,6) = posidx
            do 45 j=1,length
               mat(pos+j)      = vtwert
   	       index(posidx+j) = 1 + (j-1) * (dstride+1)
 45         continue
            pos    = pos + length
	    posidx = posidx + length
            vtwert = vtwert * ufac
 40      continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,526) anzahl
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
!--   Initialisation of vector terms in the lower triangle          --- 
!
         vtwert = vt30
	 nvt1   = nvt + 1
!
!--   Number of vector terms in the lower triangle                  ---
!
	 anzahl = vtband/2
!
	 if (1+anzahl*(1+vtstep) .gt. l)
     &      anzahl = l/(vtstep+1)
	 
!
!--   Start of constructing vector terms in the lower triangle      ---
!
         do 50 i=1,anzahl
            nvt    = nvt+1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    row    = 1 + i * (vtstep + 1)
            laenge = l + 1 - row
	    length = laenge / (dstride + 1)
	    if (length*(dstride+1) .ne. laenge) 
     &         length = length + 1
	    if (pos+length .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    if (posidx+length .gt. lindex) then
	       ierr2 = 3
	       goto 9999
            endif
!
            info(nvt,1) = 3
            info(nvt,2) = pos
 	    info(nvt,3) = length
	    info(nvt,5) = row - 1
	    info(nvt,6) = posidx
            do 55 j=1,length
               mat(pos+j)     = vtwert
               index(posidx+j)= 1 + (j-1) * (dstride+1)
 55         continue
            pos    = pos + length
	    posidx = posidx + length
            vtwert  = vtwert * lfac
 50      continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,527) anzahl
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
      endif
!**                                                                 ***
!**   Constructing vector terms of type 4 (indexed column)          ***  
!**                                                                 ***
      if (lmattyp4) then
	 vtwert = vt40
	 nvt1   = nvt + 1
	 do 60 i=1,(l-1)
	    row = l-i+1
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    info(nvt,1) = 4
	    info(nvt,2) = pos
	    info(nvt,5) = row - 1
	    info(nvt,6) = posidx
!
            if (row .gt. vtband+1) then
	       length = l-row+1
	       if (length .gt. vtband) length = vtband
	       if (pos+length .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if (posidx+length .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       info(nvt,3) = length
	       do 65 j=1,length
		  mat(pos+j) = vtwert
		  index(posidx+j) = vtband+1-j
65             continue
	       pos = pos + length
	       posidx = posidx + length
	       vtwert = vtwert * lfac
            endif
!
	    if (row .eq. vtband+1) then
	       info(nvt,3) = 1
	       if (pos+1 .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if (posidx+1 .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       mat(pos+1)  = vtwert
	       index(posidx+1) = 1
	       pos = pos + 1
	       posidx = posidx + 1
	       vtwert = vtwert * lfac 
            endif
!
            if (row .lt. vtband+1) then
	       ir = 1
	       j  = 0
66             continue
	       if ((pos+ir) .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if ((posidx+ir) .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       mat(pos+ir) = vtwert
	       if (row+ir-1 .le. vtband+1) then
		  j = j + 1
		  index(posidx+ir) = j
               else
		  j = j - 1
		  index(posidx+ir)  = j
		  if ((j .le. 1) .or. (row+ir-1 .eq. l)) 
     &                 goto 67
               endif
	       if (row+ir .gt. l) goto 67
	       ir = ir + 1
	       goto 66
67             continue
	       length = ir
	       info(nvt,3) = length
	       pos = pos + length
	       posidx = posidx + length
	       vtwert = vtwert * lfac
            endif
60       continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,528) nvt-nvt1+1
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
      endif
!**                                                                 ***
!**   Constructing vector terms of type 5 (indexed row)             ***
!**                                                                 ***
      if (lmattyp5) then

	 vtwert = vt50
	 nvt1 = nvt + 1

	 do 70 i=1,(l-1)
	    column = l-i+1
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    info(nvt,1) = 5
	    info(nvt,2) = pos
	    info(nvt,4) = column - 1
	    info(nvt,7) = posidx
!
            if (column .gt. vtband+1) then
	       length = l-column+1
	       if (pos+length .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if (posidx+length .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       if (length .gt. vtband) length = vtband
	       info(nvt,3) = length
	       do 75 j=1,length
		  mat(pos+j)      = vtwert
		  index(posidx+j) = vtband+1-j
 75            continue
	       pos    = pos + length
	       posidx = posidx + length
	       vtwert = vtwert * ufac
            endif
!
	    if (column .eq. vtband+1) then
	       info(nvt,3) = 1
	       if (pos+1 .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if (posidx+1 .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       mat(pos+1)  = vtwert
	       index(posidx+1) = 1
	       pos = pos + 1
	       posidx = posidx + 1
	       vtwert = vtwert * ufac
            endif
!
            if (column .lt. vtband+1) then
	       ic = 1
	       j  = 0
 76            continue
	       if ((pos+ic) .gt. lmat) then
	          ierr2 = 2
	          goto 9999
               endif
	       if ((posidx+ic) .gt. lindex) then
	          ierr2 = 3
	          goto 9999
               endif
	       mat(pos+ic) = vtwert
	       if (column+ic-1 .le. vtband+1) then
		  j = j + 1
		  index(posidx+ic) = j
               else
		  j = j - 1
		  index(posidx+ic)  = j
		  if ((j .le. 1) .or. (column+ic-1 .eq. l))
     &               goto 77
               endif
	       if (column+ic .gt. l) goto 77
	       ic = ic + 1
	       goto 76
 77            continue
	       length = ic	
	       info(nvt,3) = length
	       pos    = pos + length
	       posidx = posidx + length
	       vtwert = vtwert * ufac
            endif
 70      continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,529) nvt-nvt1+1
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
      endif
!
!**                                                                 ***
!**   Constructing VCTBAND vector terms of type 6 (starry sky)      ***
!**                                                                 *** 
      if (lmattyp6) then
!         
         vtwert = vt60
	 nvt1=nvt+1 
!
	 call RANDOM_SEED()
!
	 do 80 i=1,vtband
	    nvt = nvt+ 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    call RANDOM_NUMBER(s)
	    s = 1.d0+s*real(l)
	    length = min(l,int(s))
	    if (pos+length .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    if (posidx+2*length .gt. lindex) then
	       ierr2 = 3
	       goto 9999
            endif
	    info(nvt,1) = 6
            info(nvt,2) = pos
	    info(nvt,3) = length
	    info(nvt,6) = posidx
	    info(nvt,7) = posidx + length
            do 85 j=1,length 
	       call RANDOM_NUMBER(z1)
	       call RANDOM_NUMBER(z2)
	       z1 = 1.d0 + z1*l
	       z2 = 1.d0 + z2*l
	       row = min(l,int(z1))
	       column = min(l,int(z2))
	       if (row .eq. column) then
		  row = row - 1
		  if (row .eq. 0) row = row + 2
               endif
	       mat(pos+j)      = vtwert
	       index(posidx+j) = column
	       index(posidx+length+j) = row
 85         continue
	    pos    = pos + length
	    posidx = posidx + length + length
	    vtwert = vtwert * fac60
 80      continue
!
!--   Output of user-specifications                                 ---
!
	 write(lout,530) nvt-nvt1+1
         write(lout,523) (info(k,3), k=nvt1,nvt)
!
      endif
!**                                                                 ***
!**   Constructing VTBAND vector terms of 7 (full column)           ***
!**                                                                 ***
      if (lmattyp7) then

         write(lout,531) vtband, l
	 
	 vtwert = vt70

	 do 90 i=1,vtband
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then

	       ierr2 = 1
	       goto 9999
            endif
	    if (pos+l .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    info(nvt,1) = 7
	    info(nvt,2) = pos
	    info(nvt,3) = l
	    info(nvt,4) = 0
	    info(nvt,5) = i - 1
	    do 95 j=1,l
	       if (i .eq. j) then
		  mat(pos+j) = 0.
               else
		  mat(pos+j) = vtwert
               endif
 95         continue
	    pos    = pos + l
	    vtwert = vtwert * ufac
 90      continue
      endif
!**                                                                 ***
!**   Constructing VTBAND vector terms of type 8 (full row)         ***
!**                                                                 ***
      if (lmattyp8) then
      
         write(lout,532) vtband, l

	 vtwert = vt80
	 
	 do 100 i=1,vtband
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    if (pos+l .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    info(nvt,1) = 8
	    info(nvt,2) = pos
	    info(nvt,3) = l
	    info(nvt,4) = i - 1
	    info(nvt,5) = 0
	    do 105 j=1,l
	       if (i .eq. j) then
		  mat(pos+j) = 0.
               else
		  mat(pos+j) = vtwert
               endif
 105        continue
	    pos    = pos + l
	    vtwert = vtwert * lfac
 100     continue
      endif
!**                                                                 ***
!**   Constructing VTBAND vector terms of type 9 (packed row)       ***
!**                                                                 ***
      if (lmattyp9) then
	 
	 vtwert = vt90
	 length = int((l+dstride+1-1)/(dstride + 1))
	
         write(lout,533) vtband, length
	 
	 do 110 i=1,vtband
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
	    if (pos+length .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
	    if (posidx + length .gt. lindex) then
	       ierr2 = 3
	       goto 9999
            endif
	    info(nvt,1) = 9
	    info(nvt,2) = pos
	    info(nvt,3) = length
	    info(nvt,5) = i - 1
	    info(nvt,6) = posidx
!
	    do 115 j=1,length
	      index(posidx + j) = 1 + (j - 1) * (dstride + 1)
	       if (i .eq. (posidx +  j)) then
		  mat(pos+j) = 0.
               else
		  mat(pos+j) = vtwert
               endif
!	       index(posidx + j) = 1 + (j - 1) * (dstride + 1)
 115        continue
	    pos    = pos + length 
	    posidx = posidx + length
	    vtwert = vtwert * ufac
 110     continue
      endif
!**                                                                 *** 
!**   Constructing VTBAND vector terms of type 11 (packed column)   ***
!**                                                                 ***
      if (lmattyp11) then
      
	 vtwert = vt100
	 length = l/(dstride + 1)
	 if((length * (dstride + 1)) .ne. l) then
	    length = length + 1
         endif
         
	 write(lout,534) vtband, length

	 do 120 i=1,vtband
	    nvt = nvt + 1
	    if (nvt .gt. ia1) then
	       ierr2 = 1
	       goto 9999
            endif
            
	    if (pos+length .gt. lmat) then
	       ierr2 = 2
	       goto 9999
            endif
!	    
	    if (posidx + length .gt. lindex) then
	       ierr2 = 3
	       goto 9999
            endif
!	    
	    info(nvt,1) = 11
	    info(nvt,2) = pos
	    info(nvt,3) = length
	    info(nvt,4) = i - 1
	    info(nvt,7) = posidx
	    do 125 j=1,length
	      index(posidx + j) = 1 + (j - 1) * (dstride + 1)
	       if (i .eq. (1 + (j - 1) * (dstride + 1))) then
		  mat(pos+j) = 0.
               else
		  mat(pos+j) = vtwert
               endif
 125        continue
	    pos    = pos + length
	    posidx = posidx + length
	    vtwert = vtwert * lfac
 120     continue
      endif
!**                                                                 *** 
!**  Calculating the main diagonal (type 1) using the row sums of   ***
!**  the matrix MAT.                                                ***
!**  For FAC >= 1 and VTVAL > 0 a diagonal dominant main diagonal   ***
!**  will be built, for FAC = 0 all main diagonal elements are zero.***
!**                                                                 ***
      vtwert      = vt10
      nvt         = nvt + 1
      if (nvt .gt. ia1) then
         ierr2 = 1 
	 goto 9999 
      endif 
      if (pos+l .gt. lmat) then
         ierr2 = 2
         goto 9999
      endif
      info(nvt,1) = 1
      info(nvt,2) = pos
      info(nvt,3) = l
!
      ilin(5) = nvt-1
!
!--   For each row of the matrix (so far existing without a main    --- 
!--   diagonal) the row sum will be calculated.                     ---
!--   They are used to calculate the main diagonal elements.        ---
!
      call ZSN(lmat,lindex,l,lsym,ia1,info,mat,index,ilin,prec)
!
!--   Calculating the main diagonal elements                        ---
!
      do 10 i=1,l
	mat(pos+i)=(prec(i)+vtwert)*fac10
10    continue
      
      pos = pos + l
!
      laenge  = pos
      ilin(5) = nvt
      write(lout,510) nvt
      write(lout,520) laenge
      write(lout,521) l
!
!**                                                                  ***
!**------------------------------------------------------------------***
!**   Output of errors                                               ***
!**------------------------------------------------------------------***
!**                                                                  ***
 9999 continue
      deallocate(prec)
      if (ierr2 == 1) then
        ierr = 100 + ierr2
        write(lout,1202) ia1
      endif
      if (ierr2 == 2) then
        ierr = 100 + ierr2
        write(lout,1203) lmat
      endif
      if (ierr2 == 3) then
        ierr = 100 + ierr2
        write(lout,1204) lindex
      endif
!**                                                                  ***
!***********************************************************************
!**   END OF CALCULATION                                             ***
!***********************************************************************
!**                                                                  ***
  500 format('  ------------------------------------------------ '/
     &       ' |   RANDOMized construction of the matrix        |'/
     &       ' |   starts ....                                  |'/
     &       '  ------------------------------------------------ '/)
  510 format('  Number of built vector terms:',i6)
  520 format('  Number of non-zero elements: ',i6)  
  521 format('  Order of matrix A is:        ',i6/)
  522 format('  ',i4,' full diagonal(s) in the upper triangle'/
     &       '   with length(s): ')
  523 format(3x,8(i6,1x),/)
  525 format('  ',i4,' full diagonal(s) in the lower triangle'/
     &       '   with length(s): ')
  526 format('  ',i4,' packed diagonal(s) in the upper triangle'/
     &       '   with length(s): ')
  527 format('  ',i4,' packed diagonal(s) in the lower triangle'/
     &       '   with length(s): ')
  528 format('  ',i4,' indexed column(s) with length(s): ',i5/)
  529 format('  ',i4,' indexed row(s) with length(s): ',i5/)
  530 format('  ',i4,' starry sky(skies) with length(s): ',i5/)
  531 format('  ',i4,' full row(s) with length(s): ',i5/)
  532 format('  ',i4,' full column(s) with length(s): ',i5/)
  533 format('  ',i4,' packed row(s) with length(s): ',i5/)
  534 format('  ',i4,' packed column(s) with length(s): ',i5/)
!    &       '                      check input parameters.')
 1005 format('  Reading file ',/
     &       '  ',a72,/
     &       '  on unit ',i3,' ...'/)
 1200 format(' **************************************************'/
     &       ' ***  ERROR occured in RANDOM:                  ***')
 1201 format(' ***   allocation of array <mat> or <index> or  ***'/
     &       ' ***   <info> or <prec> failed!                 ***')
 1202 format(' ***   ia1 = ',i11,' is too small!          ***')
 1203 format(' ***   lmat = ',i11,' is too small!         ***')
 1204 format(' ***   lindex = ',i11,' is too small!       ***')
 1300 format(' **************************************************')

      return
!
!-----END OF RANDOM----------------------------------------------------
!
      end 
  



!:::::      ,,,,,ZSN.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine ZSN(lmat,lindex,l,lsym,ia1,info,mat,index,ilin,prec)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      Z S N   Berechnung der Zeilensummennorm der Matrix MAT     ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      Programm ZSN ist ein Teilstueck von LL1PRE.                ***
!**      Erklaerung der formalen Parameter: siehe in LL1PRE.        ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     Copyright (C) UNIVERSITAET KARLSRUHE RECHENZENTRUM  1994        ***
!**     PROGRAMMER: H. Haefner     F.Seegmueller                    ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants
      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**                                                                 *** 
      integer           lmat,lindex,l,ia1,ilin(nilin)
      double precision  mat(lmat)
      double precision  norm
      double precision  prec(l)
      integer index(lindex),info(ia1,ia2)
      logical           lsym
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <linsol>)                                   ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer            i,nvt
      
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**  START OF CALCULATION :                                         ***
!**  ---------------------                                          ***
!**                                                                 ***
      nvt    = ilin(5)
      norm   = 0
!**                                                                 ***
      call LINRSA(l,lmat,mat,lindex,index,prec,ia1,info,nvt) 
      if (lsym) then
        call LINRST(l,lmat,mat,prec,lindex,index,ia1,info,nvt)
      endif
!**                                                                ***
      do 50 i=1,l 
	 norm = max(abs(prec(i)),norm)
   50 continue
!**                                                                 ***
!**   END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**-----------------------------------------------------------------***
!**                                                                 ***
      r e t u r n
!-----END OF ZSN-------------------------------------------------------
      e n d
