!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine RCV_INPUT_PARAM(infmt,split,outfmt,method,itmax,
     #                           outdev,isprec,bufsize,
     #                           msprec,noprec,idoku,msnorm,smooth,
     #                           misc,optim,nrhs,startsol,
     #                           bwoalg,runacc,rlin,
     #                           matrix,rhsin,outnam,
     #                           nproc,myproc,tids,nmsg)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   Receive input parameters from processor 1                     ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      Copyright (C) 1999 University Karlsruhe                    ***
!**      PROGRAMMER:    H. Haefner                                  ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer,intent(in) ::  nproc,myproc,tids(nproc)
      integer,intent(inout) ::  nmsg
      integer,intent(out) ::  infmt,split,outfmt,method,itmax,outdev
      integer,intent(out) ::  isprec,msprec,noprec,idoku,msnorm,smooth 
      integer,intent(out) ::  bufsize,misc,optim,nrhs,startsol
      integer,intent(out) ::  bwoalg,runacc
      character*72,intent(out) ::  outnam,matrix,rhsin
      double precision,intent(out) ::  rlin(nrlin)
!**                                                                 ***
!**                                                                 ***
!**      LOCAL VARIABLES :                                          ***
!**      -----------------                                          ***
!**                                                                 ***
      integer,parameter ::  nparm=19, nrparm=6
      integer  ierr,midr,from,ibuf(nparm)

c**********************************************************************
c**    Start of calculation                                         ***
c**********************************************************************

      from = tids(1)
      call MPRCVA(from,nmsg+myproc,nparm*iint,ibuf(1),midr,ierr)
      call MPRCVW(from,nmsg+myproc,nparm*iint,ibuf(1),midr,ierr)
      infmt  = ibuf(1)
      split  = ibuf(2)
      outfmt = ibuf(3)
      method = ibuf(4)
      itmax  = ibuf(5)
      outdev = ibuf(6)
      isprec = ibuf(7)
      msprec = ibuf(8)
      noprec = ibuf(9)
      idoku  = ibuf(10)
      msnorm = ibuf(11)
      smooth = ibuf(12)
      misc   = ibuf(13)
      optim  = ibuf(14)
      nrhs   = ibuf(15)
      startsol = ibuf(16)
      bufsize  = ibuf(17)
      bwoalg   = ibuf(18)
      runacc   = ibuf(19)
      call MPRCVA(from,nmsg+myproc,nrparm*ireal,rlin,midr,ierr)
      call MPRCVW(from,nmsg+myproc,nrparm*ireal,rlin,midr,ierr)
      if (outfmt > 0) then
         call MPRCVA(from,nmsg+myproc,72,outnam,midr,ierr)
         call MPRCVW(from,nmsg+myproc,72,outnam,midr,ierr)
      endif
      if (split == 1) then
         call MPRCVA(from,nmsg+myproc,72,matrix,midr,ierr)
         call MPRCVW(from,nmsg+myproc,72,matrix,midr,ierr)
         call MPRCVA(from,nmsg+myproc,72,rhsin,midr,ierr)
         call MPRCVW(from,nmsg+myproc,72,rhsin,midr,ierr)
      endif
      nmsg = nmsg + nproc

      return
!***  E N D  OF  RECEIVE_INPUT_PARAM **********************************
      end
