C**********************************************************************
C       1         2         3         4         5         6         7 *
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine rcv_linsol_matrix(mat,lmat,index,lindex,ilin,
     #                      info,ia1,llocal,nvtloc,ierr,lmatbk,ptrmbk,
     #                      myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***

C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      Copyright (C) 1997 University Karlsruhe                    ***
c**      PROGRAMMER:    Hartmut Haefner                             ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer myproc,nproc,nmsg,lmat,lindex,ia1,nvtloc,ierr,
     #        tids(nproc),index(lindex),info(ia1,ia2),ilin(nilin),
     #        lmatbk(nproc),ptrmbk(nproc+1),llocal
      double precision  mat(lmat)
      
C**                                                                 ***
C**      LOCAL VARIABLES :                                          ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           midr,from,ityp,nvec
      integer           i,ibuf(ia2),indbuf(llocal),irbuf(llocal)
      integer           endmat,endind,ivt,iertag
      double precision  buf(llocal)

c**********************************************************************
c**    Start of calculation                                         ***
c**********************************************************************

      endmat = 0
      endind = 0
      iertag = 0
      ivt    = 1

!*********************************************************
!   Get matrix in LINSOL-Format from processor 1
!*********************************************************

 200  from = tids(1)
      call MPRCVA(from,nmsg+myproc,2*iint,ibuf(1),midr,ierr)
      call MPRCVW(from,nmsg+myproc,2*iint,ibuf(1),midr,ierr)
      nmsg = nmsg+nproc-1
      ityp = ibuf(1)
      nvec = ibuf(2)
      if (ityp.eq.0) then 
        goto 500    ! Separation of matrix is finished
      else
        do 210 i=1,nvec
          if (ityp.eq.1) then
            call LINSP1(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat)
          elseif (ityp.eq.2) then
            call LINSP2(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,
     #                   nmsg,ierr,iertag,buf,llocal,ibuf,endmat)
          elseif (ityp.eq.3) then
            call LINSP3(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat,
     #                  index,lindex,endind,indbuf)
          elseif (ityp.eq.4) then
            call LINSP4(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat,
     #                  index,lindex,endind,indbuf)
          elseif (ityp.eq.5) then
            call LINSP5(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat,index,
     #                  lindex,endind,indbuf)
          elseif (ityp.eq.6) then
            call LINSP6(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat,index,
     #                  lindex,endind,indbuf,irbuf)
          elseif (ityp.eq.7) then
            call LINSP7(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat)
          elseif (ityp.eq.8) then
            call LINSP8(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat)
          elseif (ityp.eq.9) then
            call LINSP9(mat,lmat,info,ivt,ia1,tids,
     #                  lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                  ierr,iertag,buf,llocal,ibuf,endmat,
     #                  index,lindex,endind,indbuf)
          elseif (ityp.eq.11) then
            call LINSP11(mat,lmat,info,ivt,ia1,tids,
     #                   lmatbk,ptrmbk,nproc,myproc,nmsg,
     #                   ierr,iertag,buf,llocal,ibuf,endmat,
     #                   index,lindex,endind,indbuf)
          endif
 210    continue
        goto 200          
      endif

 500  nvtloc   = ivt-1      
      ilin(39) = iertag
      ilin(33) = endmat
      ilin(34) = endind

      r e t u r n
c---- END OF RCV_LINSOL_MATRIX ---------------------------------------
      e n d
