!***********************************************************************
!        1         2         3         4         5         6         7 *
!***********************************************************************
!**                                                                  ***
!**                                                                  ***
      subroutine SEND_SOLUTION(x,l,lmatbk,ierr,tids,nproc,myproc,nmsg)
!**                                                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    SEND_SOLUTION   sends own part of the solution to processor 1 ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    Copyright (C) 1997 University Karlsruhe                       ***
!**    PROGRAMMER : H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
      USE constants

      implicit none
!**                                                                  *** 
!***********************************************************************
!**                                                                  ***
!**    Formal Parameters :                                           ***
!**                                                                  ***
!***********************************************************************
      integer          l,ierr,myproc,nproc,nmsg
      integer          lmatbk(nproc),tids(nproc)
      double precision x(l)
!***********************************************************************
!**                                                                  ***
!**    List of Formal Parameters :                                   ***
!**                                                                  ***
!**                                                                  ***
!---------I------I-----I------------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I------------------------------------------------
! l       I int  I in  I dimension of the matrix
!---------I------I-----I------------------------------------------------
! ierr    I int  I out I error-indication
!---------I------I-----I------------------------------------------------
!**                                                                  ***
!**                                                                  ***
!**    Local Variables :                                             ***
!**                                                                  ***
      integer          to,mids

!***********************************************************************
!**    Start of Calculation                                          ***
!***********************************************************************

!*********************************************************
!   Send parts of solution-vector to processor 1
!*********************************************************
      to = tids(1)
      call MPSNDA(to,nmsg+myproc-1,lmatbk(myproc)*ireal,
     &            x(1),mids,ierr)
      call MPSNDW(to,nmsg+myproc-1,lmatbk(myproc)*ireal,
     &            x(1),mids,ierr)
      nmsg = nmsg+nproc-1

!***********************************************************************
!**    End of Calculation                                            ***
!***********************************************************************

       r e t u r n
!-----END OF SEND_SOLUTION --------------------------------------------
       e    n    d
