!***********************************************************************
!        1         2         3         4         5         6         7 *
!***********************************************************************
!**                                                                  ***
!**                                                                  ***
      subroutine SET_ARRAY_HB(lmatbk,ptrmbk,info,ia1,nproc,matfac,
     &                        indfac,infofac,lmatbuf,lindbuf,ia1buf)
!**                                                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    SET_ARRAY_HB    sets the dimensions of the arrays <MAT>,      ***
!**                    <index> and <info> for H/B-Format             ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    Copyright (C) 1996 University Karlsruhe                       ***
!**    PROGRAMMER : H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
      USE constants

      implicit none
!**                                                                  *** 
!***********************************************************************
!**                                                                  ***
!**    Formal Parameters :                                           ***
!**                                                                  ***
!***********************************************************************
      integer          nproc,ia1
      integer          lmatbk(nproc),ptrmbk(nproc+1)
      integer          info(ia1,ia2),lmatbuf(nproc),lindbuf(nproc)
      integer          ia1buf(nproc)
      real             matfac,indfac,infofac

!***********************************************************************
!**                                                                  ***
!**    List of Formal Parameters :                                   ***
!**                                                                  ***
!**                                                                  ***
!---------I------I-----I------------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I------------------------------------------------
! lmatbuf I int  I out I dimensions of the distributed matrices
!         I      I     I                      array: lmatbuf(nproc)
!---------I------I-----I------------------------------------------------
! lindbuf I int  I out I dimensions of the distributed index-arrays
!         I      I     I (lindbuf = lmatbuf)  array: lindbuf(nproc)
!---------I------I-----I------------------------------------------------
! ia1buf  I int  I out I first dimensions of the distributed 
!         I      I     I information-arrays   array: ia1buf(nproc)
!---------I------I-----I------------------------------------------------
!**                                                                  ***
!**                                                                  ***
!**    Local Variables :                                             ***
!**                                                                  ***
       integer  i,j


!***********************************************************************
!**    Start of Calculation                                          ***
!***********************************************************************

      if (nproc > 1) then
        do j=2,nproc
          lmatbuf(j) = 0
          do i=1,lmatbk(j)
            lmatbuf(j) = lmatbuf(j)+info(ptrmbk(j)+i,3)
          enddo
          lindbuf(j) = int(lmatbuf(j)*indfac)
          lmatbuf(j) = int(lmatbuf(j)*matfac)
          ia1buf(j)  = int((lmatbk(j)+1)*infofac)
        enddo
      endif

!***********************************************************************
!**    End of Calculation                                            ***
!***********************************************************************

       r e t u r n
!---- END OF SET_ARRAY_HB ----------------------------------------------
       e    n    d
