/*===========================================================================*/
/*                                                                           */
/* LIBRARY OF INPUT-OUTPUT PROCEDURES .                                      */
/*                                                                           */
/*                                                                           */
/*    Copyright (C) 1999 University Karlsruhe                                */
/*    PROGRAMMER:    H. Haefner                                              */
/*                                                                           */
/*    This file is part of LINSOL.                                           */
/*    LINSOL is free software; you can redistribute it and/or                */
/*    modify it under the terms of the GNU General Public License            */
/*    as published by the Free Software Foundation; either                   */
/*    version 2 of the License, or (at your option) any later                */
/*    version.                                                               */
/*                                                                           */
/*    LINSOL is distributed in the hope that it will be useful,              */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty            */
/*    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                */
/*    See the GNU General Public License for more details.                   */
/*                                                                           */
/*    You should have received a copy of the GNU General Public              */
/*    License along with LINSOL; if not, write to the Free                   */
/*    Software Foundation, Inc., 59 Temple Place - Suite 330,                */
/*    Boston, MA  02111-1307, USA.                                           */
/*                                                                           */
/*===========================================================================*/
#include <stdlib.h>
#include <stdio.h>

#ifdef FTNLINKSUFFIX
#define FTNNAME(n) n ## _
#else
#define FTNNAME(n) n
#endif

#define  false      0
#define  true       1
#define  FALSE      0
#define  TRUE       1
#define  BEGIN      {  
#define  END        }    

#define  IF         if 
#define  THEN       {  
#define  ELSE       } else {  
#define  ELIF       } else if 
#define  ELSIF      } else if  
#define  ELSEIF     } else if 
#define  ENDIF      }    

#define  FOR        for  
#define  WHILE      while 
#define  DO         {  
#define  ENDDO      }    

#define  LOOP       for (;;) {
#define  ENDLOOP    }      

#define  H_size     4096
#define  MAX_WIDTH  1024
#define  MAX_HEIGHT 1024 

int nligne , ncolonne;
float   echellez,zeroz;
float   fxmin,fxmax,fymin,fymax;

int     header_size;

#define                 iechellez  435 
#define                 izeroz     363 
#define                 idim       1536  
#define                 inligne    407 
#define                 incolonne  411
#define                 ifxmin     419
#define                 ifxmax     423
#define                 ifymin     427
#define                 ifymax     431
#define                 iunitez    451
#define                 iunitexy   461 

#define                 header_size  128 


/*===========================================================================*/
/*                                                                           */
/* GET KEYWORD .                                                             */
/*                                                                           */
/*===========================================================================*/
#ifdef UPPERCASE
void FTNNAME(GET_ENV_KEYWORD)(char *keyword , char *string , int *L)
#else
void FTNNAME(get_env_keyword)(char *keyword , char *string , int *L)
#endif
BEGIN 
      char *p0 , *p;
      int k , length; 
      p0 = getenv (keyword) ;          
      p = p0; 
      k = 0;
      WHILE ((*p != '\0') & (*p != ' ')) DO
         string[k] = *p;
         p++;
         k = k + 1;    
      ENDDO  
      length = p-p0;
      *L = length;
END 


/*===========================================================================*/
/*                                                                           */
/* CONVERSION OF A DIGIT THAT IS REPRESENTED BY A CHARACTER .                */
/*                                                                           */
/*===========================================================================*/
int  digit( uc )
unsigned char uc;  
BEGIN 
     int I;

     IF (uc == ' ') THEN 
        I = 0; 
     ELSEIF (uc == '0') THEN 
        I = 0; 
     ELSEIF (uc == '1') THEN 
        I = 1; 
     ELSEIF (uc == '2') THEN 
        I = 2; 
     ELSEIF (uc == '3') THEN 
        I = 3; 
     ELSEIF (uc == '4') THEN 
        I = 4; 
     ELSEIF (uc == '5') THEN 
        I = 5; 
     ELSEIF (uc == '6') THEN 
        I = 6; 
     ELSEIF (uc == '7') THEN 
        I = 7; 
     ELSEIF (uc == '8') THEN 
        I = 8; 
     ELSEIF (uc == '9') THEN 
        I = 9; 
     ELSE
        I = -1; 
     ENDIF 
     return (int ) I;

END 


/*===========================================================================*/
/*                                                                           */
/* GET a 1 BYTES INTEGER from INPUT STREAM .                                 */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* Type conversion from "char" to "integer" .                                */
/*---------------------------------------------------------------------------*/
int  swap_1( a1 )
unsigned char *a1;  
BEGIN 
      unsigned char *p;
      unsigned int u;
      p = a1; 
      u = (unsigned int)*p;
      return (int ) u;
END

/*---------------------------------------------------------------------------*/
/* Get 1 byte integer .                                                      */
/*---------------------------------------------------------------------------*/
int get_int_1( header , index  )
unsigned char *header;
int index;
BEGIN 
      unsigned char s[10];
      int I;
      s[0] = header[index] ;
      s[1] = 0  ;
      I = swap_1( &s[0]);
      return I;
END


/*===========================================================================*/
/*                                                                           */
/* GET a 2 BYTES INTEGER from INPUT STREAM .                                 */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* Type conversion from "char" to "integer" .                                */
/*---------------------------------------------------------------------------*/
int  swap_2( a1 )
unsigned char *a1;  
BEGIN 
      unsigned char *p;
      unsigned int u1, u2;
      unsigned int u;
      p = a1; 
      u1 = (unsigned int)*p++;
      u2 = (unsigned int)*p++;
      u =  (u2 << 8 ) + u1; 
      return (int ) u;
END

/*---------------------------------------------------------------------------*/
/* Get 2 bytes integer .                                                     */
/*---------------------------------------------------------------------------*/
int get_int_2( header , index  )
unsigned char *header;
int index;
BEGIN 
      unsigned char s[10];
      int I;
      s[0] = header[index ] ;
      s[1] = header[index+1] ;
      s[2] = 0  ;
      I = swap_2( &s[0]);
      return I;
END

/*===========================================================================*/
/*                                                                           */
/* GET a 4 BYTES INTEGER from INPUT STREAM .                                 */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* Type conversion from "char" to "integer" .                                */
/*---------------------------------------------------------------------------*/
int  swap( a1 )
unsigned char *a1;  
BEGIN 
      unsigned char *p;
      unsigned int u1, u2, u3, u4;
      unsigned int u;
      p = a1; 
      u1 = (unsigned int)*p++;
      u2 = (unsigned int)*p++;
      u3 = (unsigned int)*p++;
      u4 = (unsigned int)*p;
      u =  (u1 << 24) + (u2<<16) + (u3<<8) + u4; 
      u =  (u3 << 8 ) + u4; 
      u =  (u2 << 8 ) + u1; 
      return (int ) u;
END

/*---------------------------------------------------------------------------*/
/* Get 4 bytes integer .                                                     */
/*---------------------------------------------------------------------------*/
int get_int( header , index  )
unsigned char *header;
int index;
BEGIN 
      unsigned char s[10];
      int I;
      s[0] = header[index ] ;
      s[1] = header[index+1] ;
      s[2] = header[index+2] ;
      s[3] = header[index+3] ;
      s[4] = 0  ;
      I = swap( &s[0]);
      return I;
END




/*===========================================================================*/
/*                                                                           */
/* GET a 4 BYTES FLOATING POINT VALUE from INPUT STREAM .                    */
/*                                                                           */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* Type conversion from "char" to "float" .                                  */
/*---------------------------------------------------------------------------*/
float  swapF( a1 )
unsigned char *a1;  
BEGIN 
     unsigned char *p;
     unsigned char pf[10];
     float *f;
     p = a1; 
     pf[3] = (unsigned char)*p++;
     pf[2] = (unsigned char)*p++;
     pf[1] = (unsigned char)*p++;
     pf[0] = (unsigned char)*p;
     f = (float *)&pf[0];
     return (float ) *f;
END

/*---------------------------------------------------------------------------*/
/* Get 4 bytes real value .                                                  */
/*---------------------------------------------------------------------------*/
float get_float( header , index  )
unsigned char *header;
int index;
BEGIN 
      unsigned char s[10];
      float  f;
      s[0] = header[index ] ;
      s[1] = header[index+1] ;
      s[2] = header[index+2] ;
      s[3] = header[index+3] ;
      s[4] = 0  ;
      f = swapF( &s[0]);
      return f;
END 
