!:::::      ,,,,,BWAVG.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine BWAVG(index,lindex,info,ia1,nvt,ibwavg)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     B W A V G :  computes the average bandwidth of a matrix     ***
!**                  that is completely stored in the storage       ***
!**                  pattern "packed row"r.                         ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2001 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in)  ::  ia1, lindex, nvt
!     integer, intent(in)  ::  info(ia1,ia2), index(lindex)
      integer, intent(in)  ::  info(ia1,7), index(lindex)
      integer, intent(out) ::  ibwavg
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF IMPORTANT PARAMETERS :                                ***
!**   ------------------------------                                ***
!**                                                                 ***
!--------I------I-----I------------------------------------------------
! NAME   I TYPE I I/O I     MEANING
!--------I------I-----I------------------------------------------------
!--------I------I-----I------------------------------------------------
! ibwavg I  I   I out I  average bandwidth of the matrix completely
!        I      I     I  sored in the storage pattern "packed row" 
!--------I------I-----I------------------------------------------------
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer    i, idist
      integer*8  idistsum
!
!
!**** START OF CALCULATION :
!     ---------------------
!

      idistsum = 0
      do i=1,nvt
	idist = index(info(i,6)+info(i,3)) - index(info(i,6)+1) 
	idistsum = idistsum + idist
      enddo
      ibwavg = NINT(REAL(idistsum)/REAL(nvt))

      r e t u r n
!-----END OF BWAVG------------------------------------------------------      
      e n d
