C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine CREATE_BUF(rbuf,nofcols,nofrows,ilin,lmyblk,
     *                      myproc,nproc,tids,nmsg,ierr)
C**                                                                 ***
C**                                                                 ***
C**    State of parameter:   in     in      in      out   in ...    ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   C R E A T E _ B U F  creates a buffer of bufsize (in MByte)   ***
C**                        with <nofrows> rows and <nofcols> cols.  ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1998 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer,intent(in) ::   nofcols,nproc,myproc,lmyblk
      integer,intent(inout) ::   ierr,nmsg
      integer,intent(in) ::   ilin(nilin),tids(nproc)
      double precision,dimension(:,:),pointer :: rbuf
      integer,intent(out)::   nofrows
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <linsol>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    bufsize,iermax,ihelp,idoku,lout

C
C**** START OF CALCULATION :
C     ---------------------
C
      lout   = ilin(12)
      idoku  = ilin(13)
      bufsize = ilin(7)

      ierr  = 0
      if (bufsize < 1) then
	ierr = 1
	goto 999
      endif

      nofrows = int(bufsize*1.e6/(ireal*nofcols))
      nofrows = min(lmyblk,nofrows)
!     if (idoku > 0) then
!       if (myproc == 1) write(lout,1010) nofrows*nofcols*ireal
!     endif
!     if (idoku < 0) write(lout,1010) nofrows*nofcols*ireal 
      allocate (rbuf(nofrows,nofcols),stat=ierr)

  999 call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
      if (iermax > 0) then
        ierr = iermax
        if (myproc .eq. 1) then
          write(lout,1000)
          write(lout,1040)
          write(lout,1020)
        endif
      endif

 1000 format(' **************************************************'/
     &       ' ***  ERROR occured in LSOLP (CREATE_BUF):      ***')
 1040 format(' ***   buffer allocation failed!!!              ***')
 1020 format(' **************************************************')
!1010 format('  Allocating storage of size (in Bytes) ',i9,/
!    &       '  for buffer <rbuf> .....'/)

      R E T U R N
C------END OF CREATE_BUF--------------------------------------------
      E N D                                   
