C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine CREATE_BUFI(ibuf,bufsize,maxbuf,ilin,myproc,nproc,
     *                       tids,nmsg,ierr)
C**                                                                 ***
C**                                                                 ***
C**    State of parameter:    out   out   in    in    in    in      ***
C**                            in   i/o out                         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   C R E A T E _ B U F I  creates one buffer of                  ***
C**                          LINSOL_BUFFER_SIZE (in Mbyte) for the  ***
C**                          integer buffer <ibuf>.                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1999 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer,intent(in) ::   nproc,myproc
      integer,intent(inout) ::   nmsg
      integer,intent(out) ::   ierr
      integer,intent(in) ::   ilin(nilin),tids(nproc)
      integer,dimension(:),pointer :: ibuf
      integer,intent(out) ::   bufsize
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <linsol>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    iermax,ihelp,idoku,lout,bsize,maxbuf

C
C**** START OF CALCULATION :
C     ---------------------
C
      lout   = ilin(12)
      idoku  = ilin(13)
      bsize  = ilin(7)

      ierr  = 0
      if (bsize < 1) then
        ierr = 1
        goto 999
      endif

      bufsize = min(maxbuf,int(bsize*1.e6/iint))
!     bufsize = 200

!     if (idoku > 0) then
!       if (myproc == 1) write(lout,1010) bufsize*iint
!     endif
!     if (idoku < 0) write(lout,1010) bufsize*iint 
      allocate (ibuf(bufsize),stat=ierr)

  999 call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
      if (iermax > 0) then
        ierr = iermax
        if (myproc .eq. 1) then
          write(lout,1000)
          write(lout,1040)
          write(lout,1020)
        endif
      endif

 1000 format(' **************************************************'/
     &       ' ***  ERROR  occured  in  CREATE_BUFI:          ***')
 1040 format(' ***   buffer allocation failed!!!              ***')
 1020 format(' **************************************************')
!1010 format('  Allocating storage of size (in Bytes) ',i9,/
!    &       '  for a integer buffer  .....'/)

      R E T U R N
C------END OF CREATE_BUFI-------------------------------------------
      E N D                                   
