!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine DIAGCOMP(index,lindex,info,ia1,nvt,l,diagel,diagbgn,
     &                    diagend,diagbwavg)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   DIAGCOMP    to computate the amounts of the elements of each  ***
!**               diagonal.                                         ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2001 University Karlsruhe                      ***
!**    PROGRAMMER: Xiangming Quan                                   ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in) ::  ia1,lindex,nvt,l
      integer, intent(in) ::  info(ia1,7), index(lindex)
      integer, intent(out) ::  diagel(2*l-1),diagbgn(2*l-1)
      integer, intent(out) ::  diagend(2*l-1)
      integer, intent(out) ::  diagbwavg
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolp>)                                    ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer   lvt,ixptr,ix,i,k,iar 
      integer   diagelnew(2*l-1)
      integer   diagsum, diagbwsum, temp1

!
!**** START OF CALCULATION :
!     ---------------------
!

      do i=1 , 2*l-1
	diagel(i) = 0
      end do

      do i=1,nvt! nvt=no. of the vector terms
	lvt = info(i,3) ! lvt= length of the vector terms
	ixptr = info(i,6) !ixptr= index pointer of colomn
	iar = info(i,5) ! index of row
	do k=1,lvt ! for all elements of a row
	   ix = l-index(ixptr+k)+iar+1   ! index(x)=iac+1
	   diagel(ix)=diagel(ix)+1
        end do
      end do

      do i= 1, 2*l-1
	 diagelnew(i)=0
	 diagbgn(i)=0
	 diagend(i)=0
      enddo

      do i= 1, nvt
	 lvt = info(i,3)
	 ixptr = info(i,6)
	 iar = info(i,5)
	 do k = 1,lvt
	    ix = l-index(ixptr+k)+iar+1
	    diagelnew(ix)=diagelnew(ix)+1
	     if (diagelnew(ix) == 1) then
	       diagbgn(ix)=iar+1
             end if
	    if (diagelnew(ix)==diagel(ix)) then
	       diagend(ix)=iar+1 
            end if 
         enddo
      enddo

      diagsum=0
      diagbwsum=0
      do i=1,2*l-1
	 if (diagel(i)>1) then
	    diagsum = diagsum +1
         end if
	 temp1 = diagend(i) - diagbgn(i)
	 if (temp1 < 0) temp1 = 0
         diagbwsum = diagbwsum + temp1
      enddo

      diagbwavg = NINT(REAL(diagbwsum)/REAL(diagsum))


      return
      end
