C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine FILL_BUF(lmat,lindex,mat,index,info,ia1,lmatbk,ptrmbk,
     *                 myproc,nproc,rbuf,nofrows,nofcols,runind,nvt,js)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   F I L L _ B U F  fills a buffer of bufsize (in MByte) with    ***	
C**                    matrix elements of type 1 to type 11.        ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1998 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer,intent(in) ::  nofrows,nofcols,nproc,myproc
      integer,intent(in) ::  lmat,lindex,ia1,nvt,js
      integer,intent(in) ::  index(lindex),info(ia1,ia2),lmatbk(nproc)
      integer,intent(in) ::  ptrmbk(nproc+1)
      integer,intent(inout)::  runind(nvt)
      double precision,intent(in):: mat(lmat)
      double precision,intent(inout):: rbuf(nofrows,nofcols)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C runind I  I   I i/o I  shows how many elements of the vector terms
C        I      I     I  have already been stored in the buffer.
C--------I------I-----I------------------------------------------------
C js     I  I   I in  I  points to the first row of the matrix to be
C        I      I     I  buffered.
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    adda,ivt,iac,iar,iarloc,iarend,indr,indc,k,j,irbmin
      integer    lvt,iacloc,lmyblk,ptrmyb

C
C**** START OF CALCULATION :
C     ---------------------
C
      lmyblk = lmatbk(myproc)
      ptrmyb = ptrmbk(myproc)

      do ivt = 1,nvt
	if (info(ivt,1) == 1) then
	  adda = info(ivt,2)
	  do j = 0,min(nofrows,lmyblk)-1
	    rbuf(j+1,js+j+ptrmyb) = rbuf(j+1,js+j+ptrmyb) +
     *                              mat(adda+js+j)
	  enddo
	endif

	if (info(ivt,1) == 2) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  k      = runind(ivt)
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  do j = iarloc+runind(ivt)-js+1,irbmin-js+1
	    rbuf(j,iac+k) = rbuf(j,iac+k) + mat(adda+k)
	    k = k+1
	  enddo
	  runind(ivt) = k 
	endif

	if (info(ivt,1) == 3) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  indc   = info(ivt,6)
	  k      = runind(ivt)
	  irbmin = min(js-1+nofrows,lmyblk)
	  j      = iarloc+index(indc+k)-js+1
	  do while ((j <= irbmin-js+1) .and. (k <= lvt))
	    rbuf(j,iac+index(indc+k)) = rbuf(j,iac+index(indc+k)) +
     *                                  mat(adda+k)
	    k = k+1
	    j = iarloc+index(indc+k)-js+1
	  enddo
	  runind(ivt) = k 
	endif

	if (info(ivt,1) == 4) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  indc   = info(ivt,6)
	  k      = runind(ivt)
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  do j = iarloc+runind(ivt)-js+1,irbmin-js+1
	    rbuf(j,index(indc+k)) = rbuf(j,index(indc+k)) +
     *                              mat(adda+k)
	    k = k+1
	  enddo
	  runind(ivt) = k 
	endif

	if (info(ivt,1) == 5) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  indr   = info(ivt,7)
	  irbmin = min(js-1+nofrows,lmyblk)
	  do k = 1,lvt
	    iarloc = index(indr+k) - ptrmyb
	    if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	      rbuf(iarloc-js+1,iac+k) = rbuf(iarloc-js+1,iac+k) +
     *                                  mat(adda+k)
	    endif
	  enddo
	endif

	if (info(ivt,1) == 6) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  indc   = info(ivt,6)
	  indr   = info(ivt,7)
	  irbmin = min(js-1+nofrows,lmyblk)
	  do k = 1,lvt
	    iarloc = index(indr+k) - ptrmyb
	    if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	      rbuf(iarloc-js+1,index(indc+k)) = 
     *        rbuf(iarloc-js+1,index(indc+k)) + mat(adda+k)
	    endif
	  enddo
	endif

	if (info(ivt,1) == 7) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5)+1 - ptrmyb
	  irbmin = min(js-1+nofrows,lmyblk)
	  if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	    do k = 1,lvt
	      rbuf(iarloc-js+1,iac+k) = rbuf(iarloc-js+1,iac+k) +
     *                                  mat(adda+k)
	    enddo
	  endif
	endif

	if (info(ivt,1) == 8) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  k      = runind(ivt)
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  do j = iarloc+runind(ivt)-js+1,irbmin-js+1
	    rbuf(j,iac+1) = rbuf(j,iac+1) + mat(adda+k)
	    k = k+1
	  enddo
	  runind(ivt) = k 
	endif

	if (info(ivt,1) == 9) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5)+1 - ptrmyb
	  indc   = info(ivt,6)
	  irbmin = min(js-1+nofrows,lmyblk)
	  if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	    do k = 1,lvt
	      rbuf(iarloc-js+1,index(indc+k)) =
     *        rbuf(iarloc-js+1,index(indc+k)) + mat(adda+k)
	    enddo
	  endif
	endif

	if (info(ivt,1) == 11) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  indr   = info(ivt,7)
	  k      = runind(ivt)
	  irbmin = min(js-1+nofrows,lmyblk)
	  j      = index(indr+k) - ptrmyb - js+1
	  do while ((j <= irbmin-js+1) .and. (k <= lvt))
	    rbuf(j,iac+1) = rbuf(j,iac+1) + mat(adda+k)
	    k = k+1
	    j = index(indr+k) - ptrmyb - js+1
	  enddo
	  runind(ivt) = k 
	endif
      enddo

      R E T U R N
C------END OF FILL_BUF--------------------------------------------
      E N D                                   
