C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine FILL_BUF_INPL(mat,lmat,index,lindex,info,nvt,ia1,
     *                         lmyblk,ptrmyb,rbuf,nofrows,nofcols,js,
     *                         matmark,ixmark,myproc,nproc)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   F I L L _ B U F _ I N P L  fills a buffer of bufsize          ***
C**                              (in MByte) with matrix elements    ***
C**                              of type 1 to type 11. The buffered ***
C**                              matrix elements must be marked.    ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1998 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer,intent(in) ::  nofrows,nofcols,nproc,myproc
      integer,intent(in) ::  lmyblk,ptrmyb
      integer,intent(in) ::  lmat,lindex,nvt,ia1,js,ixmark
      integer,intent(inout) ::  index(lindex),info(ia1,ia2)
      double precision,intent(in):: matmark
      double precision,intent(inout):: mat(lmat)
      double precision,intent(inout):: rbuf(nofrows,nofcols)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C js     I  I   I in  I  points to the first row of the matrix to be
C        I      I     I  buffered.
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    adda,ivt,iac,iar,iarloc,iarend,indr,indc,k,j,irbmin
      integer    lvt,iacloc
      double precision,parameter ::  zero = 0.0

C
C**** START OF CALCULATION :
C     ---------------------
C
      do ivt = 1,nvt
	if (info(ivt,1) == 1) then
	  adda = info(ivt,2)
	  lvt  = info(ivt,3)
	  do j = 0,min(nofrows,lvt)-1
	    rbuf(j+1,js+j+ptrmyb) = rbuf(j+1,js+j+ptrmyb) +
     *                              mat(adda+j+1)
	    mat(adda+j+1) = matmark
	  enddo
          info(ivt,3) = info(ivt,3) - min(nofrows,lvt)
	endif

	if (info(ivt,1) == 2) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  k = 0  
	  do j = iarloc+1-js+1,irbmin-js+1
	    k = k + 1
	    rbuf(j,iac+k) = rbuf(j,iac+k) + mat(adda+k)
	    mat(adda+k) = matmark
	  enddo
          info(ivt,3) = lvt - k
          info(ivt,4) = iac + k
          info(ivt,5) = info(ivt,5) + k
	endif

	if (info(ivt,1) == 3) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  indc   = info(ivt,6)
	  irbmin = min(js-1+nofrows,lmyblk)
	  k      = 1
	  j      = iarloc+index(indc+k)-js+1
	  do while ((j <= irbmin-js+1) .and. (k <= lvt))
	    rbuf(j,iac+index(indc+k)) = rbuf(j,iac+index(indc+k)) +
     *                                  mat(adda+k)
	    mat(adda+k) = matmark
	    index(indc+k) = ixmark
	    k = k+1
	    j = iarloc+index(indc+k)-js+1
	  enddo
          info(ivt,3) = lvt - k + 1
	endif

	if (info(ivt,1) == 4) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  indc   = info(ivt,6)
	  k      = 0
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  do j = iarloc+1-js+1,irbmin-js+1
	    k = k + 1
	    rbuf(j,index(indc+k)) = rbuf(j,index(indc+k)) +
     *                              mat(adda+k)
	    mat(adda+k) = matmark
	    index(indc+k) = ixmark
	  enddo
          info(ivt,3) = lvt - k
          info(ivt,5) = info(ivt,5) + k
	endif

! This storage pattern can enlarge the size of the matrix
	if (info(ivt,1) == 5) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  indr   = info(ivt,7)
	  irbmin = min(js-1+nofrows,lmyblk)
	  do j = 1,lvt
	    iarloc = index(indr+j) - ptrmyb
	    if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	      rbuf(iarloc-js+1,iac+j) = rbuf(iarloc-js+1,iac+j) +
     *                                  mat(adda+j)
	      mat(adda+j) = zero
	    endif
	  enddo
	  k = 1
	  do while ((mat(adda+k) == zero) .and. (k <= lvt))
	    mat(adda+k) = matmark
	    index(indr+k) = ixmark
	    k = k + 1
	  enddo
          info(ivt,3) = lvt - k + 1
          info(ivt,4) = iac + k + 1
	endif

	if (info(ivt,1) == 6) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  indc   = info(ivt,6)
	  indr   = info(ivt,7)
	  irbmin = min(js-1+nofrows,lmyblk)
	  k = 0
	  do j = 1,lvt
	    iarloc = index(indr+j) - ptrmyb
	    if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	      rbuf(iarloc-js+1,index(indc+j)) = 
     *        rbuf(iarloc-js+1,index(indc+j)) + mat(adda+j)
	      mat(adda+j) = matmark
	      index(indc+j) = ixmark
	      index(indr+j) = ixmark
	      k = k + 1
	    endif
	  enddo
          info(ivt,3) = lvt - k
	endif

	if (info(ivt,1) == 7) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) + 1 - ptrmyb
	  irbmin = min(js-1+nofrows,lmyblk)
	  if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	    do k = 1,lvt
	      rbuf(iarloc-js+1,iac+k) = rbuf(iarloc-js+1,iac+k) +
     *                                  mat(adda+k)
	      mat(adda+k) = matmark
	    enddo
            info(ivt,3) = 0
	  endif
	endif

	if (info(ivt,1) == 8) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  iarloc = info(ivt,5) - ptrmyb
	  iarend = iarloc+lvt
	  irbmin = min(js-1+nofrows,lmyblk,iarend)
	  k = 0
	  do j = iarloc+1-js+1,irbmin-js+1
            k = k + 1
	    rbuf(j,iac+1) = rbuf(j,iac+1) + mat(adda+k)
	    mat(adda+k) = matmark
	  enddo
          info(ivt,3) = info(ivt,3) - k
          info(ivt,5) = info(ivt,5) + k
	endif

	if (info(ivt,1) == 9) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iarloc = info(ivt,5) + 1 - ptrmyb
	  indc   = info(ivt,6)
	  irbmin = min(js-1+nofrows,lmyblk)
	  if ((iarloc >= js) .and. (iarloc <= irbmin)) then
	    do k = 1,lvt
	      rbuf(iarloc-js+1,index(indc+k)) =
     *        rbuf(iarloc-js+1,index(indc+k)) + mat(adda+k)
	      mat(adda+k) = matmark
	      index(indc+k) = ixmark
	    enddo
            info(ivt,3) = 0
	  endif
	endif

	if (info(ivt,1) == 11) then
	  adda   = info(ivt,2)
	  lvt    = info(ivt,3)
	  iac    = info(ivt,4)
	  indr   = info(ivt,7)
	  k      = 1
	  irbmin = min(js-1+nofrows,lmyblk)
	  j      = index(indr+k) - ptrmyb - js+1
	  do while ((j <= irbmin-js+1) .and. (k <= lvt))
	    rbuf(j,iac+1) = rbuf(j,iac+1) + mat(adda+k)
	    mat(adda+k) = matmark
	    index(indr+k) = ixmark
	    k = k+1
	    j = index(indr+k) - ptrmyb - js+1
	  enddo
          info(ivt,3) = lvt - k + 1
	endif
      enddo

      R E T U R N
C------END OF FILL_BUF_INPL---------------------------------------
      E N D                                   
