
! Heapsort zum Sortieren eines Integer-Vektors

      subroutine HEAPSORTIX(isort,ixsort,N,lident)

!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1998 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************

      implicit none

      integer, intent(in) :: N
      integer, intent(inout) :: isort(N),ixsort(N)
      logical, intent(in) :: lident

      integer i, iswap, m, j, l

      if (lident) then
        do i = 1, N
          ixsort(i) = i
        end do
      endif

      do i = INT(N/2), 1, -1
        l = i 
        m = N
        call sink(isort,ixsort,N,l,m)
      end do
      do i = N, 2, -1
        iswap = isort(i)
        isort(i) = isort(1)
        isort(1) = iswap
        iswap = ixsort(i)
        ixsort(i) = ixsort(1)
        ixsort(1) = iswap

        l = 1
        m = i - 1 
        call sink(isort,ixsort,N,l,m)
      end do

      return

      contains

      subroutine sink(isort,ixsort,N,l,m)

         implicit none

         integer, intent(in) :: N 
         integer, intent(inout) :: isort(N),ixsort(N)
         integer, intent(inout) :: l, m

         integer :: iswap
! Sink-Prozedur fuer Heapsort
! Startparameter der Sink-Prozedur
         do while((2*l) <= m)
            j = 2*l
            if(j < m) then
               if(isort(j) < isort(j+1)) j = j + 1
            end if
            if(isort(l) < isort(j)) then
               iswap = isort(l)
               isort(l) = isort(j)
               isort(j) = iswap
               iswap = ixsort(l)
               ixsort(l) = ixsort(j)
               ixsort(j) = iswap
               l = j
            else 
               l = m
               exit 
            end if      
         end do
         return
      end subroutine sink

      end subroutine HEAPSORTIX
