!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine INFOSORT(info,ia1,nvt,iw,lout,myproc,nproc,
     *                    tids,nmsg,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   I N F O S O R T  sorts the array  <info>, if the matrix only  ***
!**                    uses the storage pattern 'packed row'.       ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(inout) ::  nmsg
      integer, intent(in) ::  ia1,nvt,nproc,myproc,lout
      integer, intent(out) ::  ierr
      integer, intent(inout) ::  iw(nvt,ia2+1),info(ia1,ia2)
      integer, intent(in) ::  tids(nproc)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolp>)                                   ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer    i,j

!
!**** START OF CALCULATION :
!     ---------------------
!

!     ierr  = 0

!**
!**   Sort array <info>
!**
      do i=1,nvt
        iw(i,1) = info(i,5)
      enddo

      call HEAPSORTIX(iw(1,1),iw(1,ia2+1),nvt,.true.)

      do j=1,ia2
        do i=1,nvt
          iw(i,j) = info(iw(i,ia2+1),j)
        enddo
      enddo

      do j=1,ia2
        do i=1,nvt
          info(i,j) = iw(i,j)
        enddo
      enddo

!     call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
!     if (iermax > 0) then
!       ierr = iermax
!       if (myproc == 1) then
!         write(lout,1000)
!         write(lout,1010) iermax-8200
!         write(lout,1020)
!       endif
!     endif
!1000 format(' **********************************************'/
!    &       ' ***  FATAL ERROR occured in INFOSORT:      ***')
!1010 format(' ***     Array <info> is not correctly      ***'/
!    &       ' ***     defined on processor ',i6,'        ***')
!1020 format(' **********************************************')

      R E T U R N
!------END OF INFOSORT--------------------------------------------
      E N D                                   
