!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine INFOSRT_WRAP(infoLU,ia1LU,nvtLU,iw,lout,myproc,
     *                        nproc,tids,nmsg,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   I N F O S R T _ W R A P  sorts the array  <infoLU>, if the    ***
!**                   matrix only uses the storage pattern          ***
!**                   'packed row'.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2000 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(inout) ::  nmsg
      integer, intent(in) ::  ia1LU,nvtLU,nproc,myproc,lout
      integer, intent(out) ::  ierr
      integer, intent(inout) ::  infoLU(ia1LU,ia2LU)
      integer, intent(inout) ::  iw(nvtLU,ia2LU+1)
      integer, intent(in) ::  tids(nproc)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <linsol>)                                   ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer    i,j

!
!**** START OF CALCULATION :
!     ---------------------
!

!     ierr  = 0

!**
!**   sort info-array
!**

      do i=1,nvtLU
        iw(i,1) = infoLU(i,3)
      enddo

      call HEAPSORTIX(iw(1,1),iw(1,ia2LU+1),nvtLU,.true.)

      do j=1,ia2LU
	do i=1,nvtLU
          iw(i,j) = infoLU(iw(i,ia2LU+1),j)
        enddo
      enddo

      do j=1,ia2LU
	do i=1,nvtLU
          infoLU(i,j) = iw(i,j)
        enddo
      enddo

! 999 call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
!     if (iermax > 0) then
!       ierr = iermax
!       if (myproc == 1) then
!         write(lout,1000)
!         write(lout,1010) iermax-8200
!         write(lout,1020)
!       endif
!     endif
!1000 format(' **********************************************'/
!    &       ' ***  FATAL ERROR occured in INFOSRT_WRAP:  ***')
!1010 format(' ***     Array <infoLU> is not correctly    ***'/
!    &       ' ***     defined on processor ',i6,'        ***')
!1020 format(' **********************************************')

      R E T U R N
!------END OF INFOSRT_WRAP--------------------------------------------
      E N D                                   
