C:::::      ,,,,,LL6AC_NC.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL6AC_NC(mat,x,c,ptsmyb,l,nvt,lmat,lindex,ia1,
     *                    info,index)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 6 A C _ N C   is the routine counting the              ***
C**                        multiplications per row without          *** 
C**                        communication: count++1, if MAT * x <> 0.***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1998 University Karlsruhe                      ***
C**    PROGRAMMER : H.Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           nvt, lmat, lindex, ia1, l
      integer           info(ia1,ia2), index(lindex)
      integer           ptsmyb,c(l)
      double precision  x(l), mat(lmat)
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i, k, jc, jr
      integer           typ,adda,lvt,iac,iar,iar1,indc,indr
      double precision  zero
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0.)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      do 100 k=1,nvt
C**                                                                 ***
         typ   =info(k,1)
         adda  =info(k,2)
         lvt   =info(k,3)
         iar1  =info(k,5)-ptsmyb
         iac   =info(k,4)
         iar   =info(k,5)
         indc  =info(k,6)
         indr  =info(k,7)
C**                                                                 ***
         if ((typ .eq. 2).or.(typ.eq.1)) then
           do   120   i = 1,lvt
	     if (mat(i+adda)*x(i+iac) .ne. zero)  
     *         c(i+iar1) = c(i+iar1) + 1
  120      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 3) then
      include "norec.h"
           do   130   i = 1,lvt
             jc = index(i+indc)
	     if (mat(i+adda)*x(jc+iac) .ne. zero)  
     *         c(jc+iar1) = c(jc+iar1) + 1
  130      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 4) then
           do   140   i = 1,lvt
             jc = index(i+indc)
	     if (mat(i+adda)*x(jc) .ne. zero)  
     *         c(i+iar1) = c(i+iar1) + 1
  140      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 5) then
      include "norec.h"
           do   150   i = 1,lvt
	     if (mat(i+adda)*x(i+iac) .ne. zero) then  
	       jr = index(i+indr)-ptsmyb
               c(jr) = c(jr) + 1
             endif
  150      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 6) then
      include "norec.h"
           do   160   i = 1,lvt
	     jc = index(i+indc)
	     if (mat(i+adda)*x(jc) .ne. zero) then 
               jr = index(i+indr)-ptsmyb
               c(jr) = c(jr) + 1
             endif
  160      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 7) then
	   do 170 i = 1,lvt
	     if (mat(i+adda)*x(iac+i) .ne. zero)
     *         c(iar1+1) = c(iar1+1) + 1
  170      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 8) then
	   do 180 i = 1,lvt
	     if (mat(i+adda)*x(iac+1) .ne. zero)
     *         c(iar1+i) = c(iar1+i) + 1
  180      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 9) then
	   do 190 i = 1,lvt
             jc = index(i+indc)
	     if (mat(i+adda)*x(jc) .ne. zero)
     *         c(iar1+1) = c(iar1+1) + 1
  190      continue
           goto 100
         endif
C**                                                                 ***
         if (typ .eq. 11) then
	   do 210 i = 1,lvt
	     if (mat(i+adda)*x(iac+1) .ne. zero) then
               jr = index(i+indr)-ptsmyb
	       c(jr) = c(jr) + 1
             endif
  210      continue
           goto 100
         endif
 100  continue
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LL6AC_NC-------------------------------------------------
      e    n    d
