!:::::      ,,,,,LL6ATXO.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LL6ATXO(mat,lmat,index,lindex,info,ia1,nvt,x,b,l,
     #                   ptsmyb,ptsmbk,lmatbk)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L L 6 A T X O   is the kernel routine for the matrix-      ***
!**                      vector-multiplication with the matrix      ***
!**                      MAT_transposed:                            ***
!**                      b = b + MAT_t * x .                        ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2001 University Karlsruhe                      ***
!**    PROGRAMMER : H.Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           nvt,lmat,lindex,ia1
      integer           info(ia1,ia2),index(lindex)
      integer           ptsmyb,l,ptsmbk,lmatbk
      double precision  b(l), x(l), mat(lmat)
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
!
      integer           i,jc,jr,k,imatcl,imatrl,first
      integer           typ,ptrmat,lvt,imatc,imatr,ptrixc,ptrixr
!**                                                                 ***
!**        CONSTANTS:                                               ***
!**        ---------                                                ***
!**                                                                 ***
      double precision, parameter ::  zero = 0.0
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      do k=1,nvt
        typ    = info(k,1)
        ptrmat = info(k,2)
        lvt    = info(k,3)
        imatc  = info(k,4)
        imatr  = info(k,5)
        imatcl = info(k,4) - ptsmbk
        imatrl = info(k,5) - ptsmyb
        ptrixc = info(k,6)
        ptrixr = info(k,7)
!**                                                                 ***
        if ((typ == 1) .or. (typ == 2)) then
          do i=1,lvt
            if ((imatcl+i > 0) .and. (imatcl+i <= lmatbk)) then
              b(i+imatcl) = b(i+imatcl) + mat(i+ptrmat)*x(i+imatrl)
            endif
          enddo 
          cycle
        endif
!**                                                                 ***
        if (typ == 3) then
          include "norec.h"
          do i=1,lvt
	    jc = imatcl + index(i+ptrixc)
            if ((jc > 0) .and. (jc <= lmatbk)) then
              b(jc) = b(jc) + mat(i+ptrmat)*x(jc-imatcl+imatrl)
            endif
          enddo
          cycle
        endif
!**                                                                 ***
        if (typ == 4) then
          do i=1,lvt
	    jc = index(i+ptrixc)-ptsmbk
            if ((jc > 0) .and. (jc <= lmatbk)) then
              b(jc) = b(jc) + mat(i+ptrmat)*x(i+imatrl)
            endif
          enddo
          cycle
        endif
!**                                                                 ***
        if (typ == 5) then
          include "norec.h"
          do i=1,lvt
	    jr = index(i+ptrixr)-ptsmyb
            if ((jr > 0) .and. (jr <= lmatbk)) then
              b(i+imatcl) = b(i+imatcl) + mat(i+ptrmat)*x(jr)
            endif
          enddo
          cycle
        endif
!**                                                                 ***
        if (typ == 6) then
          do i=1,lvt
	    jc = index(i+ptrixc)-ptsmbk
	    jr = index(i+ptrixr)-ptsmyb
            if ((jr > 0) .and. (jr <= lmatbk) .and.
     &          (jc > 0) .and. (jc <= lmatbk)) then
              b(jc) = b(jc) + mat(i+ptrmat)*x(jr)
            endif
          enddo
          cycle
        endif
!**                                                                 ***
        if (typ == 7) then
	  do i=1,lvt
            if ((imatcl+i > 0) .and. (imatcl+i <= lmatbk)) then
	      b(imatcl+i) = b(imatcl+i) + mat(i+ptrmat)*x(imatrl+1)
            endif
          enddo
	  cycle
        endif
!**                                                                 ***
        if (typ == 8) then
	  do i=1,lvt
            if ((imatrl+i > 0) .and. (imatrl+i <= lmatbk)) then
	      b(imatcl+1) = b(imatcl+1) + mat(i+ptrmat)*x(imatrl+i)
            endif
          enddo
	  cycle
        endif
!**                                                                 ***
        if (typ == 9) then
          include "norec.h"
	  do i=1,lvt
	    jc = index(i+ptrixc)-ptsmbk
            if ((jc > 0) .and. (jc <= lmatbk)) then
	      b(jc) = b(jc) + mat(i+ptrmat)*x(imatrl+1)
            endif
          enddo
	  cycle
        endif
!**                                                                 ***
        if (typ == 11) then
          include "norec.h"
	  do i=1,lvt
	    jr = index(i+ptrixr)-ptsmyb
            if ((jr > 0) .and. (jr <= lmatbk)) then
	      b(imatcl+1) = b(imatcl+1) + mat(i+ptrmat)*x(jr)
            endif
          enddo
        endif
      enddo
!
!**** END OF CALCULATION
!     ------------------
!
      r e t u r n
!-----END OF LL6ATXO---------------------------------------------------
      e    n    d
