!:::::      ,,,,,LL6AX9.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LL6AX9(mat,lmat,index,lindex,info,ia1,nvt,b,x,l,
     #                  ptsmyb,ptsmbk,lmatbk)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L L 6 A X 9   is the kernel routine for the matrix-        ***
!**                    vector-multiplication with storage pattern   ***
!**                    "packed row":                                ***
!**                    b = b + MAT * x .                            ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1994 University Karlsruhe                      ***
!**    PROGRAMMER : P.STERNECKER + L.GROSS + C.ROLL + H.Haefner     ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           nvt, lmat, lindex, ia1
      integer           info(ia1,ia2), index(lindex)
      integer           ptsmyb,ptsmbk,lmatbk,l
      double precision  b(l), x(l), mat(lmat)
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i, k, jc
      integer           typ,adda,lvt,iar1,indc
!**                                                                 ***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      do k=1,nvt
         typ   = info(k,1)
         adda  = info(k,2)
         lvt   = info(k,3)
         iar1  = info(k,5)-ptsmyb
         indc  = info(k,6)
         if (typ == 9) then
	   do i = 1,lvt
             jc = index(i+indc)-ptsmbk
	     if ((jc > 0) .and. (jc <= lmatbk)) then
	       b(iar1+1) = b(iar1+1) + mat(i+adda)*x(jc) 
	     endif
           enddo
         endif
      enddo
!
!**** END OF CALCULATION
!     ------------------
!
      r e t u r n
!-----END OF LL6AX9----------------------------------------------------
      e    n    d
