C:::::      ,,,,,LSPCHK.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LSPCHK(lmat,lindex,l,nproc,nvt,info,ia1,ilin,ierr,
     *                  tids,lmatbk,lmain,lsym)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     L S P C H K :  CHECKS LSOLP PARAMETERS CONCERNING THE       ***
c**                    MATRIX, THE OUTPUT AND NUMBER OF PROCESSORS  ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1998 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer nproc,ia1,ierr,lmat,lindex,l
      integer info(ia1,ia2),ilin(nilin),lmatbk(nproc),tids(nproc)
      logical lmain,lsym
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <lsolp>)                                    ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    ione,i,lout,myproc,nmsg,nvt,iermax,ihelp1,maxi,maxind
      integer    ihelp2,optim,ihelp(3),idoku,iertag,isprec,nrhs
      integer    bwoalg,lmyblk,maxadd,maxval,minval
      logical    lmethok,lprecon
      parameter (ione=1)
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      nmsg   = ilin(3)
      nrhs   = ilin(4)
      isprec = ilin(6)
      lout   = ilin(12)
      idoku  = ilin(13)
      myproc = ilin(17)
      optim  = ilin(20)
      bwoalg = ilin(22)
      iertag = ilin(39)
      ierr   = 0000
      iermax = 0000
      lmyblk = lmatbk(myproc)
C**                                                                 ***
C***  START OF PARAMETER CHECK                                      ***
C**                                                                 ***
      if (lout < 0) then
        ierr  = 8001
	if (myproc == 1) then
	  write(*,1010)
	  write(*,1016)
	  write(*,1020)
        endif
        goto 999
      endif
c**
      if (bwoalg < 0 .or. bwoalg > 4) then
        ierr  = 8022
	if (myproc == 1) then
	  write(lout,1010)
	  write(lout,1031)
	  write(lout,1020)
        endif
        goto 999
      endif
c**
      if (nproc < 1) then
        ierr  = 8002
	write(lout,1010)
	write(lout,1017)
	write(lout,1020)
        goto 999
      endif
c**
      if (nproc > maxnpe) then
        ierr  = 8003
	if (myproc == 1) then
	  write(lout,1010)
	  write(lout,1018) maxnpe
	  write(lout,1020)
        endif
        goto 999
      endif
c**
      lmethok = ((ilin(1) == 1) .or. (ilin(1) == 2) .or.
     &           (ilin(1) == 6) .or. (ilin(1) == 7))
      lprecon = ((ilin(8) == 63).or.(ilin(8) == 66).or.(ilin(8) == 69)
     &       .or.(ilin(8) == 72).or.(ilin(8) == 75).or.(ilin(8) == 78))
      if (.not. lsym .and. lprecon .and. .not. lmethok) then
	if (myproc == 1) then
	  write(lout,1011)
	  write(lout,1012)
	  write(lout,1020)
        endif
	ilin(1) = 7
      endif
      if (lsym .and. lprecon .and. ilin(1) /= 100) then
	if (myproc == 1) then
	  write(lout,1011)
	  write(lout,1013)
	  write(lout,1020)
        endif
	ilin(1) = 100
      endif
c**
c***  check main diagonal
c**
      ihelp1 = 0
      do i=1,nvt
	if (info(i,1) == 1) ihelp1 = 1
      enddo
      call LL4INM(ione,ione,ione,ihelp1,maxval,ihelp2,myproc,
     *            nproc,tids,nmsg)
      call LL4MIN(ione,ione,ione,ihelp1,minval,ihelp2,myproc,
     *            nproc,tids,nmsg)
      if (maxval /= minval) then
        ierr = 8010
	if (myproc == 1) then
          write(lout,1010)
          write(lout,1045)
          write(lout,1020)
        endif
        goto 999
      endif
      if (ihelp1 == 0) lmain = .false.
      if (ihelp1 == 1) lmain = .true.

      if (lsym .and. .not. lmain) then
	ihelp1 = nvt + 1
      else
	ihelp1 = nvt
      endif
      if (ihelp1 > ia1) then
        ierr  = 8004
	write(lout,1010)
	write(lout,1014) myproc
	write(lout,1020)
        goto 999
      endif

      if (lsym .and. .not. lmain .and. (nrhs == -1)) then
        ierr  = 8007
	write(lout,1010)
	write(lout,1015)
	write(lout,1020)
        goto 999
      endif
c**
c***********************************************************************
c**    Size of matrix, index array and info array on one processor   ***
c***********************************************************************

      if (nproc == 1) then
       if (ilin(50) /= -1) then
c** Size of matrix on processor 1
        maxadd = 0
        do i = 1,nvt
	 if (info(i,2) > maxadd) then
	   maxadd = info(i,2)
	   maxi   = i
	 endif
        enddo
        maxi=max(maxi,1)
        ilin(30) = info(maxi,2) + info(maxi,3)
	ilin(33) = ilin(30)
c** Size of index array  on processor 1
        maxind = -1
        do 100 i = 1,nvt
         if (info(i,1) == 3 .or. info(i,1) == 4 .or.
     &      info(i,1) == 9 .or.
     &      info(i,1) == 30 .or. info(i,1) == 40 .or.
     &      info(i,1) == 90) then
          if (info(i,6) > maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
         endif
         if (info(i,1) == 5 .or. info(i,1) == 11 .or.
     &      info(i,1) == 50 .or. info(i,1) == 110) then
          if (info(i,7) > maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
         endif
         if (info(i,1) == 6 .or. info(i,1) == 60) then
          if (info(i,6) > maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
          if (info(i,7) > maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
         endif
  100   continue
        if (maxind > -1) then
         ilin(31) = maxind + info(maxi,3)
        else
	 ilin(31) = 0
        endif
	ilin(34) = ilin(31)

c** Size of info array on processor 1
        ilin(32) = nvt
        ilin(35) = ilin(32)
       endif
c**
       if (lsym .and. .not. lmain) then
	 ihelp1 = ilin(30) + lmyblk
       else
	 ihelp1 = ilin(30)
       endif
       if (lmat < ihelp1) then
         ierr  = 8005
	 write(lout,1010)
	 write(lout,1021)
	 write(lout,1020)
         goto 999
       endif
c**
       if (lindex < ilin(31)) then
         ierr  = 8006
	 write(lout,1010)
	 write(lout,1022)
	 write(lout,1020)
         goto 999
       endif
c**
       if ((lprecon .and. isprec < 10) .or. (bwoalg > 0) .or.
     &    (mod(optim,100000) >= 10000) .or.
     &    (mod(optim,200000) >= 100000)) then
         if (lindex < lmat) then
           ierr  = 8006
	   write(lout,1010)
	   write(lout,1025)
	   write(lout,1020)
           goto 999
         endif
       endif
      endif
c**
c***********************************************************************
c**    Size of matrix, index array and info array on many processors ***
c***********************************************************************

      if (nproc > 1) then
c** Size of matrix on local processor
       if (iertag == 0) then
         maxadd = 0
         do i = 1,nvt
	   if (info(i,2) > maxadd) then
	     maxadd = info(i,2)
	     maxi   = i
	   endif
         enddo
         maxi=max(maxi,1)
         ilin(33) = info(maxi,2) + info(maxi,3)
       endif
c** Size of index array  on local processor
       if (iertag == 0) then
         maxind = -1
         do i = 1,nvt
          if (info(i,1) == 3 .or. info(i,1) == 4 .or.
     &        info(i,1) == 9 .or.
     &        info(i,1) == 30 .or. info(i,1) == 40 .or.
     &        info(i,1) == 90) then
            if (info(i,6) > maxind) then
              maxind = info(i,6)
              maxi   = i
            endif
          endif
          if (info(i,1) == 5 .or. info(i,1) == 11 .or.
     &        info(i,1) == 50 .or. info(i,1) == 110) then
            if (info(i,7) > maxind) then
              maxind = info(i,7)
              maxi   = i
            endif
          endif
          if (info(i,1) == 6 .or. info(i,1) == 60) then
            if (info(i,6) > maxind) then
              maxind = info(i,6)
              maxi   = i
            endif
            if (info(i,7) > maxind) then
              maxind = info(i,7)
              maxi   = i
            endif
          endif
         enddo
         if (maxind > -1) then
           ilin(34) = maxind + info(maxi,3)
         else
	   ilin(34) = 0
         endif
       endif
c** Size of info array on processor 1
       ilin(35) = nvt
       ilin(38) = INT(REAL(l)/(REAL(nproc)*msgblkfac))
       if (ilin(38) < 1) ilin(38) = 1
       if (ilin(38) > l) ilin(38) = l

c** Globalization of the local variables ilin(33),ilin(34) and ilin(35)
       call LL4ISM(ione,3,ione,ilin(33),ilin(30),ihelp,myproc,nproc,
     *             tids,nmsg)
c**
       if (lsym .and. .not. lmain) then
	 ihelp1 = ilin(33) + lmyblk
       else
	 ihelp1 = ilin(33)
       endif
       if (lmat < ihelp1) then
         ierr  = 8095
	 if (idoku >= 0) then
	   if (myproc == 1) then
       	     write(lout,1010)
	     write(lout,1023) myproc
	     write(lout,1020)
	   endif
	 else
       	   write(lout,1010)
	   write(lout,1023) myproc
	   write(lout,1020)
	 endif
       endif
c**
       if (lindex < ilin(34)) then
         ierr  = 8096
	 if (idoku >= 0) then
	   if (myproc == 1) then
       	     write(lout,1010)
	     write(lout,1024) myproc
	     write(lout,1020)
	   endif
	 else
       	   write(lout,1010)
	   write(lout,1024) myproc
	   write(lout,1020)
	 endif
       endif
c**
       if ((lprecon .and. isprec < 10) .or. (bwoalg > 0) .or.
     &    (mod(optim,100000) >= 10000) .or.
     &    (mod(optim,200000) >= 100000)) then
         if (lindex < lmat) then
           ierr  = 8096
!          if (idoku >= 0) then
!            if (myproc == 1) then
!              write(lout,1010)
!              write(lout,1026) myproc
!              write(lout,1020)
!            endif
!          else
	     write(lout,1010)
	     write(lout,1026) myproc
	     write(lout,1020)
!          endif
         endif
       endif
      endif   ! (nproc > 1)

      if (mod(ilin(19),1000) >= 100) then
        if (ilin(43) < 21 .or. ilin(43) > 99) then
          if (myproc == 1) then
            write(lout,1011)
            write(lout,1019)
            write(lout,1020)
          endif
          ilin(43) = 23
        endif
      endif

      if (mod(ilin(19),100000) >= 10000) then
        if (ilin(44) < 21 .or. ilin(44) > 99) then
          if (myproc == 1) then
            write(lout,1011)
            write(lout,1112)
            write(lout,1020)
          endif
          ilin(44) = 24
        endif
      endif

      if (mod(ilin(20),200000) >= 100000) then
        if (ilin(45) < 21 .or. ilin(45) > 99) then
          if (myproc == 1) then
            write(lout,1011)
            write(lout,1113)
            write(lout,1020)
          endif
          ilin(45) = 25
        endif
      endif


  999 call LL4INM(ione,ione,ione,ierr,iermax,ihelp1,myproc,nproc,
     *            tids,nmsg)
      ierr = iermax
      ilin(3) = nmsg
      ilin(50)= -2
c**
c*** FORMATS
c**
 1010 format(' **************************************************'/
     &       ' ***  ERROR detected (LSPCHK):                  ***')
 1011 format(' **************************************************'/
     &       ' ***  WARNING from LSPCHK:                      ***')
 1012 format(' ***   no allowed solution method in connection ***'/
     &       ' ***   with Gauss preconditioning chosen --->   ***'/
     &       ' ***   solution method is set to BiCGSTAB2!     ***')
 1013 format(' ***   no allowed solution method in connection ***'/
     &       ' ***   with Cholesky preconditioner chosen ---> ***'/
     &       ' ***   solution method is set to classical CG!  ***')
 1014 format(' ***   first dim. of array INFO on proc. ',i6,' ***'/
     &       ' ***   too small: ia1 is less than nvt.         ***')
 1015 format(' ***   matrix is symmetric and no main diagonal ***'/
     &       ' ***   exists! Then it is not allowed to set    ***'/
     &       ' ***   LINSOL_NUMBER_RHS = -1 (ilin(4) = -1).   ***')
 1016 format(' ***   output unit number LOUT has to           ***'/
     &       ' ***   be non-negative.                         ***')
 1017 format(' ***   number of processors NPROC has           ***'/
     &       ' ***   to be greater than zero.                 ***')
 1018 format(' ***   number of processors NPROC has           ***'/
     &       ' ***   to be less or equal than ',i6,'          ***')
 1019 format(' ***   parameter <ilin(43)> is set to 23!       ***')
 1112 format(' ***   parameter <ilin(44)> is set to 24!       ***')
 1113 format(' ***   parameter <ilin(45)> is set to 25!       ***')
 1020 format(' **************************************************'/)
 1021 format(' ***   array MAT too small:  l m a t            ***'/
     &       ' ***   is less than size of (optimized) matrix. ***')
 1022 format(' ***   array INDEX too small: l i n d e x       ***'/
     &       ' ***   is less than size of index array.        ***')
 1023 format(' ***   array MAT too small on processor  ',i6,' ***'/
     &       ' ***   lmat is less than size of (opt.) matrix. ***')
 1024 format(' ***   array INDEX too small on proc.    ',i6,' ***'/
     &       ' ***   lindex is less than size of index array. ***')
 1025 format(' ***   array INDEX too small: l i n d e x       ***'/
     &       ' ***   is less than size of matrix array.       ***')
 1026 format(' ***   array INDEX too small on proc.    ',i6,' ***'/
     &       ' ***   lindex is less than size of matrix array ***')
 1031 format(' ***   b w o a l g must be greater than zero    ***'/
     &       ' ***   and less than five.                      ***')
 1045 format(' ***   on some processors the main diagonal     ***'/
     &       ' ***   is present, on some it is absent!        ***')
c**
c***
c**
      r e t u r n
c-----END OF LSPCHK---------------------------------------------------
      e n d
