!:::::      ,,,,,LSPDIA.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPDIA(lmat,lindex,ldw,l,imain,main,ia1,mat,dw,info,
     #                  ilin,index,tids,nproc,myproc,nmsg,
     #                  lmyblk,ptsmyb)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P D I A   stores the coefficients of the main diagonal ***
!**                    of the matrix MAT into a buffer of length l. ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER :  H. Haefner                                     ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                    ***
!**   THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           lmat,lindex,ldw,l,main,ia1,nproc,
     *                  myproc,lmyblk,ptsmyb,imain,nmsg
      double precision  dw(ldw),mat(lmat)
      integer           info(ia1,ia2),ilin(nilin)
      integer           index(lindex),tids(nproc)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**                                                                 ***
!**   see Manual Pages <lsolpp>                                     ***
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,jc,jr,k,adda,lvt,indc,indr
      integer           couold,iac,iac1,iar,iar1,imax,lout,nvt
      integer           idoku,iinp(2*ntyp),isum(2*ntyp),ihlp(2*ntyp)
      integer           counvt(ntyp),counel(ntyp)
      real              percnt

      integer,parameter ::  maxout = 50
      double precision,parameter ::  zero = 0.0
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      nvt   = ilin(5)
      lout  = ilin(12)
      idoku = ilin(13)

      if ((idoku < 0) .and. (idoku >= -maxout)) then
         write(lout,1000)
         write(lout,1001)
      endif
      if ((idoku > 0) .and. (idoku <= maxout)) then
        if (myproc == 1) then
	  write(lout,1000)
	  write(lout,1001)
        endif
      endif

      do i=1,l
        dw(main+i-1) = zero
      enddo
!**                                                                 ***
      counvt = 0
      counel = 0

      do k=1,nvt
        if (info(k,1) == 2) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac1 = info(k,4)-ptsmyb
	  iar1 = info(k,5)-ptsmyb
	  if (iac1 /= iar1) cycle
	  counvt(2) = counvt(2) + 1
          do i=1,lvt
            dw(main+iar1+i-1) = dw(main+iar1+i-1) + mat(i+adda)
	    counel(2) = counel(2) + 1
          enddo
        endif
!**
        if (info(k,1) == 3) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac1 = info(k,4)-ptsmyb
	  iar1 = info(k,5)-ptsmyb
	  if (iac1 /= iar1) cycle
	  counvt(3) = counvt(3) + 1
	  indc = info(k,6)
          do i=1,lvt
	    jc = index(i+indc)
            dw(main+iar1+jc-1) = dw(main+iar1+jc-1) + mat(i+adda)
	    counel(3) = counel(3) + 1
          enddo
        endif
!**
        if (info(k,1) == 4) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iar  = info(k,5)
	  iar1 = info(k,5)-ptsmyb
	  indc = info(k,6)
          couold = counel(4)
          do i=1,lvt
	    jc = index(i+indc)
	    if (iar+i == jc) then
              dw(main+iar1+i-1) = dw(main+iar1+i-1) + mat(i+adda)
	      counel(4) = counel(4) + 1
            endif
          enddo
	  if (counel(4) > couold) counvt(4) = counvt(4) + 1
        endif
!**
        if (info(k,1) == 5) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac  = info(k,4)
	  iac1 = info(k,4)-ptsmyb
	  indr = info(k,7)
          couold = counel(5)
          do i=1,lvt
	    jr = index(i+indr)
	    if (iac+i == jr) then
              dw(main+iac1+i-1) = dw(main+iac1+i-1) + mat(i+adda)
	      counel(5) = counel(5) + 1
            endif
          enddo
	  if (counel(5) > couold) counvt(5) = counvt(5) + 1
        endif
!**
        if (info(k,1) == 6) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  indc = info(k,6)
	  indr = info(k,7)
          couold = counel(6)
          do i=1,lvt
	    jc = index(i+indc)
	    jr = index(i+indr)
	    if (jc == jr) then
              dw(main+jr-ptsmyb-1) = dw(main+jr-ptsmyb-1) + mat(i+adda)
	      counel(6) = counel(6) + 1
            endif
          enddo
	  if (counel(6) > couold) counvt(6) = counvt(6) + 1
        endif
!**
        if (info(k,1) == 7) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac1 = info(k,4)-ptsmyb
	  iar1 = info(k,5)-ptsmyb
	  if ((iac1 > iar1) .or. (iac1+lvt < iar1+1)) cycle
          couold = counel(7)
          do i=1,lvt
	    if (iac1+i == iar1+1) then
              dw(main+iar1) = dw(main+iar1) + mat(i+adda)
	      counel(7) = counel(7) + 1
            endif
          enddo
	  if (counel(7) > couold) counvt(7) = counvt(7) + 1
        endif
!**
        if (info(k,1) == 8) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac1 = info(k,4)-ptsmyb
	  iar1 = info(k,5)-ptsmyb
	  if ((iar1 > iac1) .or. (iar1+lvt < iac1+1)) cycle
          couold = counel(8)
          do i=1,lvt
	    if (iar1+i == iac1+1) then
              dw(main+iac1) = dw(main+iac1) + mat(i+adda)
	      counel(8) = counel(8) + 1
            endif
          enddo
	  if (counel(8) > couold) counvt(8) = counvt(8) + 1
        endif
!**
        if (info(k,1) == 9) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iar  = info(k,5)
	  iar1 = info(k,5)-ptsmyb
	  indc = info(k,6)
          couold = counel(9)
          do i=1,lvt
	    jc = index(i+indc)
	    if (iar+1 == jc) then
              dw(main+iar1) = dw(main+iar1) + mat(i+adda)
	      counel(9) = counel(9) + 1
            endif
          enddo
	  if (counel(9) > couold) counvt(9) = counvt(9) + 1
        endif
!**
        if (info(k,1) == 11) then
	  adda = info(k,2)
	  lvt  = info(k,3)
	  iac  = info(k,4)
	  iac1 = info(k,4)-ptsmyb
	  indr = info(k,7)
          couold = counel(11)
          do i=1,lvt
	    jr = index(i+indr)
	    if (iac+1 == jr) then
              dw(main+iac1) = dw(main+iac1) + mat(i+adda)
	      counel(11) = counel(11) + 1
            endif
          enddo
	  if (counel(11) > couold) counvt(11) = counvt(11) + 1
        endif
      enddo     ! k=1,nvt

      iinp(1:ntyp) = counvt(1:ntyp)
      iinp(ntyp+1:2*ntyp) = counel(1:ntyp)
      call LL4ISM(1,2*ntyp,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)

      do i=2,ntyp
	if (i /= 10 .and. isum(i) /= 0) then
          if ((idoku < 0) .and. (idoku > -3))
     &      write(lout,1002) i,isum(i),isum(ntyp+i)
          if ((idoku > 0) .and. (idoku < 3)) then
            if (myproc == 1) write(lout,1002) i,isum(i),isum(ntyp+i)
          endif
        endif
      enddo

      counel(1) = 0
      do i=1,lmyblk
        if (dw(main+i-1) /= zero) then
	  counel(1) = counel(1) + 1
        endif
      enddo
      call LL4ISM(1,1,1,counel(1),isum(1),ihlp(1),myproc,nproc,
     &            tids,nmsg)
      imain = isum(1)

      percnt = REAL(isum(1))/REAL(ilin(36))
      percnt = percnt*100
      if ((idoku < 0) .and. (idoku >= -maxout)) then
        write(lout,1020) percnt
        write(lout,1021)
      endif
      if ((idoku > 0) .and. (idoku <= maxout)) then
        if (myproc == 1) then
	  write(lout,1020) percnt
	  write(lout,1021)
        endif
      endif


 1000 format(/'   -------------------------------------------------- ')
 1001 format('  ||  NO explicit main diagonal (MD) for            ||',/
     &       '  ||  normalization !!!                             ||')
 1002 format('  ||  Storage pattern ',i6,' :                      ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1020 format('  ||  Collective (over all storage patterns) :      ||',/
     &       '  ||   percentage of occupancy of the MD            ||',/
     &       '  ||   with non-zero elements ............ : ',f6.1,' ||')
 1021 format('   -------------------------------------------------- '/)

!**                                                                 ***
!**** END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**                                                                 ***
      r e t u r n
!-----END OF LSPDIA----------------------------------------------------
      e    n    d
