!:::::      ,,,,,LSPDIA.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPDIA(lmat,lindex,ldw,l,imain,main,nvtLU,ia1LU,mat,
     #                  dw,infoLU,ilin,index,tids,nproc,myproc,nmsg,
     #                  lmyblk,ptsmyb)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P D I A   stores the coefficients of the main diagonal ***
!**                    of the matrix MAT into a buffer of length l. ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER :  H. Haefner                                     ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                    ***
!**   THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.               ***
!**                                                                 ***
      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      USE constants

      integer           lmat,lindex,ldw,l,main,ia1LU,nproc,nvtLU,
     *                  myproc,lmyblk,ptsmyb,imain,nmsg
      double precision  dw(ldw),mat(lmat)
      integer           infoLU(ia1LU,ia2LU),ilin(nilin)
      integer           index(lindex),tids(nproc)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**                                                                 ***
!**   see Manual Pages <lsolpp>                                     ***
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,jc,jr,k,adda,lvt,indc,indr
      integer           couold,iac,iac1,iar,iar1,imax,lout
      integer           idoku,isum,ihlp
      integer           counvt,counel
      real              percnt

      integer,parameter ::  maxout = 50
      double precision,parameter ::  zero = 0.0
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      lout  = ilin(12)
      idoku = ilin(13)

      if ((idoku < 0) .and. (idoku >= -maxout)) then
         write(lout,1000)
         write(lout,1001)
      endif
      if ((idoku > 0) .and. (idoku <= maxout)) then
        if (myproc == 1) then
	  write(lout,1000)
	  write(lout,1001)
        endif
      endif

      do i=1,l
        dw(main+i-1) = zero
      enddo
!**                                                                 ***
      counvt = 0
      counel = 0

      do k=1,nvtLU
	adda = infoLU(k,1)
	lvt  = infoLU(k,2)
	iar  = infoLU(k,3)
	iar1 = infoLU(k,3)-ptsmyb
	indc = adda
        couold = counel
        do i=1,lvt
	  jc = index(i+indc)
	  if (iar+1 == jc) then
            dw(main+iar1) = dw(main+iar1) + mat(i+adda)
	    counel = counel + 1
          endif
        enddo
	if (counel > couold) counvt = counvt + 1
      enddo

      counel = 0
      do i=1,lmyblk
        if (dw(main+i-1) /= zero) then
	  counel = counel + 1
        endif
      enddo
      call LL4ISM(1,1,1,counel,isum,ihlp,myproc,nproc,
     &            tids,nmsg)
      imain = isum

      percnt = float(isum)/float(ilin(36))
      percnt = percnt*100
      if ((idoku < 0) .and. (idoku >= -maxout)) then
        write(lout,1020) percnt
        write(lout,1021)
      endif
      if ((idoku > 0) .and. (idoku <= maxout)) then
        if (myproc == 1) then
	  write(lout,1020) percnt
	  write(lout,1021)
        endif
      endif


 1000 format(/'  ***************************************************')
 1001 format('  *** NO explicit main diagonal (MD) for          ***',/
     &       '  *** Normalization !!!                           ***')
 1020 format('  ***  ------->                                   ***',/
     &       '  ***   ',f6.1,' percent of the MD are filled       ***',/
     &       '  ***          with non-zero elements !           ***')
 1021 format('  ***************************************************'/)

!**                                                                 ***
!**** END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**                                                                 ***
      r e t u r n
!-----END OF LSPDIA----------------------------------------------------
      e    n    d
