!:::::      ,,,,,LSPNORM.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPNORM(mat,lmat,index,lindex,info,ia1,l,
     &                   pmat,lpmat,pix,lpix,infoLU,ia1LU,nvtLU,
     &                   norm,dw,ldw,lsym,ilin,lmatbk,ptrmbk,jump,tids,
     &                   myproc,nproc,nmsg,iconv,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     L S P N O R M   computes the normalization before the       ***
!**                     vector terms of the matrix are partitioned. ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
!     USE solex
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer,intent(in)    ::  lmat,lindex,l,ldw,ia1,nproc,myproc
      integer,intent(in)    ::  lpmat,lpix,ia1LU,nvtLU
      integer,intent(inout) ::  nmsg
      integer,intent(out)   ::  iconv,ierr
      integer,intent(in)    ::  index(lindex),info(ia1,ia2)
      integer,intent(inout) ::  pix(lpix),infoLU(ia1LU,ia2LU)
      integer,intent(in)    ::  lmatbk(nproc),ptrmbk(nproc+1)
      integer,intent(in)    ::  jump(nproc),tids(nproc)
      integer,intent(inout) ::  ilin(nilin)
      double precision,intent(in)    ::  mat(lmat)
      double precision,intent(inout) ::  dw(ldw),norm(l),pmat(lpmat)
      logical,intent(in)    ::  lsym
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolpp>)                                   ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer            adda,i,ione,k,lout,ibcom,inrow,main,nvt,
     &                   lmyblk,ptsmyb,iermax,ihelp,typ,imain,igmain,
     &                   ierproc
      double precision   one,zero
      logical            lerr,lmain
      external           LSPRST,LSPSST,LSPAP

!**                                                                 ***
!**      CONSTANTS :                                                ***
!**      -----------                                                ***
!**                                                                 ***
      parameter (zero = 0.0, one = 1.0, ione = 1)
!
!
!**** START OF CALCULATION :
!     ---------------------
!
      ierr  = 0
      iconv = 0
!
      inrow  = 0
      nvt    = ilin(5)
      lout   = ilin(12)
      lmyblk = lmatbk(myproc)
      ptsmyb = ptrmbk(myproc)
      main   = 1
      ibcom  = l+1  
      imain  = 0
      lmain  = .false.

      do k=1,nvt
	if (info(k,1) == 1) then
	  lmain = .true.
          if ((mod(ilin(6),10) == 0) .and. (ilin(15) /= 0)) then
            adda = info(k,2)
	    do i=1,lmyblk
	      dw(i+main-1) = mat(i+adda)
            enddo
	    do i=1,lmyblk
	      if (dw(i+main-1) /= zero) imain =imain + 1
            enddo
            call LL4ISM(1,1,1,imain,igmain,ihelp,myproc,nproc,
     &                  tids,nmsg)
	    if (ilin(15) == 2 .or. ilin(15) == 12 .or. ilin(15) == 4
     &          .or. ilin(15) == 14) then 
	      if (igmain == 0) then
	        ierr = 1100
	        goto 888
	      endif
	      if (igmain /= ilin(36)) then
	        ierr = 1101
	        goto 888
	      endif
            endif
          endif
        endif
      enddo
      if (.not. lmain) then
        if ((mod(ilin(6),10) == 0) .and. (ilin(15) /= 0)) then
          call LSPDIA(lmat,lindex,ldw,l,igmain,main,ia1,mat,dw,info,
     &                ilin,index,tids,nproc,myproc,nmsg,lmyblk,ptsmyb)
	  if (ilin(15) == 2 .or. ilin(15) == 12
     &        .or. ilin(15) == 4 .or. ilin(15) == 14) then 
	    if (igmain == 0) then
	      ierr = 1100
	      goto 888
	    endif
	    if (igmain /= ilin(36)) then
	      ierr = 1101
	      goto 888
	    endif
	  endif
	endif
      endif
!**                                                                 ***
!**                                                                 ***
!**   COMPUTE NRMCONDITIONING MATRIX IF WANTED :                    ***
!**   (IF ILIN(6)>0 THEN THE MATRIX IS ALREADY NORMALIZED           ***
!**    AND ONLY THE RIGHT HAND SIDE HAS TO BE NORMALIZED)           ***
!**   ---------------------------------------------------------     ***
!**    NRMC*MAT*NRMC*NRMC^-1*x = NRMC*b <==>                        ***
!**         MAT~    *   x~     =   b~    ==>                        ***
!**                     x~     = NRMC^-1*x                          ***
!**                                                                 ***

  111 continue
!**                                                                 ***
      if (mod(ilin(6),10) == 0) then
!**                                                                 ***
!**   Normalization by row sum                                      ***
!**                                                                 ***
         if ((ilin(15) == 1) .or. (ilin(15) == 11)) then
	    if (ilin(13) < 0) write(lout,1351)
	    if (ilin(13) > 0) then
	       if (myproc == 1) write(lout,1351)
            endif
            call LSPRSA(mat,lmat,index,lindex,info,ia1,norm,l,
     &                  ilin,ptsmyb) 
            if (lsym) then
              call LL3ATXO(LSPRST,mat,norm,norm,dw(ibcom),
     &                     ptrmbk,lmatbk,l,nproc,tids,
     &                     myproc,jump,.true.,nvt,lmat,lindex,ia1,info,
     &                     index,nmsg)
            endif
	    lerr = .false.
	    do i=1,lmyblk
	      if (norm(i) > zero) then
	        norm(i) = sign(one,dw(i+main-1))/norm(i)
              else
	        lerr    = .true.
	        ierproc = myproc
	        inrow   = i+ptsmyb
              endif
            enddo
	    if (lerr) then
	      ierr = 1102
            endif
         endif

!**                                                                 ***
!**   Normalization by diagonal element                             ***
!**                                                                 ***
         if ((ilin(15) == 2) .or. (ilin(15) == 12)) then
	    if (ilin(13) < 0) write(lout,1352)
	    if (ilin(13) > 0) then
	       if (myproc == 1) write(lout,1352)
            endif
	    lerr = .false.
	    do i=1,lmyblk
	      if (dw(i+main-1) /= zero) then
	        norm(i) = 1./dw(i+main-1)
              else
	        lerr    = .true.
	        ierproc = myproc
	        inrow   = i+ptsmyb
              endif
            enddo
	    if (lerr) then
	      ierr = 1101
            endif
         endif

!**                                                                 ***
!**   Normalization by square sum                                   ***
!**                                                                 ***
         if ((ilin(15) == 3) .or. (ilin(15) == 13)) then
	    if (ilin(13) < 0) write(lout,1353)
	    if (ilin(13) > 0) then
	       if (myproc == 1) write(lout,1353)
            endif
            call LSPSSA(mat,lmat,index,lindex,info,ia1,norm,l,
     &                  ilin,ptsmyb) 
            if (lsym) then
              call LL3ATXO(LSPSST,mat,norm,norm,dw(ibcom),
     &                     ptrmbk,lmatbk,l,nproc,tids,
     &                     myproc,jump,.true.,nvt,lmat,lindex,ia1,info,
     &                     index,nmsg)
            endif
	    lerr = .false.
	    do i=1,lmyblk
	      if (norm(i) > zero) then
	        norm(i) = 1./sqrt(norm(i))
              else
	        lerr    = .true.
	        ierproc = myproc
	        inrow   = i+ptsmyb
              endif
            enddo
	    if (lerr) then
	      ierr = 1103
            endif
         endif

!**                                                                 ***
!**   Froboenius Normalization                                      ***
!**                                                                 ***
         if ((ilin(15) == 4) .or. (ilin(15) == 14)) then
	    if (ilin(13) < 0) write(lout,1354)
	    if (ilin(13) > 0) then
	       if (myproc == 1) write(lout,1354)
            endif
            call LSPSSA(mat,lmat,index,lindex,info,ia1,norm,l,
     &                  ilin,ptsmyb) 
            if (lsym) then
              call LL3ATXO(LSPSST,mat,norm,norm,dw(ibcom),
     &                     ptrmbk,lmatbk,l,nproc,tids,
     &                     myproc,jump,.true.,nvt,lmat,lindex,ia1,info,
     &                     index,nmsg)
            endif
	    lerr = .false.
	    do i=1,lmyblk
	      if (dw(i+main-1) == zero) then
	        lerr    = .true.
	        ierproc = myproc
	        inrow   = i+ptsmyb
              endif
            enddo
	    if (lerr) then
	      ierr = 1101
	      goto 888
            endif
	    lerr = .false.
	    do i=1,lmyblk
	      if (norm(i) > zero) then
	        norm(i) = dw(i+main-1)/norm(i)
              else
	        lerr    = .true.
	        ierproc = myproc
	        inrow   = i+ptsmyb
              endif
            enddo
	    if (lerr) then
	      ierr = 1104
            endif
         endif

         if (ilin(15) == 0) then
	    if (ilin(13) < 0) write(lout,1350)
	    if (ilin(13) > 0) then
	       if (myproc == 1) write(lout,1350)
            endif
            do i=1,lmyblk
               norm(i) = one
            enddo
         else
           if (((ilin(15) > 10) .or. lsym) .and. (ierr == 0)) then
             do i=1,lmyblk
               norm(i) = sqrt(abs(norm(i)))
             enddo
           endif
         endif
      endif
!     else 
!**                                                                 ***
!**   Matrix is already normalized                                  ***
!**                                                                 ***
!        do i=1,lmyblk
!           b(i) = b(i) * norm(i)
!        enddo
!        if (ilin(16) == 4711) then
!          if ((ilin(1) == 9) .or. (ilin(15) > 10) .or. lsym) then
!            do i=1,lmyblk
!              x(i) = x(i) / norm(i)
!            enddo
!          endif
!        endif
!     endif
!**                                                                 ***
  888 call LL4INM(ione,ione,ione,ierr,iermax,ihelp,myproc,
     &            nproc,tids,nmsg)
!**                                                                 ***
      if (iermax == 1100) then
	if (ilin(13) < 0) then 
	  write(lout,1021)
	  write(lout,1416)
	  write(lout,1030)
        endif
	if (ilin(13) >= 0) then 
	  if (myproc == 1) then 
	    write(lout,1021)
	    write(lout,1416)
	    write(lout,1030)
          endif
        endif
	if (lsym) then
	  ilin(15) = 11
	else
	  ilin(15) = 1
	endif
	ierr     = 0
	inrow    = 0
	goto 111
      endif
      if (iermax == 1101) then
	if (ilin(13) < 0) then 
	  if (ierproc == myproc) then 
	    write(lout,1021)
	    write(lout,1417) inrow,ierproc
	    write(lout,1030)
          endif
        endif
	if (ilin(13) >= 0) then 
	  if (myproc == 1) then 
	    write(lout,1021)
	    write(lout,1419) inrow,nproc
	    write(lout,1030)
          endif
        endif
	if (lsym) then
	  ilin(15) = 11
	else
	  ilin(15) = 1
	endif
	ierr     = 0
	inrow    = 0
	goto 111
      endif
      if (iermax > 1101 .and. iermax < 1105) then
	if (ierproc == myproc) then 
	  write(lout,1020)
	  write(lout,1414) ierproc,inrow
	  write(lout,1030)
        endif
	ierr = iermax
	iconv = 4
	goto 999
      endif
      if (iermax == 1105) then
	if (ilin(13) < 0) then 
	  write(lout,1020)
	  write(lout,1415)
	  write(lout,1030)
        endif
	if (ilin(13) >= 0) then 
	  if (myproc == 1) then 
	    write(lout,1020)
	    write(lout,1415)
	    write(lout,1030)
          endif
        endif
	ierr = iermax
	iconv = 4
	goto 999
      endif
!**                                                                 ***
!**   IF (LSYM) THEN COMPUTE MATRIX NRMC*MAT*NRMC                   ***
!**   IF (NOT LSYM) THEN COMPUTE MATRIX  NRMC*MAT                   ***
!**   COMPUTE VECTOR B =  NRMC*B                                    ***
!**                                                                 ***
      if ((mod(ilin(6),10) == 0) .and. (ilin(15) /= 0)) then
        if ((lsym) .or. (ilin(15) >= 11)) then
	  if (ilin(13) < 0) write(lout,1355)
	  if (ilin(13) > 0) then
	    if (myproc == 1) write(lout,1355)
          endif
          call LL3AXO(LSPAP,pmat,norm,norm,dw(ibcom),ptrmbk,
     &               lmatbk,l,nproc,tids,myproc,jump,.true.,
     &               nvtLU,lpmat,lpix,ia1LU,ia2LU,infoLU,pix,nmsg)
        endif
        call LSPPA(pmat,lpmat,pix,lpix,infoLU,ia1LU,norm,l,nvtLU,
     &             ptsmyb)
!       do i=1,lmyblk
!         b(i) = b(i)*norm(i)
!       enddo
!       ilin(6) = ilin(6) + 1
        if ((ilin(1) == 9) .or. (ilin(15) >= 11) .or. lsym) then 
	  lerr=.false.
	  do i=2,lmyblk
	    if (sign(one,dw(main+i-1)) /= sign(one,dw(main))) then
	      lerr=.true.
            endif
          enddo
	  if (lerr) then
	    if (ilin(13) < 0) then 
	      write(lout,1021)
	      write(lout,1418)
	      write(lout,1030)
            endif
	    if (ilin(13) > 0) then
	      if (myproc == 1) then
	        write(lout,1021)
	        write(lout,1418)
	        write(lout,1030)
              endif
            endif
          endif
!         if (ilin(16) == 4711) then
!           do i=1,lmyblk
!             x(i) = x(i) / norm(i)
!           enddo
!         endif
!         if (mod(ilin(19),10000) >= 1000) then
!           do i=1,lmyblk
!             xexact(i) = xexact(i) / norm(i)
!           enddo
!         endif
        endif
      endif

  999 continue
      ilin(3) = nmsg
!
!
!**** END OF CALCULATION
!     ------------------
!
 1020 format(' ***************************************************'/
     &       ' ***  Error occured in LSOLP (Normalization):    ***')
 1021 format(' ***************************************************'/
     &       ' ***  Warning  (Normalization):                  ***')
 1414 format(' ***   Normalization failed on processor ',i6,'; ***'/
     &       ' ***   Row  ',i6,' contains no nonzero element;  ***'/
     &       ' ***   Matrix is nonregular!                     ***')
 1415 format(' ***   Matrix is symmetric and no explicit main  ***'/
     &       ' ***   diagonal is specified by the user  -->    ***'/
     &       ' ***   hidden (in storage patterns 2-11)         ***'/
     &       ' ***   diagonal elements are not allowed!        ***')
 1416 format(' ***   There are no main diagonal entries        ***'/
     &       ' ***   specified in the matrix    -->            ***'/
     &       ' ***   LSOLP  switches to row sum normalization! ***')
 1417 format(' ***   The main diagonal contains zero elements  ***'/
     &       ' ***   --> LSOLP switches to row sum normaliz.!  ***')
 1418 format(' ***   The main diagonal elements have           ***'/
     &       ' ***   different signs!                          ***')
 1419 format(' ***   The main diagonal element of line ',i6,'  ***'/
     &       ' ***   on processor 1 -',i6,' contains a zero    ***'/
     &       ' ***   element  -->  LSOLP  switchs to row sum   ***'/
     &       ' ***   normalization!                            ***')
 1030 format(' ***************************************************')
 1350 format('  No normalization for elimination matrix'/)
 1351 format('  Elimination matrix normalized by'/
     &       '  sign(A_ii)/sum{abs(A_ij),j=1,l}'/)
 1352 format('  Elimination matrix normalized by 1/A_ii'/)
 1353 format('  Elimination matrix normalized by'/
     &       '  1/sqrt(sum{A_ij**2,j=1,l})'/)
 1354 format('  Elimination matrix normalized by'/
     &       '  A_ii/sum{A_ij**2,j=1,l}'/)
 1355 format('  Symmetric normalization'/)
      r e t u r n
!-----END OF LSPNORM---------------------------------------------------
      e    n    d
