!:::::      ,,,,,LSPPA.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPPA(mat,lmat,index,lindex,infoLU,ia1LU,norm,l,
     &                 nvtLU,ptsmyb)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P P A     multiplies the diagonal matrix norm with     ***
!**                    the matrix MAT.                              ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER : P.STERNECKER + L.GROSS + C.ROLL + H.Haefner     ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   The implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           ia1LU,nvtLU,ptsmyb,lmat,lindex,l
      integer           infoLU(ia1LU,ia2LU),index(lindex)
      double precision  norm(l),mat(lmat)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   see Manual Pages <lsolp>                                      ***
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,k
      integer           adda,lvt,iar1
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      do k=1,nvtLU
         adda = infoLU(k,1)
         lvt  = infoLU(k,2)
         iar1 = infoLU(k,3)-ptsmyb
         do i=1,lvt
           mat(i+adda) = mat(i+adda) * norm(iar1+1)
         enddo
      enddo
!**                                                                 ***
!**                                                                 ***
!**** END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**                                                                 ***
      r e t u r n
!-----END OF LSPPA----------------------------------------------------
      e    n    d
