!:::::      ,,,,,LSPRSA.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPRSA(mat,lmat,index,lindex,info,ia1,norm,l,
     &                  ilin,ptsmyb)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P R S A   computes the row sum of the nonsymmetrical   ***
!**                    matrix (part) mat.                           ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMERS : P.STERNECKER + L.GROSS + C.ROLL + H.Haefner    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           ptsmyb,lmat,lindex,ia1,l
      double precision  norm(l),mat(lmat)
      integer           info(ia1,ia2),index(lindex),ilin(nilin)
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,k,jc,jr,nvt
      integer           typ,adda,lvt,iar1,indc,indr

      double precision,parameter ::  zero = 0.0, one = 1.0

!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      nvt = ilin(5)

      do i = 1,l
         norm(i) = zero
      enddo
!**                                                                 ***
      do k=1,nvt
!**                                                                 ***
         typ   =info(k,1)
         adda  =info(k,2)
         lvt   =info(k,3)
         iar1   =info(k,5)-ptsmyb
         indc  =info(k,6)
         indr  =info(k,7)
!**                                                                 ***
         if ((typ == 1) .or. (typ == 2) .or. (typ == 4) .or.
     &       (typ == 8)) then
           do i=1,lvt
             norm(i+iar1) = norm(i+iar1) + abs(mat(i+adda))
           enddo
         endif
!**                                                                 ***
         if (typ == 3) then
      include "norec.h"
           do i=1,lvt
	     jc = index(i+indc)
             norm(jc+iar1) = norm(jc+iar1) + abs(mat(i+adda))
           enddo
         endif
!**                                                                 ***
         if ((typ == 5) .or. (typ == 6) .or. (typ == 11)) then
      include "norec.h"
           do i=1,lvt
	     jr = index(i+indr)-ptsmyb
             norm(jr) = norm(jr) + abs(mat(i+adda))
           enddo
         endif
!**                                                                 ***
         if ((typ == 7) .or. (typ == 9)) then
           do i=1,lvt
             norm(iar1+1) = norm(iar1+1) + abs(mat(i+adda))
           enddo
         endif
!**                                                                 ***
      enddo

!**                                                                 ***
!**                                                                 ***
!**** END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**                                                                 ***
      r e t u r n
!-----END OF LSPRSA----------------------------------------------------
      e    n    d
