!:::::      ,,,,,LSPRSA.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPRSA(mat,lmat,index,lindex,infoLU,ia1LU,nvtLU,norm,
     &                  l,ilin,ptsmyb)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P R S A   computes the row sum of the nonsymmetrical   ***
!**                    matrix (part) mat.                           ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMERS : P.STERNECKER + L.GROSS + C.ROLL + H.Haefner    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           ptsmyb,lmat,lindex,ia1LU,l,nvtLU
      double precision  norm(l),mat(lmat)
      integer           infoLU(ia1LU,ia2LU),index(lindex),ilin(nilin)
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,k
      integer           adda,lvt,iar1

      double precision,parameter ::  zero = 0.0, one = 1.0

!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***

      do i = 1,l
         norm(i) = zero
      enddo
!**                                                                 ***
      do k=1,nvtLU
        adda = infoLU(k,1)
        lvt  = infoLU(k,2)
        iar1 = infoLU(k,3)-ptsmyb
        do i=1,lvt
          norm(iar1+1) = norm(iar1+1) + abs(mat(i+adda))
        enddo
      enddo

!**                                                                 ***
!**                                                                 ***
!**** END OF CALCULATION                                            ***
!**   ------------------                                            ***
!**                                                                 ***
      r e t u r n
!-----END OF LSPRSA----------------------------------------------------
      e    n    d
