!:::::      ,,,,,LSPRST.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LSPRST(mat,lmat,index,lindex,info,ia1,nvt,dummy,norm,
     &                  l,ptsmyb,ptsmbk,lmatbk) 
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      L S P R S T   is the kernel routine for the computation    ***
!**                    of the row sum of the symmetrical matrix     ***
!**                    part (matrix mat_transposed).                ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER : P.STERNECKER  +  L.GROSS  + C.ROLL              ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           nvt, lmat, lindex, ia1
      integer           info(ia1,ia2), index(lindex)
      integer           ptsmyb,l,ptsmbk,lmatbk
      double precision  norm(l),dummy(l),mat(lmat)
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
!
      integer           i,k,jc,jcb,jce
      integer           adda,iar,lvt,indc,istart,iend
      logical           ldata
!**                                                                 ***
!**        CONSTANTS:                                               ***
!**        ---------                                                ***
      double precision,parameter ::  zero = 0.0
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**** START OF CALCULATION :                                        ***
!**   ---------------------                                         ***
!**                                                                 ***
      do k=1,nvt
        adda  =info(k,2)
        lvt   =info(k,3)
        iar   =info(k,5)
        indc  =info(k,6)

        ldata = .false.
        jcb = index(indc+1)
        jce = index(indc+lvt)
        if ((jcb <= ptsmbk) .and. (jce > ptsmbk)) then
          istart = 2
          do while (index(indc+istart) <= ptsmbk .or.
     &              index(indc+istart) == iar+1)
            istart = istart + 1
          enddo
          ldata = .true.
        endif
   
        if ((jcb > ptsmbk) .and. (jcb <= ptsmbk+lmatbk)) then
          istart = 2  ! not 1 because main diagonal has already been considered
          ldata = .true.
        endif
   
        if (ldata) then
          if (jce <= ptsmbk+lmatbk) then
            iend = lvt
          else
            iend = lvt - 1
            do while (index(indc+iend) > ptsmbk+lmatbk)
              iend = iend - 1
            enddo
          endif
!     include "norec.h"
          do i=istart,iend
            jc = index(i+indc)
            norm(jc-ptsmbk) = norm(jc-ptsmbk) + abs(mat(i+adda))
          enddo
        endif
      enddo
!
!**** END OF CALCULATION
!     ------------------
!
      r e t u r n
!-----END OF LSPRST----------------------------------------------------
      e    n    d
