C:::::      ,,,,,LSPSC6.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LSPSC6(mat,index,rbuf,ibuf,l,lmat,lindex,info,nvt,
     #                  ivt,ia1,lmatbk,ptrmbk,myproc,nproc,tid,
     #                  nmsg,lout,ierr,iertag)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L S P S C 6   separates  "starry sky" patterns in <nproc>  ***
C**                    column blocks.                               ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1995 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    lmat,lindex,ia1,ivt,nvt,nproc,myproc,
     *           nmsg,ierr,iertag,l,lout
      integer    info(ia1,ia2),index(lindex),tid(nproc),lmatbk(nproc),
     *           ptrmbk(nproc+1),ibuf(4*l)
C**                                                                 ***
      double precision   mat(lmat),rbuf(2*l)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays mat(lmat),info(ia1,ia2),tid(nproc),lmatbk(nproc),      ***
C**          ptrmbk(nproc+1) and                                      ***
C**   Variables lmat,ia1,ia2,nproc,myproc,nmsg,ierr,l:              ***
C**              see Manual-Pages <linsol>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,j,j1,j2,k,iwork,iermax,iar,iacend,indr,indc,ixend
      integer    adda,glvt,s_addr,iac,ixbgn,iacbgn,minvt
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      ierr = 0
      adda = info(ivt,2)
      info(ivt,4) = 0
      info(ivt,5) = 0
      indc = info(ivt,6) 
      indr = info(ivt,7) 

      do 10 i=nproc,1,-1
        glvt = info(ivt,3)
        ixbgn = 1
        do 5 k=2,glvt
          if (index(indc+k) .lt. index(indc+ixbgn)) ixbgn = k
    5   continue
        iacbgn = index(indc+ixbgn)

        ixend = 1
        do 6 k=2,glvt
          if (index(indc+k) .gt. index(indc+ixend)) ixend = k
    6   continue
        iacend = index(indc+ixend)

	if (iacbgn .lt. ptrmbk(i)) then
	  if (iacend .gt. ptrmbk(i)) then
	    nvt = nvt+1
	    if (iertag == 0 .and. nvt > ia1) then
	      iertag = myproc + 600000
              write(lout,1000)
              write(lout,1010) myproc
              write(lout,1020)
	    endif
	    minvt = min(nvt,ia1)
	    j1 = 0
	    j2 = 0
            do 12 k=1,glvt
	      if (index(indc+k) .le. ptrmbk(i)) then
		j1 = j1+1
		ibuf(j1) = index(indc+k)
		ibuf(l+j1) = index(indr+k)
		rbuf(j1) = mat(adda+k)
              else
		j2 = j2+1
		ibuf(2*l+j2) = index(indc+k)
		ibuf(3*l+j2) = index(indr+k)
		rbuf(l+j2) = mat(adda+k)
              endif
   12       continue
            do 14 k=1,glvt
	      if (k .le. j1) then
		index(indc+k) = ibuf(k) 
		index(indr+k) = ibuf(l+k) 
		mat(adda+k) = rbuf(k) 
              else
		index(indc+k) = ibuf(2*l+k-j1) 
		index(indr+k) = ibuf(3*l+k-j1) 
		mat(adda+k) = rbuf(l+k-j1) 
              endif
   14       continue
            info(minvt,1) = 6
            info(minvt,2) = adda+j1
            info(minvt,4) = 0
            info(minvt,5) = 0
            info(minvt,6) = indc+j1
            info(minvt,7) = indr+j1
	    if (iacend .le. ptrmbk(i)+lmatbk(i)) then
	      info(minvt,3) = j2
            else
	      ierr = 6000+myproc
              write(lout,1000)
              write(lout,1030) myproc
              write(lout,1020)
	      goto 999
            endif
	    info(ivt,3) = glvt-info(minvt,3)
          endif
        endif
   10 continue

  999 continue
 1000 format(' **********************************************'/
     &       ' ***  Error occured in LSOLP (LSPSC6):      ***')
 1010 format(' ***   First dimension of array <info> is   ***'/
     &       ' ***   too small on processor ',i6,'        ***')
 1020 format(' **********************************************')
 1030 format(' ***   LSPSC6: Implementation error         ***')

C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LSPSC6---------------------------------------------------
      e    n    d
