C:::::      ,,,,,LSPSC7.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LSPSC7(mat,l,lmat,info,nvt,ivt,ia1,lmatbk,ptrmbk,
     #                  myproc,nproc,tid,nmsg,lout,ierr,iertag)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L S P S C 7   separates full rows in <nproc>               ***
C**                    column blocks.                               ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1995 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    lmat,ia1,ivt,nvt,nproc,myproc,
     *           nmsg,ierr,iertag,l,lout
      integer    info(ia1,ia2),tid(nproc),lmatbk(nproc),
     *           ptrmbk(nproc+1)
C**                                                                 ***
      double precision   mat(lmat)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays mat(lmat),info(ia1,ia2),tid(nproc),lmatbk(nproc),      ***
C**          ptrmbk(nproc+1) and                                    ***
C**   Variables lmat,ia1,ia2,nproc,myproc,nmsg,ierr,l:              ***
C**              see Manual-Pages <linsol>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,j,k,iwork,iermax,iar,iacend
      integer    adda,glvt,s_addr,iac,minvt
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      ierr = 0
      adda = info(ivt,2)
      iac  = info(ivt,4)
      iar  = info(ivt,5)
      info(ivt,6) = 0
      info(ivt,7) = 0

      do 10 i=nproc,1,-1
        glvt = info(ivt,3)
        iacend = iac+glvt
	if (iac .lt. ptrmbk(i)) then
	  if (iacend .gt. ptrmbk(i)) then
	    nvt = nvt+1
	    if (iertag == 0 .and. nvt > ia1) then
	      ierr = myproc + 700000
              write(lout,1000)
              write(lout,1010) myproc
              write(lout,1020)
	    endif
	    minvt = min(nvt,ia1)
	    s_addr  = ptrmbk(i)-iac
            info(minvt,1) = 7
            info(minvt,2) = adda+s_addr
            info(minvt,4) = ptrmbk(i)
            info(minvt,5) = iar
            info(minvt,6) = 0
            info(minvt,7) = 0
	    if (iacend .le. ptrmbk(i)+lmatbk(i)) then
	      info(minvt,3) = iacend-ptrmbk(i)
            else
	      ierr = 7000+myproc
              write(lout,1000)
              write(lout,1030) myproc
              write(lout,1020)
	      goto 999
            endif
	    info(ivt,3) = glvt-info(minvt,3)
          endif
        endif
   10 continue

  999 continue
 1000 format(' **********************************************'/
     &       ' ***  Error occured in LSOLP (LSPSC7):      ***')
 1010 format(' ***   First dimension of array <info> is   ***'/
     &       ' ***   too small on processor ',i6,'        ***')
 1020 format(' **********************************************')
 1030 format(' ***   LSPSC7: Implementation error         ***')
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LSPSC7---------------------------------------------------
      e    n    d
