C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LSPSRT(index,lindex,nvt,ia1,ptrmbk,info,ptrinf,
     *                  lout,myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**    State of paramet.: in    in    in   in   in   in    i/o  out ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   L S P S R T   calculates array  <ptrinf> and sorts the        ***
C**                 array  <info>.                                  ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1996 University Karlsruhe                      ***
C**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer   nvt,ia1,nproc,lindex,myproc,nmsg,lout
      integer   info(ia1,ia2),ptrinf(ntyp+1,nproc),ptrmbk(nproc+1)
      integer   index(lindex),tids(nproc)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <linsol>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    i,j,k,ityp,iac,indc,istart,iblk,it
      integer    ivt,numvt,nrblk,posanf,ierr,iermax,ihelp
      integer    nrinf(ntyp,nproc),iw(nvt*ia2)

C
C**** START OF CALCULATION :
C     ---------------------
C

      ierr  = 0
      nrinf = 0

C**
C**   calculate logical block-index for each typ
C**   and number of vt-typs on each processor
C**
      do i=1,nvt
         ityp = info(i,1)
         iac  = info(i,4)
         indc = info(i,6)
         do j=1,nproc
	   if (ityp .eq. 1 .or. ityp .eq. 2 .or.
     *         ityp .eq. 7 .or. ityp .eq. 8) then
            if (iac .ge. ptrmbk(j) .and. iac .lt. ptrmbk(j+1)) then
              nrinf(ityp,j) = nrinf(ityp,j)+1
	      info(i,7) = 10000*j
            endif
           endif
	   if (ityp .eq. 5 .or. ityp .eq. 11) then
            if (iac .ge. ptrmbk(j) .and. iac .lt. ptrmbk(j+1)) then
              nrinf(ityp,j) = nrinf(ityp,j)+1
	      info(i,5) = 10000*j
            endif
           endif
	   if (ityp .eq. 3) then
             if (iac+index(indc+1) .gt. ptrmbk(j) .and.
     *           iac+index(indc+1) .le. ptrmbk(j+1)) then
               nrinf(ityp,j) = nrinf(ityp,j)+1
	       info(i,7) = 10000*j
             endif
           endif
	   if (ityp .eq. 4 .or. ityp .eq. 9) then
             if (index(indc+1) .gt. ptrmbk(j) .and.
     *           index(indc+1) .le. ptrmbk(j+1)) then
               nrinf(ityp,j) = nrinf(ityp,j)+1
	       info(i,7) = 10000*j
             endif
           endif
	   if (ityp .eq. 6) then
             if (index(indc+1) .gt. ptrmbk(j) .and.
     *           index(indc+1) .le. ptrmbk(j+1)) then
               nrinf(ityp,j) = nrinf(ityp,j)+1
	       info(i,5) = 10000*j
             endif
           endif
         enddo
      enddo
C**                             
C**   calculate ptrinf-array
C**
      k=0
      do i=1,nproc
         ptrinf(1,i) = k 
         do j=2,ntyp+1
            ptrinf(j,i) = ptrinf(j-1,i)+nrinf(j-1,i)
         enddo  
         k = ptrinf(ntyp+1,i)
      enddo

C**
C**   sort info-array
C**
      istart = 1
      do iblk = 1,nproc
	do it = 1,ntyp
	  numvt = nrinf(it,iblk)
	  posanf = ptrinf(it,iblk)+1
          ivt=istart
	  do i=1,numvt
  555       ityp = info(ivt,1)
	    if (ityp.eq.1 .or. ityp.eq.2 .or. ityp.eq.3 .or. ityp.eq.4
     *          .or. ityp.eq.7 .or. ityp.eq.8 .or. ityp.eq.9) then
	      nrblk = info(ivt,7)/10000
            endif
	    if (ityp.eq.5 .or. ityp.eq.6 .or. ityp.eq.11) then
	      nrblk = info(ivt,5)/10000
            endif
	    if (nrblk .ne. iblk .or. ityp .ne. it) then
	      ivt = ivt+1
              if (ivt .gt. nvt) then
                ierr = 0800+myproc
                write(lout,1000)
                write(lout,1030) myproc,it
                write(lout,1020)
                goto 999
              endif
	      goto 555
            endif
	    do j=1,ia2
	      iw((posanf+i-2)*ia2+j) = info(ivt,j)
            enddo
	    if (ivt .eq. istart) istart = istart+1
	    ivt = ivt+1
          enddo
        enddo
      enddo

      do j=1,ia2
	do i=1,nvt
          info(i,j) = iw((i-1)*ia2+j)
        enddo
      enddo

  999 call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
      if (iermax .gt. 0) then
        ierr = iermax
        if (myproc .eq. 1) then
          write(lout,1000)
          write(lout,1040) iermax-0800
          write(lout,1020)
        endif
      endif
 1000 format(' **********************************************'/
     &       ' ***  Error occured in LSOLP  (LSPSRT):     ***')
 1030 format(' ***     Array <info> has wrong data on     ***'/
     &       ' ***     processor ',i6,' sorting type',i6,'***')
 1040 format(' ***     Array <info> has wrong data on     ***'/
     &       ' ***     processor ',i6,'                   ***')
 1020 format(' **********************************************')

      R E T U R N
C------END OF LSPSRT--------------------------------------------
      E N D                                   
