!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine LUSORT(mat,lmat,index,lindex,infoLU,ia1LU,maxlvt,
     &                  nvtLU)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   L U S O R T   resorts the column indices of matrix <mat> and  ***
!**                 the corresponding matrix elements - stored in   ***
!**                 packed rows - increasingly.                     ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in) ::  ia1LU,lmat,lindex,nvtLU,maxlvt
      integer, intent(in) ::  infoLU(ia1LU,ia2LU)
      integer, intent(inout) ::  index(lindex)
      double precision, intent(inout) ::  mat(lmat)
!**                                                                 ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      double precision matbuf(maxlvt)
      integer          nix(maxlvt)
      integer          adda,j,k,lvt
!
!**** START OF CALCULATION :
!     ---------------------
!

!
! sort indices and matrixelements for all packed rows
!
      do k=1,nvtLU
	adda = infoLU(k,1)
	lvt  = infoLU(k,2)
        call HEAPSORTIX(index(adda+1),nix,lvt,.true.)
	do j=1,lvt
	  matbuf(j) = mat(adda+nix(j))
	enddo
	do j=1,lvt
	  mat(adda+j) = matbuf(j)
	enddo
      enddo


      R E T U R N
!------END OF LUSORT------------------------------------------------
      E N D
