!:::::      ,,,,,PREPRO....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine PREPRO(index,lindex,info,ia1,graph,lgraph,vertix,l,
     #                  lglobal,ilin,ptrmbk,lmatbk,tids,nproc,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**      program description of PREPRO                              ***
!**                                                                 ***
!**      Mirrors the elements of the matrix below the main diagonal ***
!**      into the upper half and vice versa and stores the indices  ***
!**      rowwise in the vector graph and its pointervector vertix.  ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2001 University Karlsruhe                      ***
!**    PROGRAMMER : Hartmut Haefner                                 ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   the implicit none-instruction has the aim,                    ***
!**   that all variables must be declared explicitly.               ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           ia1,ierr,lindex,lgraph
      integer           nproc,l,lglobal,ptrmbk(nproc+1),ilin(nilin)
      integer           info(ia1,ia2),index(lindex)
      integer           tids(nproc),lmatbk(nproc)
      integer           graph(lgraph),vertix(l+1)
!**********************************************************************
!**                                                                 ***
!**    List of Formal Parameters :                                  ***
!**                                                                 ***
!**                                                                 ***
!---------I------I-----I-----------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I-----------------------------------------------
! info    I int  I     I array with matrix-structure-information
!---------I------I-----I-----------------------------------------------
! index   I int  I     I array with indices
!---------I------I-----I-----------------------------------------------
! vertix  I int  I out I array with matrix-structure-information
!---------I------I-----I------------------------------------------------
! graph   I int  I out I array with indices
!---------I------I-----I------------------------------------------------
!**                                                                 ***
!**                                                                 ***
!**        LOCAL PARAMETERS :                                       ***
!**        ----------------                                         ***
!**                                                                 ***
      integer           i,ii,j,jj,jjoff,jloc,k,lvt,iermax
      integer           gcnt,vcnt,hixsiz(nproc),hixsizr(nproc)
      integer           hixlen(l),hixmlen(l),hixrlen(l,nproc-1)
      integer           hixmax,hixmaxrg,hixmaxr(nproc)
      integer           myproc,frtid,totid,ihlp(2),ihlpr(2),nmsg
      integer           firstindex,lastindex,mids,midr
      integer           joff(l),ixh(lglobal)
!     double precision  t1,ted,t2
      integer,allocatable,dimension(:,:,:)::hix
      integer,allocatable,dimension(:,:)::hixm,hixr
!**********************************************************************
!**                                                                 ***
!**    List of Local Variables :                                    ***
!**                                                                 ***
!**                                                                 ***
!---------I------I-----I-----------------------------------------------
! NAME    I TYPE I I/O I MEANING
!---------I------I-----I-----------------------------------------------
! hixm    I int  I --- I array with indices
!         I      I     I array:  hix(hixsiz(myproc),lmatbk(myproc))
!         I      I     I
!         I      I     I  hixm(1:hixsiz(myproc),j) = column indices of
!         I      I     I   column j in main diagonal block
! hixmlen I int  I --- I length of column vectors of array hixm
!         I      I     I   array:  hixmlen(l)
! hix     I int  I --- I array with indices to be sent
!         I      I     I array:  hix(hixmax,l,nproc-1)
!         I      I     I
!         I      I     I  hix(1:hixsiz(i),j,i) = column indices of
!         I      I     I   column j in block i (no main diagonal block)
! hixlen  I int  I --- I length of column vectors of array hix
!         I      I     I   array:  hixlen(l)
! hixr    I int  I --- I array with received indices
!         I      I     I array:  hixr(hixmaxr*l,nproc-1)
!         I      I     I
!         I      I     I  hixr((j-1)*hixmaxr(i)+1:hixrlen(j,i),i) =
!         I      I     I   row indices of row j in block i
!         I      I     I   (no main diagonal block)
! hixrlen I int  I --- I length of row vectors of array hixr
!         I      I     I   array:  hixrlen(l,nproc-1)
!---------I------I-----I-----------------------------------------------
!**                                                                 ***
!**        CONSTANTS:                                               ***
!**        ---------                                                ***
!**                                                                 ***

      nmsg=ilin(3)
      myproc=ilin(17)
      hixsiz = 0
      hixsizr= 0
      hixrlen= 0
!**                                                                 ***
!**   determine, send and receive hixsiz(1:nproc)                   ***
!**                                                                 ***
!     call SECONDS(t1,ted)
      if (nproc == 1) then
	hixlen = 0
	do k=1,lmatbk(1)
	  lvt = info(k,3)
	  do jj=1,lvt
	    j = index(info(k,6)+jj)
	    hixlen(j) = hixlen(j) + 1
	  enddo
	enddo
	hixsiz(1) = 0
	do j=1,lmatbk(1)
	  if (hixlen(j) > hixsiz(1)) hixsiz(1) = hixlen(j)
	enddo
      else
        joff = 1
        do i=1,nproc
          if (i==myproc) then
!**                                                                 ***
!**       determination of hixsiz(1:nproc)                          ***
!**                                                                 ***
!**       count the number of elements rowwise                      ***

	    hixlen = 0
            do k=1,lmatbk(myproc)
	      lvt = info(k,3)
	      jjoff = joff(k)
              do jj=jjoff,lvt
		j = index(info(k,6)+jj)
		jloc = j - ptrmbk(i)
                if (j > ptrmbk(i+1)) exit
                if (j > ptrmbk(i) .and. (j /= ptrmbk(myproc)+k)) then
		  hixlen(jloc) = hixlen(jloc) + 1
		  joff(k) = joff(k) + 1
		endif
              enddo
            enddo
	    hixsiz(i) = 0
	    do j=1,lmatbk(i)
	      if (hixlen(j) > hixsiz(i)) hixsiz(i) = hixlen(j)
	    enddo
            
          else
            
	    hixlen = 0
            do k=1,lmatbk(myproc)
	      lvt = info(k,3)
	      jjoff = joff(k)
              do jj=jjoff,lvt
		j = index(info(k,6)+jj)
		jloc = j - ptrmbk(i)
                if (j > ptrmbk(i+1)) exit
                if (j > ptrmbk(i)) then
		  hixlen(jloc) = hixlen(jloc) + 1
		  joff(k) = joff(k) + 1
		endif
              enddo
            enddo
	    hixsiz(i) = 0
	    do j=1,lmatbk(i)
	      if (hixlen(j) > hixsiz(i)) hixsiz(i) = hixlen(j)
	    enddo
          endif
        enddo

!**   determine the maximum of hixsiz(i)                            ***

        hixmax = 0
        do i=1,nproc
          if ((i /= myproc) .and. (hixsiz(i) > hixmax)) then
            hixmax = hixsiz(i)
          endif
        enddo

!**   send hixmax to all other processors                           ***

        do i=1,nproc
          if (i /= myproc) then
            frtid=tids(i)
            call MPRCVA(frtid,nmsg+i,2*iint,ihlpr,midr,ierr)
            totid=tids(i); ihlp(1) = hixsiz(i); ihlp(2) = hixmax
            call MPSNDA(totid,nmsg+myproc,2*iint,ihlp,mids,ierr)
            call MPSNDW(totid,nmsg+myproc,2*iint,ihlp,mids,ierr)
            call MPRCVW(frtid,nmsg+i,2*iint,ihlpr,midr,ierr)
            hixsizr(i) = ihlpr(1); hixmaxr(i) = ihlpr(2)
          endif
        enddo
        nmsg=nmsg+nproc+1

!**   determine the maximum of hixsizr(i)                           ***

        hixmaxrg = 0
        do i=1,nproc
          if ((i /= myproc) .and. (hixmaxr(i) > hixmaxrg)) then
            hixmaxrg = hixmaxr(i)
          endif
        enddo

      endif      ! if (nproc == 1)


!     call SECONDS(t2,ted)
!     print*,' Determine array sizes:',t2-t1

!**                                                                 ***
!**  end of send, receive and determination of hixmax and hixmaxr   ***
!**                                                                 ***

      ierr = 0

!     call SECONDS(t1,ted)
      allocate(hixm(hixsiz(myproc),lmatbk(myproc)),stat=ierr)
      if (nproc > 1) allocate(hix(hixmax,l,nproc-1),stat=ierr)

      if ((nproc > 1) .and. (hixmaxrg /= 0))
     &  allocate(hixr(hixmaxrg*l,nproc-1),stat=ierr)

      call LL4INM(1,1,1,ierr,iermax,ihlp,myproc,nproc,tids,nmsg)
      if (iermax /= 0) then
        ierr = iermax
        if (ierr /= 0) goto 999
      endif
!     call SECONDS(t2,ted)
!     print*,' Allocation of arrays:',t2-t1

!**                                                                 ***
!**       columnwise set up of hix                                  ***
!**                                                                 ***
!**       IMPORTANT: indices must be sorted .and.                   ***
!**                  rows must be sorted!!!                         ***
!**                                                                 ***

!     call SECONDS(t1,ted)

      joff = 1
      do i=1,nproc

        if (i == myproc) then

	  hixmlen = 0
          do k=1,lmatbk(myproc)
	    lvt = info(k,3)
	    jjoff = joff(k)
            do jj=jjoff,lvt
	      j = index(info(k,6)+jj)
              jloc = j - ptrmbk(i)
              if (j > ptrmbk(i+1)) exit
              if (j > ptrmbk(i) .and. (j /= ptrmbk(myproc)+k)) then
	        hixmlen(jloc) = hixmlen(jloc) + 1
	        joff(k) = joff(k) + 1
		hixm(hixmlen(jloc),j-ptrmbk(i)) = ptrmbk(myproc) + k
	      endif
            enddo
          enddo

        else

          if (i > myproc) then
	    ii = i - 1
	  else
	    ii = i
	  endif
	  hixlen = 0
          do k=1,lmatbk(myproc)
	    lvt = info(k,3)
	    jjoff = joff(k)
            do jj=jjoff,lvt
	      j = index(info(k,6)+jj)
              jloc = j - ptrmbk(i)
              if (j > ptrmbk(i+1)) exit
              if (j > ptrmbk(i)) then
	        hixlen(jloc) = hixlen(jloc) + 1
	        joff(k) = joff(k) + 1
		hix(hixlen(jloc),j-ptrmbk(i),ii) = ptrmbk(myproc) + k
	      endif
            enddo
          enddo

!**                                                                 ***
!**       Send hix to another processor and receive hixr from       ***
!**       another processor                                         ***
!**                                                                 ***
          frtid=tids(i)
          if (hixsizr(i)>0) then
            call MPRCVA(frtid,nmsg+i+1,l*iint,hixrlen(1,ii),midr,ierr)
            call MPRCVA(frtid,nmsg+i+2,hixmaxr(i)*l*iint,
     #                  hixr(1,ii),midr,ierr)
	  endif
          totid=tids(i)
          if (hixsiz(i) > 0) then
            call MPSNDA(totid,nmsg+myproc+1,l*iint,hixlen,mids,ierr)
            call MPSNDW(totid,nmsg+myproc+1,l*iint,hixlen,mids,ierr)
            call MPSNDA(totid,nmsg+myproc+2,hixmax*l*iint,
     #                  hix(1,1,ii),mids,ierr)
            call MPSNDW(totid,nmsg+myproc+2,hixmax*l*iint,
     #                  hix(1,1,ii),mids,ierr)
          endif
          if (hixsizr(i)>0) then
            call MPRCVW(frtid,nmsg+i+1,l*iint,hixrlen(1,ii),midr,ierr)
            call MPRCVW(frtid,nmsg+i+2,hixmaxr(i)*l*iint,
     #                  hixr(1,ii),midr,ierr)
	  endif
        endif
      enddo

      nmsg=nmsg+nproc+2
!     call SECONDS(t2,ted)
!     print*,' Compute array hix:',t2-t1

      if (nproc > 1) then
	deallocate(hix)
        do i=1,nproc-1
	  if (i >= myproc) then
	    hixsizr(i) = hixsizr(i+1)
	    hixmaxr(i) = hixmaxr(i+1)
          endif
        enddo
      endif

!**                                                                 ***
!**   rowwise sorting of index and hix into graph                   ***
!**                                                                 ***
!     call SECONDS(t1,ted)
      gcnt=0
      vcnt=1
      vertix(vcnt) = gcnt

!***  for all rows!
      do i=1,lmatbk(myproc)
        ixh = 0
        do k=1,info(i,3)
          ixh(index(info(i,6)+k)) = index(info(i,6)+k)
        enddo
        do k=1,hixmlen(i)
          ixh(hixm(k,i)) = hixm(k,i)
        enddo

!***  for all column blocks!
        do j=1,nproc-1
	 if (hixsizr(j) > 0) then
	  do k=1,hixrlen(i,j)
	    ixh(hixr((i-1)*hixmaxr(j)+k,j)) = hixr((i-1)*hixmaxr(j)+k,j)
	  enddo
	 endif
        enddo

        firstindex = lglobal + 1
	lastindex  = 0
	if (info(i,3) > 0) then
          firstindex = min(firstindex,index(info(i,6)+1))
          lastindex  = max(lastindex,index(info(i,6)+info(i,3)))
	endif
	if (hixmlen(i) > 0) then
          firstindex = min(firstindex,hixm(1,i))
          lastindex  = max(lastindex,hixm(hixmlen(i),i))
	endif
        do j=1,nproc-1
	 if (hixrlen(i,j) > 0) then
          firstindex = min(firstindex,hixr((i-1)*hixmaxr(j)+1,j))
          lastindex=max(lastindex,hixr((i-1)*hixmaxr(j)+hixrlen(i,j),j))
         endif
        enddo

	do k=firstindex,lastindex    ! originally k=1,lglobal
	  if (ixh(k) /= 0) then
	    gcnt =gcnt + 1
	    graph(gcnt) = ixh(k)
	  endif
	enddo
	vcnt = vcnt + 1
	vertix(vcnt) = gcnt
      enddo

!     call SECONDS(t2,ted)
!     print*,' Merge sort:',t2-t1

      deallocate(hixm)
      if ((nproc > 1) .and. (hixmaxrg /= 0)) deallocate(hixr)

  999 continue
      ilin(3)=nmsg
!**                                                                  ***
      r e t u r n
!-----END OF PREPRO-----------------------------------------------------
      e    n    d
