!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine PROW2DIAG(mat,lmat,index,lindex,info,ia1,nvt,ilin,l,      
     &                    diagcrf,diagcrp,diagbgn,diagend,
     &                    diagel)   
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   PROW2DIAG   change the srorage pattern 9 to packed diag. or   ***
!**               full diagonal if necessary and then pack it.      ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2001 University Karlsruhe                      ***
!**    PROGRAMMER: Xiangming Quan                                   ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in) ::  lmat,ia1,lindex,l
      integer, intent(in) ::  diagcrf(2*l-1),diagcrp(2*l-1)
      integer, intent(in) ::  diagbgn(2*l-1),diagend(2*l-1)
      integer, intent(in) ::  diagel(2*l-1)
      integer, intent(inout) ::  nvt
      integer, intent(inout) ::  info(ia1,7), index(lindex)
      integer, intent(inout) ::  ilin(nilin)
      double precision, intent(inout) :: mat(lmat)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolp>)                                    ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer   bufsize,adda,i,ix,iar,iac,k,endind,endmat,j 
      integer   indc,lvt,runacc,ixmark,ixptrf,ixptrp,tag1
      integer   nlvt,idxptrf,idxptrp,lvtf,endmath,endmatn,endindn
      integer   ixdiagcr
!     integer   ireal,iint,endmax
      integer   endmax
      double precision zero,matmark 
      logical   lsto9
!     parameter (zero=0.,ireal=8,iint=4)
      parameter (zero=0.)
      double precision,allocatable :: bufferf(:),bufferp(:)
      integer, allocatable :: ibufferp(:)
!
!**** START OF CALCULATION :
!     ---------------------
!

      bufsize   = ilin(7)
      runacc    = ilin(21)
      endmat    = ilin(33)
      endind    = ilin(34)

      matmark = TINY(1.d0)
      ixmark = -999

      bufsize = INT(bufsize*1.e6/(ireal+iint))
      allocate(bufferf(bufsize))
      allocate(bufferp(bufsize),ibufferp(bufsize))
!
!**** SET VARIABLES POINTING TO THE END OF THE MATRIX- AND INDEX-ARRAY
!

!     do i=1,2*l-1
!       ixdiagcr(i) = 0
!     enddo
      ixptrp = 0
      ixptrf = 0

      bufferf = zero

      do i = 1,2*l-1
        if (diagcrp(i) == 1) then
	  ixdiagcr = 1
          do j=diagbgn(i),diagend(i)
       	    adda = info(j,2)
	    lvt  = info(j,3) ! lvt= length of the vector terms
	    iar  = info(j,5) ! index of row
	    indc = info(j,6)
	    do k=1,lvt ! for all elements of a row
	      ix = l-index(indc+k)+iar+1   ! index(x)=iac+1
	      if (ix == i) then          
	        bufferp(ixptrp+ixdiagcr) = mat(adda + k)
	        ibufferp(ixptrp+ixdiagcr) = j -diagbgn(i) +1
	        mat(adda+k) = matmark
	        index(indc+k) = ixmark
	        info(j,3)   = info(j,3) - 1
	        ixdiagcr    = ixdiagcr + 1
	        exit
              end if 
            enddo
          enddo
	  ixptrp = ixptrp + diagel(i)
        end if
      
        if (diagcrf(i) == 1) then
          if (i == l) then
            do j=diagbgn(i),diagend(i)
       	      adda = info(j,2)
	      lvt  = info(j,3) ! lvt= length of the vector terms
	      iar  = info(j,5) ! index of row
	      indc = info(j,6)
	      do k=1,lvt ! for all elements of a row
	        ix = l-index(indc+k)+iar+1   ! index(x)=iac+1
	        if (ix == i) then          
	          bufferf(ixptrf+j) = mat(adda + k)
	          mat(adda+k) = matmark
		  index(indc+k) = ixmark
	          info(j,3)   = info(j,3) - 1
		  exit
                end if 
              enddo
            enddo
	    ixptrf = ixptrf + l
          else
            do j=diagbgn(i),diagend(i)
!             tag1 = 0
       	      adda = info(j,2)
	      lvt  = info(j,3) ! lvt= length of the vector terms
	      iar  = info(j,5) ! index of row
	      indc = info(j,6)
	      do k=1,lvt ! for all elements of a row
	        ix = l-index(indc+k)+iar+1   ! index(x)=iac+1
	        if (ix == i) then          
!       	  tag1 =1
!                 bufferf(ixptrf+ixdiagcr(ix)+1) = mat(adda + k)
                  bufferf(ixptrf+j-diagbgn(i)+1) = mat(adda + k)
	          mat(adda+k) = matmark
		  index(indc+k) = ixmark
	          info(j,3)   = info(j,3) - 1
!                 ixdiagcr(i) = ixdiagcr(i) + 1
		  exit
                end if 
              enddo
!             if (tag1 == 0) then
!               bufferf(ixptrf+ixdiagcr(i)+1) = zero
!               ixdiagcr(i) = ixdiagcr(i) + 1
!             end if
            enddo
	    ixptrf = ixptrf + diagend(i) - diagbgn(i) +1
          endif
        end if
      enddo


      lsto9 = .true.
      if (runacc == 0) then
	 call GC(mat,index,info,lmat,lindex,ia1,nvt,matmark,ixmark,
     &           endmat,endind,lsto9)
      else
	 endmax = MAX(endmat,endind)
	 call GCOPT(mat,index,info,lmat,lindex,ia1,nvt,matmark,ixmark,
     &              endmat,endind,endmax,lsto9)
      end if

      endmatn = endmat
      endindn = endind
      do i =1, 2*l -1
	 if (diagcrf(i) == 1) then
	   nvt = nvt + 1
	   if (i==l) then
	     info(nvt,1) = 1
	     info(nvt,2) = endmatn
	     info(nvt,3) = l
	     info(nvt,4) = 0
             info(nvt,5) = 0
	     endmatn = endmatn + l
           else
	     info(nvt,1) = 2
	     info(nvt,2) = endmatn
	     lvtf = diagend(i) - diagbgn(i) + 1
	     info(nvt,3) = lvtf
             info(nvt,5) = diagbgn(i) -1 
	     info(nvt,4) = diagbgn(i) -1 +l -i
	     endmatn = endmatn + lvtf
	   end if
         end if
      enddo 

      do i=1,2*l-1
	 if (diagcrp(i) == 1) then
	   nvt = nvt + 1
	   if (i==l) then
	     info(nvt,1) = 1
	     info(nvt,2) = endmatn
	     info(nvt,3) = l
	     info(nvt,4) = 0
             info(nvt,5) = 0
	     endmatn = endmatn + l
           else
	     info(nvt,1) = 3
	     info(nvt,2) = endmatn
	     info(nvt,6) = endindn
	     info(nvt,3) = diagel(i)
	     info(nvt,4) = diagbgn(i) -1 + l -i
             info(nvt,5) = diagbgn(i) -1
	     endmatn = endmatn + diagel(i)
	     endindn = endindn + diagel(i)
	   end if
         end if
      enddo

      do i = 1 , ixptrf
         mat(endmat + i) = bufferf(i)
      end do
      endmath = endmat + ixptrf

      do i = 1 , ixptrp
 	 mat(endmath +i) = bufferp(i)
 	 index(endind +i) = ibufferp(i)
      enddo

      deallocate(bufferf,bufferp,ibufferp)

      ilin(30) = endmatn
      ilin(31) = endindn
      ilin(33) = endmatn
      ilin(34) = endindn

      return
      end
