!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine ROWSRTP_NOP(mat,lmat,index,lindex,infoLU,ia1LU,nvtLU,
     *                       l,lprec,infnew,ilin,ptrmbk,startLU,
     *                       endpmat,myproc,nproc,tids,nmsg,iconv,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   R O W S R T P _ N O P   resorts the triple                    ***
!**                           (matrix,index,infoLU)                 ***
!**                           blockwise due to the row numbers in   ***
!**                           the information array <infoLU>        ***
!**                           rowwise on <nproc> processors.        ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2000 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE scriptparms
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***

      integer, intent(in) ::  lmat,lindex,l,lprec,ia1LU,myproc,nproc
      integer, intent(inout) ::  endpmat,nmsg,nvtLU
      integer, intent(out) ::  iconv,ierr
      integer, intent(in) ::  startLU,ptrmbk(nproc+1),tids(nproc)
      integer, intent(inout) :: infnew(ia1LU,ia2LU)
      integer, intent(inout) :: index(lindex),infoLU(ia1LU,ia2LU)
      integer, intent(inout) :: ilin(nilin)
      double precision, intent(inout) ::   mat(lmat)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      double precision, allocatable :: matbufs(:),matbufr(:)
      integer, allocatable :: indbufs(:),indbufr(:)
      integer, allocatable :: infbufs(:),infbufr(:)
      integer    bufsize,ihelp(6*nproc)
      integer    endmat,endmato,endmaton
      integer    matcnt,matdiff,ptrmat9,ptrmyb
      integer    maxmat,runacc
      integer    matsize,indsize,infsize
      integer    badda,adda,i,iar,indc,k,j,lbufs,lbufr,nvtbuf
      integer    iermax,lout,lvt,from,to,msgcnt,pfrom
      integer    irfilled,isfilled,infcnt,norows,ia1h,lmath,lmatorg
      integer    iertag
      integer    ier,ihs(3),ihr(3),ms1,ms2,ms3,ms4,mr1,mr2,mr3,mr4
      logical    lchgs
      real       rmax,pfac
      integer, parameter :: ixmark = -999
      double precision, parameter ::  matmark = 0.0
      double precision, parameter ::  zero = 0.0
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF LOCAL PARAMETERS :                                    ***
!**   -------------------------                                     ***
!**                                                                 ***
!--------I------I-----I------------------------------------------------
! NAME   I TYPE I I/O I     MEANING
!--------I------I-----I------------------------------------------------
!--------I------I-----I------------------------------------------------
! iertag I  I   I i/o I  gets /= 0, if the matrix <mat> can not be
!        I      I     I  resorted within the dimension <lmat> or if the
!        I      I     I  array <index> can not be resorted within the
!        I      I     I  dimension <lindex>.
!--------I------I-----I------------------------------------------------


!
!**** START OF CALCULATION :
!     ---------------------
!
      ierr     = 0
      iertag   = 0
      iconv    = 0
      norows   = 0
      bufsize  = ilin(7)
      lout     = ilin(12)
      runacc   = ilin(21)
      endmat   = endpmat
      endmaton = endmat
      ptrmat9  = endmaton
      maxmat   = lmat
      ptrmyb   = ptrmbk(myproc)
      msgcnt   = 0

      if (nproc > 1) then

        ierr  = 0
        if (bufsize < 1) then
          ierr = 1
          goto 888
        endif

        ihelp(1) = endpmat
        ihelp(2) = nvtLU
        call LL4INM(1,2,1,ihelp(1),ihelp(3),ihelp(5),myproc,nproc,
     *              tids,nmsg)
        matsize = min(ihelp(3),int(bufsize*1.e6/ireal))
        indsize = matsize
        infsize = min(ihelp(4),int(bufsize*1.e6/(iint*3*ia2LU)))
        allocate (matbufs(matsize),matbufr(matsize),stat=ierr)
        allocate (indbufs(indsize),indbufr(indsize),stat=ierr)
        allocate (infbufs(infsize*ia2),infbufr(infsize*ia2),stat=ierr)

  888   call LL4INM(1,1,1,ierr,iermax,ihelp(1),myproc,nproc,tids,nmsg)
        ierr = iermax
        if (ierr > 0) then
          iconv = 99
          if (myproc == 1) then
            write(lout,1000)
            write(lout,1040)
            write(lout,1030)
          endif
          goto 999
        endif
      endif

!
!**** Permutation of row numbers for processor i; triple (mat,index,infoLU)
!**** is put into buffers (matbufs,indbufs,infbufs) and sent to processor i;
!**** if (isfilled == 1) all data are sent 
!**** if (isfilled == 0) fill buffer again 
!**** if (irfilled == 1) all data are received 
!**** if (irfilled == 0) receive data again 
!
      do i = myproc+1,nproc
          isfilled = 0
          irfilled = 0
	  msgcnt   = msgcnt + 1


  222     infcnt = 0
	  matcnt = 0
	  lchgs  = .true.
!
!**** Resorting only works for storage pattern 'packed row'
!
          do k=1,nvtLU
	    iar = infoLU(k,3)
            if (infoLU(k,2) > 0 .and. iar >= ptrmbk(i) .and.
     *          iar < ptrmbk(i+1)) then
              infcnt = infcnt+1
	      if (infcnt > infsize) then
		infcnt = infcnt-1
		goto 333
              endif
	      adda = infoLU(k,1)
	      lvt  = infoLU(k,2)
	      indc = adda
	      if (matcnt+lvt > matsize) then
		infcnt = infcnt-1
		goto 333
              endif
	      badda = matcnt
	      do j=1,lvt
		matcnt = matcnt+1
		matbufs(matcnt) = mat(adda+j)
		mat(adda+j) = matmark
		indbufs(matcnt) = index(indc+j)
		index(indc+j) = ixmark
              enddo	
	      infbufs((infcnt-1)*ia2LU+1) = badda
	      infbufs((infcnt-1)*ia2LU+2) = infoLU(k,2)
	      infbufs((infcnt-1)*ia2LU+3) = iar
	      infoLU(k,2) = 0
            endif	
          enddo	

!**** if (.not. lchgs) ==> isfilled = 1
	  isfilled = 1

  333     if (irfilled == 0) then
            from = 2*myproc-i
	    if (from < 1) from = from + nproc
	    pfrom = tids(from)
	    call MPRCVA(pfrom,nmsg+msgcnt,3*iint,ihr,mr1,ierr)
          endif
	  if (lchgs) then
	    ihs(1) = infcnt
	    ihs(2) = matcnt
	    ihs(3) = isfilled
	    to = tids(i)
	    call MPSNDA(to,nmsg+msgcnt,3*iint,ihs,ms1,ierr)
	    call MPSNDW(to,nmsg+msgcnt,3*iint,ihs,ms1,ierr)
          endif
	  if (irfilled == 0) then
	    call MPRCVW(pfrom,nmsg+msgcnt,3*iint,ihr,mr1,ierr)
	    if (ihr(1) /= 0) then
	      lbufr = ihr(1)*ia2LU*iint
	      call MPRCVA(pfrom,nmsg+msgcnt,lbufr,infbufr,mr2,ierr)
	      call MPRCVA(pfrom,nmsg+msgcnt,ihr(2)*iint,indbufr,
     *                    mr3,ierr)
	      call MPRCVA(pfrom,nmsg+msgcnt,ihr(2)*ireal,matbufr,
     *                    mr4,ierr)       
            endif
          endif
	  if (lchgs) then
	    if (ihs(1) /= 0) then
	      lbufs = ihs(1)*ia2LU*iint
	      call MPSNDA(to,nmsg+msgcnt,lbufs,infbufs,ms2,ierr)
	      call MPSNDA(to,nmsg+msgcnt,ihs(2)*iint,indbufs,ms3,ierr)
	      call MPSNDA(to,nmsg+msgcnt,ihs(2)*ireal,matbufs,ms4,ierr)
	      call MPSNDW(to,nmsg+msgcnt,lbufs,infbufs,ms2,ierr)
	      call MPSNDW(to,nmsg+msgcnt,ihs(2)*iint,indbufs,ms3,ierr)
	      call MPSNDW(to,nmsg+msgcnt,ihs(2)*ireal,matbufs,ms4,ierr)
            endif
          endif
	  if (irfilled == 0) then
	    if (ihr(1) /= 0) then
	      call MPRCVW(pfrom,nmsg+msgcnt,lbufr,infbufr,mr2,ierr)
	      call MPRCVW(pfrom,nmsg+msgcnt,ihr(2)*iint,indbufr,
     *                    mr3,ierr)
	      call MPRCVW(pfrom,nmsg+msgcnt,ihr(2)*ireal,matbufr,
     *                    mr4,ierr)       
            endif
	    irfilled = ihr(3)
	    nvtbuf = ihr(1)
          else
	    nvtbuf = 0
          endif
		
!
!**** Insert the buffer <infbufr> into information array <infnew>,
!**** copy <matbufr> to the end of the matrix <mat> and <indbufr> to
!**** the end of <index>.
!

          if (lchgs) then
            endmato = endmaton
!
!**** Perform garbage collection on the matrix and index array -
!**** not yet sent
!

            if (runacc == 0) then
              call GCOFF(mat,index,infoLU,lmat,lindex,ia1LU,nvtLU,
     *                   matmark,ixmark,endmaton)
            else
              call GCOFFO(mat,index,infoLU,lmat,lindex,ia1LU,nvtLU,
     *                    matmark,ixmark,endmaton)
            endif

	    if (norows == 0) then
	      ptrmat9 = endmaton
	    else
	      matdiff = endmato - endmaton
              do j=1,norows
                infnew(j,1) = infnew(j,1) - matdiff
              enddo
	      if (iertag == 0) then
                do j=endmato+1,ptrmat9
                  mat(j-matdiff) = mat(j)
                enddo
                do j=endmato+1,ptrmat9
                  index(j-matdiff) = index(j)
                enddo
	      endif
              ptrmat9 = ptrmat9 - matdiff
            endif
          endif

          do k=1,nvtbuf
	    norows = norows+1
	    infnew(norows,2) = infbufr((k-1)*ia2LU+2)
	    infnew(norows,3) = infbufr((k-1)*ia2LU+3) 
	    if (ptrmat9+infnew(norows,2)>lmat) then
	      maxmat = MAX(ptrmat9+infnew(norows,2),maxmat)
	      if (iertag == 0) then
                iertag = myproc + 1000000
                write(lout,1000)
                write(lout,1010) myproc
                write(lout,1030)
              endif
            endif
            if (iertag == 0) then
	      do j=1,infnew(norows,2)
	        mat(ptrmat9+j)=matbufr(infbufr((k-1)*ia2LU+1)+j)
	      enddo
	      do j=1,infnew(norows,2)
	        index(ptrmat9+j) = indbufr(infbufr((k-1)*ia2LU+1)+j)
	      enddo
            endif
	    infnew(norows,1) = ptrmat9
	    ptrmat9 = ptrmat9 + infnew(norows,2)
          enddo  ! k=1,nvtbuf
	  if (isfilled == 0) goto 222
	  if (irfilled == 0) then
	    lchgs = .false.
	    goto 333
	  endif
      enddo  ! i=myproc+1,nproc




      do i=1,myproc
        if (i == myproc) then
!
!**** Permutation of row numbers on own processor
!
	  do k=1,nvtLU
	    iar = infoLU(k,3)
	    if (iar >= ptrmbk(i) .and.
     *          iar < ptrmbk(i+1)) then
              norows = norows+1
    	      infnew(norows,1:ia2LU) = infoLU(k,1:ia2LU)
	      infoLU(k,2) = 0
            endif
          enddo
        else
!
!**** Permutation of row numbers for processor i; triple (mat,index,infoLU)
!**** is put into buffers (matbufs,indbufs,infbufs) and sent to processor i;
!**** if (isfilled == 1) all data are sent 
!**** if (isfilled == 0) fill buffer again 
!**** if (irfilled == 1) all data are received 
!**** if (irfilled == 0) receive data again 
!
          isfilled = 0
          irfilled = 0
	  msgcnt   = msgcnt + 1


  444     infcnt = 0
	  matcnt = 0
	  lchgs  = .true.
!
!**** Resorting only works for storage pattern 'packed row'
!
          do k=1,nvtLU
	    iar = infoLU(k,3)
            if (infoLU(k,2) > 0 .and. iar >= ptrmbk(i) .and.
     *          iar < ptrmbk(i+1)) then
              infcnt = infcnt+1
	      if (infcnt > infsize) then
		infcnt = infcnt-1
		goto 555
              endif
	      adda = infoLU(k,1)
	      lvt  = infoLU(k,2)
	      indc = adda
	      if (matcnt+lvt > matsize) then
		infcnt = infcnt-1
		goto 555
              endif
	      badda = matcnt
	      do j=1,lvt
		matcnt = matcnt+1
		matbufs(matcnt) = mat(adda+j)
		mat(adda+j) = matmark
		indbufs(matcnt) = index(indc+j)
		index(indc+j) = ixmark
              enddo	
	      infbufs((infcnt-1)*ia2LU+1) = badda
	      infbufs((infcnt-1)*ia2LU+2) = infoLU(k,2)
	      infbufs((infcnt-1)*ia2LU+3) = iar
	      infoLU(k,2) = 0
            endif	
          enddo	

!**** if (.not. lchgs) ==> isfilled = 1
	  isfilled = 1

  555     if (irfilled == 0) then
            from = 2*myproc-i
	    if (from > nproc) from = from - nproc
	    pfrom = tids(from)
	    call MPRCVA(pfrom,nmsg+msgcnt,3*iint,ihr,mr1,ierr)
          endif
	  if (lchgs) then
	    ihs(1) = infcnt
	    ihs(2) = matcnt
	    ihs(3) = isfilled
	    to = tids(i)
	    call MPSNDA(to,nmsg+msgcnt,3*iint,ihs,ms1,ierr)
	    call MPSNDW(to,nmsg+msgcnt,3*iint,ihs,ms1,ierr)
          endif
	  if (irfilled == 0) then
	    call MPRCVW(pfrom,nmsg+msgcnt,3*iint,ihr,mr1,ierr)
	    if (ihr(1) /= 0) then
	      lbufr = ihr(1)*ia2LU*iint
	      call MPRCVA(pfrom,nmsg+msgcnt,lbufr,infbufr,mr2,ierr)
	      call MPRCVA(pfrom,nmsg+msgcnt,ihr(2)*iint,indbufr,
     *                    mr3,ierr)
	      call MPRCVA(pfrom,nmsg+msgcnt,ihr(2)*ireal,matbufr,
     *                    mr4,ierr)       
            endif
          endif
	  if (lchgs) then
	    if (ihs(1) /= 0) then
	      lbufs = ihs(1)*ia2LU*iint
	      call MPSNDA(to,nmsg+msgcnt,lbufs,infbufs,ms2,ierr)
	      call MPSNDA(to,nmsg+msgcnt,ihs(2)*iint,indbufs,ms3,ierr)
	      call MPSNDA(to,nmsg+msgcnt,ihs(2)*ireal,matbufs,ms4,ierr)
	      call MPSNDW(to,nmsg+msgcnt,lbufs,infbufs,ms2,ierr)
	      call MPSNDW(to,nmsg+msgcnt,ihs(2)*iint,indbufs,ms3,ierr)
	      call MPSNDW(to,nmsg+msgcnt,ihs(2)*ireal,matbufs,ms4,ierr)
            endif
          endif
	  if (irfilled == 0) then
	    if (ihr(1) /= 0) then
	      call MPRCVW(pfrom,nmsg+msgcnt,lbufr,infbufr,mr2,ierr)
	      call MPRCVW(pfrom,nmsg+msgcnt,ihr(2)*iint,indbufr,
     *                    mr3,ierr)
	      call MPRCVW(pfrom,nmsg+msgcnt,ihr(2)*ireal,matbufr,
     *                    mr4,ierr)       
            endif
	    irfilled = ihr(3)
	    nvtbuf = ihr(1)
          else
	    nvtbuf = 0
          endif
		
!
!**** Insert the buffer <infbufr> into information array <infnew>,
!**** copy <matbufr> to the end of the matrix <mat> and <indbufr> to
!**** the end of <index>.
!

          if (lchgs) then
            endmato = endmaton
!
!**** Perform garbage collection on the matrix and index array -
!**** not yet sent
!

            if (runacc == 0) then
              call GCOFF(mat,index,infoLU,lmat,lindex,ia1LU,nvtLU,
     *                   matmark,ixmark,endmaton)
            else
              call GCOFFO(mat,index,infoLU,lmat,lindex,ia1LU,nvtLU,
     *                    matmark,ixmark,endmaton)
            endif

	    if (norows == 0) then
	      ptrmat9 = endmaton
	    else
	      matdiff = endmato - endmaton
              do j=1,norows
                infnew(j,1) = infnew(j,1) - matdiff
              enddo
	      if (iertag == 0) then
                do j=endmato+1,ptrmat9
                  mat(j-matdiff) = mat(j)
                enddo
                do j=endmato+1,ptrmat9
                  index(j-matdiff) = index(j)
                enddo
	      endif
              ptrmat9 = ptrmat9 - matdiff
            endif
          endif

          do k=1,nvtbuf
	    norows = norows+1
	    infnew(norows,2) = infbufr((k-1)*ia2LU+2)
	    infnew(norows,3) = infbufr((k-1)*ia2LU+3) 
	    if (ptrmat9+infnew(norows,2)>lmat) then
	      maxmat = MAX(ptrmat9+infnew(norows,2),maxmat)
	      if (iertag == 0) then
                iertag = myproc + 1000000
                write(lout,1000)
                write(lout,1010) myproc
                write(lout,1030)
              endif
            endif
            if (iertag == 0) then
	      do j=1,infnew(norows,2)
	        mat(ptrmat9+j)=matbufr(infbufr((k-1)*ia2LU+1)+j)
	      enddo
	      do j=1,infnew(norows,2)
	        index(ptrmat9+j) = indbufr(infbufr((k-1)*ia2LU+1)+j)
	      enddo
            endif
	    infnew(norows,1) = ptrmat9
	    ptrmat9 = ptrmat9 + infnew(norows,2)
          enddo  ! k=1,nvtbuf
	  if (isfilled == 0) goto 444
	  if (irfilled == 0) then
	    lchgs = .false.
	    goto 555
	  endif
        endif  ! (i==myproc)
      enddo  ! i=1,myproc

      if (nproc > 1) then
        deallocate(matbufs,matbufr,indbufs,indbufr,infbufs,infbufr)
      endif

      nvtLU = norows
      do j=1,ia2LU
	do i=1,nvtLU
	  infoLU(i,j) = infnew(i,j)
	enddo
      enddo

      endpmat  = ptrmat9
      nmsg     = nmsg + msgcnt


      call LL4INM(1,1,1,iertag,iermax,ihelp,myproc,nproc,tids,nmsg)
      if (iermax /= 0) then
        ierr = iermax
        if (myproc == 1) then
          do i=2,nproc
            from = tids(i)
            call MPRCVA(from,nmsg+i,5*iint,ihelp(1+5*(i-1)),mr1,ier)
            call MPRCVW(from,nmsg+i,5*iint,ihelp(1+5*(i-1)),mr1,ier)
          enddo
          ihelp(1) = nvtLU
          ihelp(2) = ia1LU
          ihelp(3) = maxmat
          ihelp(4) = lmat
          ihelp(5) = ilin(33)
        else
          to = tids(1)
          ihelp(1) = nvtLU
          ihelp(2) = ia1LU
          ihelp(3) = maxmat
          ihelp(4) = lmat
          ihelp(5) = ilin(33)
          call MPSNDA(to,nmsg+myproc,5*iint,ihelp,ms1,ier)
          call MPSNDW(to,nmsg+myproc,5*iint,ihelp,ms1,ier)
        endif
        nmsg = nmsg+nproc-1
        if (myproc == 1) then
          write(lout,1020)
          write(lout,1022)
          rmax = 0.0
          ier  = 0
          call getKeyword('LINSOL_INFO_FACTOR',pfac,ier)
          do i=1,nproc
            nvtLU  = ihelp(1+5*(i-1))
            ia1h = ihelp(2+5*(i-1))
            if (nvtLU > ia1h) then
              write(lout,1023) ia1h,nvtLU,i
              if (ier == 0) then
                if (REAL(nvtLU)*pfac/REAL(ia1h) > rmax)
     *              rmax = REAL(nvtLU)*pfac/REAL(ia1h)
              else
                if (REAL(nvtLU)/REAL(ia1h) > rmax)
     *              rmax = REAL(nvtLU)/REAL(ia1h)
              endif
            endif
          enddo
          if (rmax > 0.0) write(lout,1024) rmax

          rmax = 0.0
          do i=1,nproc
            endmat = ihelp(3+5*(i-1))
            lmath  = ihelp(4+5*(i-1))
            lmatorg= ihelp(5+5*(i-1))
            if (endmat > lmath) then
              write(lout,1025) lmath,endmat,i
	      pfac = (endmat - lmath)/lprec
	      rmax = MAX((lprec*(1+pfac) - startLU)/lmatorg,rmax)
            endif
          enddo
          if (rmax > 0.0) write(lout,1026) rmax

          write(lout,1030)
        endif
        iconv = 99
      endif

 1000 format(' **********************************************'/
     &       ' ***  ERROR occured in LSOLP (ROWSRTP_NOP): ***')
 1010 format(' ***   Dimension <lpmat> of array <pmat> is ***'/
     &       ' ***   too small on processor ',i6,'        ***')
 1020 format(' **********************************************'/
     &       ' ***  ERROR occured in ROWSRTP_NOP:         ***'/
     &       ' ***  (routine redistributs rows of matrix) ***')
 1021 format(' ***   check input parameters!              ***')
 1022 format(' ***   One of the following parameters      ***'/
     &       ' ***   is too small: ia1LU,lpmat,lpix!      ***')
 1023 format(' ***   <ia1LU> is ',i6,', but must be       ***'/
     &       ' ***   greater than ',i6,' on process       ***'/
     &       ' ***   ',i6,' for sectioning!               ***')
 1024 format(' ***   Try                                  ***'/
     &       ' ***   <LINSOL_INFO_FACTOR> > ',f8.2,' or   ***'/
     &       ' ***   enlarge <ia1LU>! Call programmer!!!  ***')
 1025 format(' ***   <lmat> is ',i9,', but must be     ***'/
     &       ' ***   greater than ',i9,' on            ***'/
     &       ' ***   process(or) ',i6,' !                 ***')
 1026 format(' ***   Try                                  ***'/
     &       ' ***   <LINSOL_GAUSS_FACTOR> > ',f8.4,'     ***'/
     &       ' ***   or set <rlin(4)> to the above        ***'/
     &       ' ***   mentioned factor!                    ***')
 1030 format(' **********************************************')
 1040 format(' ***    Buffer allocation failed!!! Either  ***'/
     &       ' ***    the chosen buffer size is too large ***'/
     &       ' ***    or the buffer size has not been     ***'/
     &       ' ***    set by the user! (>> set ilin(7))   ***')

  999 R E T U R N
C------END OF ROWSRTP_NOP--------------------------------------------
      E N D                                   
