!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine SHIFTU_BEG(pmat,lpmat,pix,lpix,infoU,ia1LU,nvtU,
     *                      ilin,lenU,lenL,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   S H I F T U _ B E G  shifts the packed rows of U and its      ***
!**                        indices back to the end of the           ***
!**                        factorized matrix part L.                ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 2000 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer,intent(in) ::  lpmat,lpix,ia1LU,lenU,lenL,nvtU
      integer,intent(inout) ::  infoU(ia1LU,ia2LU)
      integer,intent(inout) ::  ilin(nilin),pix(lpix)
      integer,intent(out) ::  ierr
      double precision,intent(inout):: pmat(lpmat)
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           i,shiftUl,ptrlu
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF LOCAL PARAMETERS :                                    ***
!**   -------------------------                                     ***
!**                                                                 ***
!--------I------I-----I------------------------------------------------
! NAME   I TYPE I I/O I     MEANING
!--------I------I-----I------------------------------------------------
!--------I------I-----I------------------------------------------------
! ptrlu  I  I   I i/o I  Pointer to the last element of matrix L
!--------I------I-----I------------------------------------------------
!
!
!**** START OF CALCULATION :
!     ---------------------
!
      shiftUl = lpmat - lenU

      ierr = 0

      if (lenL >= shiftUl) then
        ierr = 10112
        goto 999
      endif

      do i=1,lenU
	pmat(lenL+i) = pmat(shiftUl+i)
      enddo

      do i=1,lenU
	pix(lenL+i) = pix(shiftUl+i)
      enddo

      shiftUl = shiftUl - lenL
      do i=1,nvtU
	infoU(i,1) = infoU(i,1) - shiftUl
      enddo

      ptrlu = lenL + lenU
      ilin(37) = ptrlu

 999  R E T U R N
!------END OF SHIFTU_BEG------------------------------------------------
      E N D                                   
