!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine STO19_BUF(lmatnew,lindnew,matnew,indnew,infnew,ia1new,
     *                     rbuf,nofrows,nofcols,js,ptrmyb,ptrmat1,
     *                     ptrmat9,ptrind9,ptrinfo,threshold,cr_md)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   S T O 1 9 _ B U F  stores a buffer of bufsize (in MByte) into ***	
!**                      matrix of type 1 - if (cr_md) - and type 9.***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1998 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer  nofrows,nofcols,ptrmat1,threshold
      integer  ptrmat9,ptrind9,ptrinfo,ptrmyb
      integer  lmatnew,lindnew,ia1new,js
      integer  indnew(lindnew),infnew(ia1new,ia2)
      logical  cr_md
      double precision matnew(lmatnew)
      double precision rbuf(nofrows,nofcols)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!--------I------I-----I------------------------------------------------
! NAME   I TYPE I I/O I     MEANING
!--------I------I-----I------------------------------------------------
!--------I------I-----I------------------------------------------------
! cr_md  I  L   I in  I  is true, if a main diagonal should be stored
!--------I------I-----I------------------------------------------------
! js     I  I   I in  I  points to the first row of the matrix to be
!        I      I     I  stored.
!--------I------I-----I------------------------------------------------
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer    adda,i,indc,j,noelt9

!
!**** START OF CALCULATION :
!     ---------------------
!

      do i = 1,nofrows
	if (cr_md) then
	  if (abs(rbuf(i,i+js-1)) .gt. threshold) then
	    matnew(ptrmat1+js-1+i) = rbuf(i,i+js-1)
          endif
        endif
        noelt9 = 0
	adda = ptrmat9
	indc = ptrind9
        do j = 1,nofcols
          if (abs(rbuf(i,j)) .gt. threshold) then
	    noelt9 = noelt9 + 1
	    ptrmat9 = ptrmat9 + 1
	    ptrind9 = ptrind9 + 1
	    matnew(ptrmat9) = rbuf(i,j)
	    indnew(ptrind9) = j
          endif
        enddo
	if (noelt9 .gt. 0) then
	  ptrinfo = ptrinfo + 1
	  infnew(ptrinfo,1) = 9
	  infnew(ptrinfo,2) = adda
	  infnew(ptrinfo,3) = noelt9
	  infnew(ptrinfo,4) = 0
	  infnew(ptrinfo,5) = js-2+i+ptrmyb
	  infnew(ptrinfo,6) = indc
	  infnew(ptrinfo,7) = 0
        endif
      enddo

      R E T U R N
!------END OF STO19_BUF--------------------------------------------
      E N D                                   
