!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine VTSORT(mat,lmat,index,lindex,info,ia1,dw,iw,lglobal,
     &                  nvt)
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   V T S O R T  sorts the vector terms within <index> and <mat>  ***
!**                increasingly due to increasing indices within    ***
!**                a single vector term.                            ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1999 University Karlsruhe                      ***
!**    PROGRAMMER: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in) ::  ia1,lmat,lindex,lglobal,nvt
      integer, intent(in) ::  info(ia1,ia2),iw(lglobal)
      integer, intent(inout) ::  index(lindex)
      double precision, intent(inout) :: dw(lglobal),mat(lmat)
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolp>)                                    ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer           adda,indc,k,j,lvt

!
!**** START OF CALCULATION :
!     ---------------------
!

!
!***  Sort indices of the corresponding matrix values within vector terms
!
      do k=1,nvt
        adda = info(k,2)
        lvt  = info(k,3)
        indc = info(k,6)
        call HEAPSORTIX(index(indc+1),iw,lvt,.true.)
        do j=1,lvt
          dw(j) = mat(adda+iw(j))
        enddo
        do j=1,lvt
          mat(adda+j) = dw(j)
        enddo
      enddo

      r e t u r n
!------END OF VTSORT----------------------------------------------
      e n d
