!***********************************************************************
!        1         2         3         4         5         6         7 *
!***********************************************************************
!**                                                                  ***
!**                                                                  ***
      subroutine LINOUT(MAT,lmat,index,lindex,info,ia1,nvt,l,lsym,
     &                  ilin,unit,ierr)
!**                                                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    L I N O U T   saves a matrix in LINSOL-format                 ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
!**    Copyright (C) 1996 University Karlsruhe                       ***
!**    Programmer : H. Haefner                                       ***
!**                                                                  ***
!**    This file is part of LINSOL.                                  ***
!**    LINSOL is free software; you can redistribute it and/or       ***
!**    modify it under the terms of the GNU General Public License   ***
!**    as published by the Free Software Foundation; either          ***
!**    version 2 of the License, or (at your option) any later       ***
!**    version.                                                      ***
!**                                                                  ***
!**    LINSOL is distributed in the hope that it will be useful,     ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty   ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.       ***
!**    See the GNU General Public License for more details.          ***
!**                                                                  ***
!**    You should have received a copy of the GNU General Public     ***
!**    License along with LINSOL; if not, write to the Free          ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,       ***
!**    Boston, MA  02111-1307, USA.                                  ***
!**                                                                  ***
!***********************************************************************
!**                                                                  ***
       USE constants

       implicit none
!**                                                                  *** 
!***********************************************************************
!**                                                                  ***
!**    formal parameters :                                           ***
!**                                                                  ***
!***********************************************************************
       integer l,lmat,lindex,nvt,ia1,unit,ierr
       integer info(ia1,ia2),index(lindex),ilin(nilin)
       double precision MAT(lmat)
       logical lsym
!***********************************************************************
!**                                                                  ***
!**    list of formal parameters :                                   ***
!**                                                                  ***
!**                                                                  ***
!---------I------I-----I------------------------------------------------
! name    I type I i/o I meaning
!---------I------I-----I------------------------------------------------
! l       I int  I in  I dimension of the matrix
!---------I------I-----I------------------------------------------------
! lmat    I int  I in  I number of nonzero elements
!---------I------I-----I------------------------------------------------
! lindex  I int  I in  I number of indices
!---------I------I-----I------------------------------------------------
! nvt     I int  I in  I total number of vector-terms
!---------I------I-----I------------------------------------------------
! ia1     I int  I in  I 1.dimension of info-array
!---------I------I-----I------------------------------------------------
! ia2     I int  I in  I 2.dimension of info-array
!---------I------I-----I------------------------------------------------
! info    I int  I in  I array with matrix-structure-information
!---------I------I-----I------------------------------------------------
! index   I int  I in  I array with indices
!---------I------I-----I------------------------------------------------
! MAT     I real I in  I array with nonzero matrix-elements
!---------I------I-----I------------------------------------------------
! lsym    I l    I in  I indicates if matrix is symmetrical
!---------I------I-----I------------------------------------------------
! lout    I int  I in  I standard output unit 
!---------I------I-----I------------------------------------------------
! unit    I int  I in  I i/o-unit to write to
!---------I------I-----I------------------------------------------------
! ierr    I int  I out I error-indication
!---------I------I-----I------------------------------------------------
!**                                                                  ***
!**                                                                  ***
!**    local variables :                                             ***
!**                                                                  ***
       integer nvecs(ntyp),i,j,idoku,lout,myproc
!**                                                                  ***
!**                                                                  ***
!***********************************************************************
!**    start of calculation                                          ***
!***********************************************************************
!**                                                                  
       rewind(unit)
       if ((ilin(33) .gt. 0) .and. (ilin(33) .le. lmat) .and.
     &     (ilin(34) .gt. 0) .and. (ilin(34) .le. lindex)) then
         write(unit,*) ilin(33),ilin(34),l,lsym,nvt
       else
         write(unit,*) lmat,lindex,l,lsym,nvt
       endif
!**
!**    calculate the number of each storage-typ
!**
       do 1 i=1,ntyp
         nvecs(i)=0
1      continue
       do 2 i=1,nvt
	 if (info(i,1) .eq. 1 .or. info(i,1) .eq. 10)
     &     nvecs(1)=nvecs(1)+1
	 if (info(i,1) .eq. 2 .or. info(i,1) .eq. 20)
     &     nvecs(2)=nvecs(2)+1
	 if (info(i,1) .eq. 3 .or. info(i,1) .eq. 30)
     &     nvecs(3)=nvecs(3)+1
	 if (info(i,1) .eq. 4 .or. info(i,1) .eq. 40)
     &     nvecs(4)=nvecs(4)+1
	 if (info(i,1) .eq. 5 .or. info(i,1) .eq. 50)
     &     nvecs(5)=nvecs(5)+1
	 if (info(i,1) .eq. 6 .or. info(i,1) .eq. 60)
     &     nvecs(6)=nvecs(6)+1
	 if (info(i,1) .eq. 7 .or. info(i,1) .eq. 70)
     &     nvecs(7)=nvecs(7)+1
	 if (info(i,1) .eq. 8 .or. info(i,1) .eq. 80)
     &     nvecs(8)=nvecs(8)+1
	 if (info(i,1) .eq. 9 .or. info(i,1) .eq. 90)
     &     nvecs(9)=nvecs(9)+1
	 if (info(i,1) .eq. 11 .or. info(i,1) .eq. 100)
     &     nvecs(11)=nvecs(11)+1
2      continue

       if ((ilin(12) .ne. 0) .and. (ilin(17) .ne. 0)) then
         lout  = ilin(12)
         idoku = ilin(13)
         myproc= ilin(17)
       else
	 lout   = 6
	 idoku  = 1
	 myproc = 1
       endif

       do 3 i=1,9
         if (idoku .gt. 0) then
           if (myproc .eq. 1) write(lout,1000) nvecs(i),i
         endif
         if (idoku .lt. 0) then
           write(lout,1000) nvecs(i),i
         endif
3      continue
       if (idoku .gt. 0) then
         if (myproc .eq. 1) write(lout,1000) nvecs(ntyp),ntyp
       endif
       if (idoku .lt. 0) then
         write(lout,1000) nvecs(ntyp),ntyp
       endif
!**
!**    write main-diagonal if storage-typ used
!**
       do 10 i=1,nvt
         if (info(i,1) .eq. 1 .or. info(i,1) .eq. 10) then   
           write(unit,*) 1,1
           write(unit,*) (MAT(info(i,2)+j), j=1,l)
         endif
10     continue
!**
!**    write diagonals if storage-typ used
!**
       if (nvecs(2).gt.0) then
         write(unit,*) 2,nvecs(2)
         do 20 i=1,nvt
           if (info(i,1) .eq. 2 .or. info(i,1) .eq. 20) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
20       continue
       endif
!**
!**    write packed-diagonals if storage-typ used
!**
       if (nvecs(3).gt.0) then
         write(unit,*) 3,nvecs(3)
         do 30 i=1,nvt
           if (info(i,1) .eq. 3 .or. info(i,1) .eq. 30) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (index(info(i,6)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
30       continue
       endif
!**
!**    write row-format if storage-typ used
!**
       if (nvecs(4).gt.0) then
         write(unit,*) 4,nvecs(4)
         do 40 i=1,nvt
           if (info(i,1) .eq. 4 .or. info(i,1) .eq. 40) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (index(info(i,6)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
40       continue
       endif
!**
!**    write column-format if storage-typ used
!**
       if (nvecs(5).gt.0) then
         write(unit,*) 5,nvecs(5)
         do 50 i=1,nvt
           if (info(i,1) .eq. 5 .or. info(i,1) .eq. 50) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (index(info(i,7)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
50       continue
       endif
!**
!**    write sky-format if storage-typ used
!**
       if (nvecs(6).gt.0) then
         write(unit,*) 6,nvecs(6)
         do 60 i=1,nvt
           if (info(i,1) .eq. 6 .or. info(i,1) .eq. 60) then
             write(unit,*) info(i,3)
             write(unit,*) (index(info(i,6)+j), j=1,info(i,3))
             write(unit,*) (index(info(i,7)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
60       continue
       endif
!**
!**    write full-row-format if storage-typ used
!**
       if (nvecs(7).gt.0) then
         write(unit,*) 7,nvecs(7)
         do 70 i=1,nvt
           if (info(i,1) .eq. 7 .or. info(i,1) .eq. 70) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
70       continue
       endif
!**
!**    write full-column-format if storage-typ used
!**
       if (nvecs(8).gt.0) then
         write(unit,*) 8,nvecs(8)
         do 80 i=1,nvt
           if (info(i,1) .eq. 8 .or. info(i,1) .eq. 80) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
80       continue
       endif
!**
!**    write packed row-format if storage-typ used
!**
       if (nvecs(9).gt.0) then
         write(unit,*) 9,nvecs(9)
         do 90 i=1,nvt
           if (info(i,1) .eq. 9 .or. info(i,1) .eq. 90) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (index(info(i,6)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
90       continue
       endif
!**
!**    write packed column-format if storage-typ used
!**
       if (nvecs(11).gt.0) then
         write(unit,*) 11,nvecs(11)
         do 110 i=1,nvt
           if (info(i,1) .eq. 11 .or. info(i,1) .eq. 100) then
             write(unit,*) info(i,3),info(i,4),info(i,5)
             write(unit,*) (index(info(i,7)+j), j=1,info(i,3))
             write(unit,*) (MAT(info(i,2)+j), j=1,info(i,3))
           endif
110       continue
       endif

 1000 format('    - writing ',i6,'-times storage pattern ',i6)
      r e t u r n
!-----END OF LINOUT---------------------------------------------------
      e    n    d
