C:::::      ,,,,,LL1CGB2.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL1CGB2(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #                   mat,prec,x,b,
     #                   iprec,index,ia1,info,dw,iw,
     #                   ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #                   eps,epslin,iconv,ierr)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 1 C G B 2    BiCGSTAB2-method for the solution of      ***
C**      the linear system    MAT * x = b.                          ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1999 University Karlsruhe                      ***
C**    Programmer: Kirsten Foerster, H. Haefner                     ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**      (ldw must be 20*l)                                         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           ldw,liw,lmat,lprec,liprec,lindex,l,ia1,nproc,
     #                  index(lindex),info(ia1,ia2),lmatbk(nproc),
     #                  ptrmbk(nproc+1),jump(nproc),tids(nproc),
     #                  ptrinf(ntyp+1,nproc),iprec(liprec),iw(liw),
     #                  ilin(nilin),iconv,ierr,nmsg
      double precision  mat(lmat),prec(lprec),x(l),b(l),
     #                  dw(ldw),eps,epslin
      logical           lsym
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :    (see man-page <lsolpp>)        ***
C**   -------------------------                                     ***
C**                                                                 ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      double precision   rho0, rho1, alfa, beta, gamma, omega1,
     *                   omega2, mue, nue, tau                       
      logical  break
      integer  swap,niter,niter2,lglobal
      external LL6AX
      logical  ladd,lsmo,lfel
      integer  i,imvm,count,lout,myproc,lmyblk,z,ione,branch
      integer  ibr0, ibr, ibrs, ibs, ibt, ibu, ibv, ibw, ibx, ibxs,   
     *         ibcom, ptrl(3),ptrr(2)
      integer  ibPu,ibPr,ibPv,ibPs,ibtmp
      double precision zero,one,sprod(6),help(6),rpoly,rseucn,rshelp,
     *                 r0iter,stopit,stopit2
      character*10  method 

      common /norms/ rseucn,rpoly(3)
C**                                                                 ***
C**        CONSTANTS :                                              ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero=0.0, one=1.0, stopit=0.1, stopit2=0.04, ione=1)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   --------------------                                          ***
C**                                                                 ***
      method = 'BiCGSTAB2 '
      ladd = .false.
C**                                                                 ***
      imvm  = ilin(10)
      iconv = 0
C**                                                                 ***
      lout   = ilin(12)
      myproc = ilin(17)
      lsmo   = ilin(18) .ne. 0
      lglobal= ilin(36)
      lmyblk = lmatbk(myproc)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** SET POINTERS :                                                ***
C**   ------------                                                  ***
C**                                                                 ***
      ibr0=0*l+1
      ibr=1*l+1
      ibrs=2*l+1
      ibs=3*l+1
      ibt=4*l+1
      ibu=5*l+1
      ibv=6*l+1
      ibw=7*l+1
      ibx=8*l+1
      ibxs=9*l+1
      ibPu=10*l+1
      ibPr=11*l+1
      ibPv=12*l+1
      ibPs=13*l+1
      ibcom=14*l+1

      if ((mod(ilin(8),3) .eq. 1) .or. (ilin(8) .eq. 0) .or.
     &    (ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
        ibPu = ibu
        ibPr = ibr
        ibPv = ibv
        ibPs = ibs
      endif
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
      include "norec.h"
      do 110 i = 1,l
        x(i)  = zero
        dw(i+ibr-1) = - b(i)
  110 continue

      include "norec.h"
      do 122 i=0,l-1
        dw(ibrs+i) = dw(ibr+i)
        dw(ibx+i) = x(i+1)
        dw(ibxs+i) = x(i+1)
  122 continue

      count = 0
C**                                                                 ***
C***  COMPUTE ||r0||2                                               ***
C**                                                                 ***
      call LL3AXB(dw(ibrs),dw(ibr),dw(ibxs),dw(ibx),
     &            b,prec,dw(ibcom),l,lprec,lmyblk,epslin,
     &            ptrmbk,lmatbk,ptrinf,jump,mat,lmat,index,
     &            lindex,info,ia1,lsym,ladd,
     &            method,.true.,myproc,nproc,tids,nmsg,ilin,ierr,
     &            count,imvm,branch)
      goto (910,920,930) branch
C**                                                                 ***
C***  INITIAL VALUES                                                ***
C**                                                                 ***
      r0iter = rseucn
      niter  = max(400,l*nproc/25)
      niter2 = max(100,l*nproc/100)

      rho0   =  one
      alfa   =  zero
      omega2 =  one
      break  = .false.
      include "norec.h"
      do 2001 z=0,lmyblk-1
        dw(ibu+z) = zero
        dw(ibr0+z) = dw(ibr+z)
 2001 continue

      goto 111

C**                                                                 ***
C***  RESTART
C**                                                                 ***

  101 continue
      if (lsmo) then
        include "norec.h"
        do 2002 z=0,lmyblk-1
          dw(ibu+z) = zero
          dw(ibr+z) = dw(ibrs+z)
          dw(ibr0+z)= dw(ibrs+z)
          dw(ibx+z) = dw(ibxs+z)
 2002   continue
      else
        include "norec.h"
        do 2102 z=0,lmyblk-1
          dw(ibu+z) = zero
          dw(ibr0+z)= dw(ibr+z)
 2102   continue
      endif
      rho0    = one
      alfa    = zero
      omega2  = one
C**                                                                 ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C***  START OF THE ITERATION-LOOP                                   ***
C**                                                                 ***

  111 continue
      count = count+1

      rho0 = -omega2*rho0 


      if (rho0 .eq. zero) then
	if (ilin(13) .lt. 0) write(lout,1350) count
	if (ilin(13) .ge. 0) then
          if (myproc .eq. 1) write(lout,1350) count
	endif
	break = .true.
	goto 101
      endif


C**                                                                 ***
C***  COMPUTATION OF RHO1                                           ***
C**                                                                 ***
      call LL4SCP(lmyblk,1,l,1,dw,ibr0,dw,ibr,rho1,help,.false.,
     #            myproc,nproc,tids,nmsg)



      beta = alfa * rho1/rho0
      rho0 = rho1

      include "norec.h"
      do 2003 z=0,lmyblk-1
	dw(ibu+z) = -dw(ibr+z)-beta*dw(ibu+z)
 2003 continue

C**                                                                 ***
C***  COMPUTATION OF P*u                                           ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 1 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibu),dw(ibPu),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(8)+1),dw(ibu),dw(ibPu),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(14)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(4),iprec(5),iprec(6),
     #             iprec(iprec(13)+1),iprec(iprec(12)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibu),dw(ibPu),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibu),dw(ibPu),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 72)) ibtmp = ibu
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) ibtmp = ibPu
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 66) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 75)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibtmp),dw(ibPu),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPu),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
          call RHSIXSRTG(dw(ibPu),iprec(iprec(15)+1),l,lglobal,lmatbk,
     #                   ptrmbk,myproc,nproc,tids,nmsg)
        endif
      endif

c**                                                                 ***
C***  COMPUTATION OF A*P*u                                         ***
C**                                                                 ***
      call LL3AX(LL6AX,mat,dw(ibPu),dw(ibv),dw(ibcom),ptrmbk,lmatbk,
     #           ptrinf,l,nproc,tids,myproc,jump,
     #           ladd,lmat,lindex,ia1,info,index,nmsg)
      imvm=imvm+1

C**                                                                 ***
C***  COMPUTATION OF PL*A*PR*u                                      ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibv),dw(ibv),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(7)+1),dw(ibv),dw(ibv),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(11)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
     #             iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibv),dw(ibv),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibv),dw(ibv),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibv),dw(ibv),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibv),dw(ibv),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
      endif

C**                                                                 ***
C***  COMPUTATION OF GAMMA                                          ***
C**                                                                 ***

      call LL4SCP(lmyblk,1,l,1,dw,ibv,dw,ibr0,gamma,help,.false.,
     #            myproc,nproc,tids,nmsg)

      if (gamma .eq. zero) then
	if (break) then
         ierr = 1231
	 if (ilin(13) .lt. 0) then 
	  write(lout,1020)
	  write(lout,1250)
	  write(lout,1030)
         endif
	 if (ilin(13) .ge. 0) then
	  if (myproc .eq. 1) then
	    write(lout,1020)
	    write(lout,1250)
	    write(lout,1030)
	  endif
         endif
	 goto 940
        else
	 if (ilin(13) .lt. 0) write(lout,1350) count
         if (ilin(13) .ge. 0) then
           if (myproc .eq. 1) write(lout,1350) count
         endif
	 break = .true.
	 goto 101
        endif
      endif
      break = .false.
      

      alfa = -(rho0/gamma)

      include "norec.h"
      do 2004 z=0,lmyblk-1
        dw(ibr+z) = -dw(ibr+z)-alfa*dw(ibv+z)
 2004 continue

C**                                                                 ***
C***  COMPUTATION OF P*r                                           ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 1 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibr),dw(ibPr),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(8)+1),dw(ibr),dw(ibPr),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(14)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(4),iprec(5),iprec(6),
     #             iprec(iprec(13)+1),iprec(iprec(12)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibr),dw(ibPr),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibr),dw(ibPr),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 72)) ibtmp = ibr
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) ibtmp = ibPr
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 66) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 75)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPr),iprec(iprec(15)+1),l,
     #                lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPr),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
          call RHSIXSRTG(dw(ibPr),iprec(iprec(15)+1),l,lglobal,lmatbk,
     #                   ptrmbk,myproc,nproc,tids,nmsg)
        endif
      endif

C**                                                                 ***
C***  COMPUTATION OF A*P*r                                         ***
C**                                                                 ***
      call LL3AX(LL6AX,mat,dw(ibPr),dw(ibs),dw(ibcom),ptrmbk,lmatbk,
     #           ptrinf,l,nproc,tids,myproc,jump,
     #           ladd,lmat,lindex,ia1,info,index,nmsg)
      imvm=imvm+1

C**                                                                 ***
C***  COMPUTATION OF PL*A*PR*r                                      ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibs),dw(ibs),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(7)+1),dw(ibs),dw(ibs),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(11)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
     #             iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibs),dw(ibs),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibs),dw(ibs),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibs),dw(ibs),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibs),dw(ibs),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
      endif

      include "norec.h"
      do 2005 z=0,lmyblk-1
	dw(ibx+z) = dw(ibx+z)+alfa*dw(ibPu+z)
 2005 continue


C**                                                                 ***
C***  COMPUTATION OF RHO1                                           ***
C**                                                                 ***
      call LL4SCP(lmyblk,1,l,1,dw,ibr0,dw,ibs,rho1,help,.false.,
     #            myproc,nproc,tids,nmsg)
     
      beta = -(alfa*rho1/rho0)
      rho0 = -rho1

      include "norec.h"
      do 2006 z=0,lmyblk-1
	dw(ibv+z) = dw(ibs+z)-beta*dw(ibv+z)
 2006 continue




C**                                                                 ***
C***  COMPUTATION OF P*v                                           ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 1 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibv),dw(ibPv),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(8)+1),dw(ibv),dw(ibPv),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(14)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(4),iprec(5),iprec(6),
     #             iprec(iprec(13)+1),iprec(iprec(12)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibv),dw(ibPv),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibv),dw(ibPv),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 72)) ibtmp = ibv
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) ibtmp = ibPv
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 66) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 75)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPv),iprec(iprec(15)+1),l,
     #                lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPv),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
          call RHSIXSRTG(dw(ibPv),iprec(iprec(15)+1),l,lglobal,lmatbk,
     #                   ptrmbk,myproc,nproc,tids,nmsg)
        endif
      endif

C**                                                                 ***
C***  COMPUTATION OF A*P*v                                         ***
C**                                                                 ***
      call LL3AX(LL6AX,mat,dw(ibPv),dw(ibw),dw(ibcom),ptrmbk,lmatbk,
     #           ptrinf,l,nproc,tids,myproc,jump,
     #           ladd,lmat,lindex,ia1,info,index,nmsg)
      imvm=imvm+1

C**                                                                 ***
C***  COMPUTATION OF PL*A*PR*v                                      ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibw),dw(ibw),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(7)+1),dw(ibw),dw(ibw),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(11)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
     #             iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibw),dw(ibw),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibw),dw(ibw),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibw),dw(ibw),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibw),dw(ibw),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
      endif



C**                                                                 ***
C***  COMPUTATION OF GAMMMA                                         ***
C**                                                                 ***
      call LL4SCP(lmyblk,1,l,1,dw,ibw,dw,ibr0,gamma,help,.false.,
     #            myproc,nproc,tids,nmsg)

      if (gamma .eq. zero) then
	if (break) then
         ierr = 1232
	 if (ilin(13) .lt. 0) then 
	  write(lout,1020)
	  write(lout,1250)
	  write(lout,1030)
         endif
	 if (ilin(13) .ge. 0) then
	  if (myproc .eq. 1) then
	    write(lout,1020)
	    write(lout,1250)
	    write(lout,1030)
	  endif
         endif
	 goto 940
        else
	 if (ilin(13) .lt. 0) write(lout,1350) count
         if (ilin(13) .ge. 0) then
           if (myproc .eq. 1) write(lout,1350) count
         endif
	 break = .true.
	 goto 101
        endif
      endif
      break = .false.

      alfa = -(rho0/gamma)

      include "norec.h"
      do 2007 z=0,lmyblk-1
	dw(ibu+z) = dw(ibr+z)-beta*dw(ibu+z)
	dw(ibr+z) = dw(ibr+z)-alfa*dw(ibv+z)
	dw(ibs+z) = dw(ibs+z)-alfa*dw(ibw+z)
 2007 continue

      if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 66) .or.
     #    (ilin(8) .eq. 72) .or. (ilin(8) .eq. 75)) then
        include "norec.h"
        do z=0,lmyblk-1
	  dw(ibPu+z) = dw(ibPr+z)-beta*dw(ibPu+z)
	  dw(ibPr+z) = dw(ibPr+z)-alfa*dw(ibPv+z)
        enddo
      endif

C**                                                                 ***
C***  COMPUTATION OF P*s                                           ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 1 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibs),dw(ibPs),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(8)+1),dw(ibs),dw(ibPs),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(14)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(4),iprec(5),iprec(6),
     #             iprec(iprec(13)+1),iprec(iprec(12)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibs),dw(ibPs),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibs),dw(ibPs),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 72)) ibtmp = ibs
        if ((ilin(8) .eq. 66) .or. (ilin(8) .eq. 75)) ibtmp = ibPs
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 66) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 75)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPs),iprec(iprec(15)+1),l,
     #                lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibtmp),dw(ibPs),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
          call RHSIXSRTG(dw(ibPs),iprec(iprec(15)+1),l,lglobal,lmatbk,
     #                   ptrmbk,myproc,nproc,tids,nmsg)
        endif
      endif

C**                                                                 ***
C***  COMPUTATION OF A*P*s                                         ***
C**                                                                 ***
      call LL3AX(LL6AX,mat,dw(ibPs),dw(ibt),dw(ibcom),ptrmbk,lmatbk,
     #           ptrinf,l,nproc,tids,myproc,jump,
     #           ladd,lmat,lindex,ia1,info,index,nmsg)
      imvm=imvm+1

C**                                                                 ***
C***  COMPUTATION OF PL*A*PR*s                                      ***
C**                                                                 ***
      if (mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then
        if (ilin(8) .ge. 1 .and. ilin(8) .le. 30) then
          call LL2IT(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     #             lsym,ia1,info,mat,prec,dw(ibt),dw(ibt),dw,iprec,
     #             index,iw,ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
     #             iconv,ierr)
        endif
        if (ilin(8) .ge. 31 .and. ilin(8) .le. 60) then
          call LL3AX(LL6AX,prec(iprec(7)+1),dw(ibt),dw(ibt),
     #             dw(ibcom),ptrmbk,lmatbk,iprec(iprec(11)+1),l,nproc,
     #             tids,myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
     #             iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
          imvm=imvm+1
        endif
        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then
          lfel = .true.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibt),dw(ibt),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibt),dw(ibt),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
        if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
          lfel = .false.
          if (nproc == 1) then
            call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                 iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                 iprec(3),dw(ibt),dw(ibt),iprec(iprec(15)+1),l,
     #                 lfel,ierr)
          else
            call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),dw(ibt),dw(ibt),iprec(iprec(15)+1),
     #                ptrmbk,l,lglobal,ilin(38),lfel,
     #                myproc,nproc,tids,nmsg,ierr)
          endif
        endif
      endif



C**                                                                  ***
C*** COMPUTATION OF OMEGA1, MUE, NUE, TAU                            ***
C**                                                                  ***
      ptrl(1)=ibr
      ptrl(2)=ibs
      ptrl(3)=ibt
      ptrr(1)=ibs
      ptrr(2)=ibt
      call LL4SCP(lmyblk,3,l,2,dw,ptrl,dw,ptrr,sprod,help,.false.,
     #            myproc,nproc,tids,nmsg)
      omega1 = sprod(1)
      mue    = sprod(2)
      nue    = sprod(3)
      tau    = sprod(6)
      omega2 = sprod(4) 

      if (mue .eq. zero .or. tau .eq. zero) then
	if (break) then
         ierr = 1233
	 if (ilin(13) .lt. 0) then 
	  write(lout,1020)
	  write(lout,1250)
	  write(lout,1030)
         endif
	 if (ilin(13) .ge. 0) then
	  if (myproc .eq. 1) then
	    write(lout,1020)
	    write(lout,1250)
	    write(lout,1030)
	  endif
         endif
	 goto 940
        else
	 if (ilin(13) .lt. 0) write(lout,1350) count
         if (ilin(13) .ge. 0) then
           if (myproc .eq. 1) write(lout,1350) count
         endif
	 break = .true.
	 goto 101
        endif
      endif
      break = .false.
      
      tau    = tau-nue*nue/mue
      omega2 = (omega2-nue*omega1/mue)/tau
      omega1 = (omega1-nue*omega2)/mue

      include "norec.h"
      do 2008 z=0,lmyblk-1
        dw(ibx+z) = dw(ibx+z)+omega1*dw(ibPr+z)+omega2*dw(ibPs+z)
     #              +alfa*dw(ibPu+z)
	dw(ibr+z) = -dw(ibr+z)+omega1*dw(ibs+z)+omega2*dw(ibt+z)
        dw(ibu+z) = dw(ibu+z)-omega1*dw(ibv+z)-omega2*dw(ibw+z)
 2008 continue

C**                                                                 ***
C***  SMOOTHING OF THE SOLUTION X AND THE RESIDUUM R                ***
C**                                                                 ***
      if (lsmo) then
        call LL8SMO(dw,ibrs,ibr,ibxs,ibx,ibcom,ldw,l,lmyblk,
     #              myproc,nproc,tids,nmsg)
      endif
C**                                                                 ***
C***  CHECK STOPPING CRITERION                                      ***
C**                                                                 ***
      call LL3AXB(dw(ibrs),dw(ibr),dw(ibxs),dw(ibx),
     &            b,prec,dw(ibcom),l,lprec,lmyblk,epslin,
     &            ptrmbk,lmatbk,ptrinf,jump,mat,lmat,index,
     &            lindex,info,ia1,lsym,ladd,
     &            method,.false.,myproc,nproc,tids,nmsg,ilin,ierr,
     &            count,imvm,branch)
      goto (910,920,930) branch

      if (mod(count,niter) .eq. 0 .and. (ilin(1) .eq. 200 .or.
     &    ilin(1) .eq. 202 .or. ilin(1) .eq. 203 .or.
     &    ilin(1) .eq. 204)) then
        if (rseucn/r0iter .ge. stopit) then
          iconv = 5
          goto 900
        endif
        r0iter = rseucn
      endif

      if (mod(count,niter2) .eq. 0 .and. ilin(1) .eq. 201) then
        rshelp = rseucn/r0iter
        if (rshelp .ge. stopit2 .and. rshelp .gt. rpoly(1)**5) then
          iconv = 6
          rpoly(2) = rshelp
          goto 900
        endif
        if (rshelp .ge. stopit2 .and. rshelp .gt. rpoly(3)) then
c         if (rpoly(3) .eq. zero) then
            rpoly(2) = rshelp
c         else
c           rpoly(2) = one
c         endif
          iconv = 5
          goto 900
        endif
        r0iter = rseucn
      endif

      goto 111
C
C***  END OF THE ITERATION-LOOP
C
  910 iconv = 1
      if (ilin(13) .le. -2) write(lout,1410) imvm
      if (ilin(13) .ge. 2) then
	 if (myproc .eq. 1) write(lout,1410) imvm
      endif
      goto 900
  920 iconv = 2
      if (ilin(13) .le. -2) write(lout,1420) imvm
      if (ilin(13) .ge. 2) then
	 if (myproc .eq. 1) write(lout,1420) imvm
      endif
      goto 900
  930 if (rseucn > eps) then
	iconv = 3
        if (ilin(13) .lt. 0) write(lout,1430) imvm
        if (ilin(13) .gt. 0) then
	  if (myproc .eq. 1) write(lout,1430) imvm
        endif
      else
	iconv = 4
        if (ilin(13) .lt. 0) write(lout,1440) imvm
        if (ilin(13) .gt. 0) then
	  if (myproc .eq. 1) write(lout,1440) imvm
        endif
      endif
      goto 900
  940 iconv = 99
  900 ilin(10) = imvm
      ilin(11) = count
      ilin(3)  = nmsg
      if (lsmo) then
      include "norec.h"
        do 901 i = 1,lmyblk
	  x(i) = dw(ibxs+i-1)
  901   continue
      else
      include "norec.h"
        do 902 i = 1,lmyblk
	  x(i) = dw(ibx+i-1)
  902   continue
      endif
C
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
 1020 format(' *******************************************'/
     &       ' ***  Error occured in LSOLPP:           ***')
 1250 format(' ***  Scalar prod. is continuously zero  ***'/
     &       ' ***  BiCGSTAB2-method not applicable!   ***')
 1030 format(' *******************************************')
 1350 format('    Step:',i7,'  Restart: scalar product is zero')
 1410 format('    Convergence after ',i8,
     &       ' matrix-vector multiplications')
 1420 format('    Iteration reached maximum number of',
     &       ' matrix-vector multiplications: ',i7)
 1430 format('    Divergence after ',i9,
     &       ' matrix-vector multiplications.'/
     &       '    Last solution used!')
 1440 format('    Solution stagnates after ',i9,
     &       ' matrix-vector multiplications.'/
     &       '    Last solution used!')
C**                                                                 ***
C**---END OF LL1CGB2------------------------------------------------***
C**                                                                 ***
      e    n    d
