C:::::      ,,,,,LL1PAP20.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL1PAP20(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,
     #                    nproc,mat,prec,x,b,
     #                    iprec,index,ia1,info,dw,iw,
     #                    ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #                    eps,epslin,iconv,ierr)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 1 P A P 2 0  Parabolic method based on PRES20-method   ***
C**                       for the solution of the linear system     ***
C**                       (MAT+(1/tau)*I)*x = (1/tau)*x + b.        ***
C**                                                                 ***
C**      (ldw must be 24*l)                                         ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 2000 University Karlsruhe                      ***
C**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           ldw,liw,lmat,lprec,liprec,lindex,l,ia1,nproc,
     #                  index(lindex),info(ia1,ia2),lmatbk(nproc),
     #                  iprec(liprec),iw(liw),
     #                  ptrmbk(nproc+1),ptrinf(ntyp+1,nproc),nmsg,
     #                  jump(nproc),tids(nproc),ilin(nilin),iconv,ierr
      double precision  mat(lmat),prec(lprec),x(l),b(l),
     #                  dw(ldw),eps,epslin
      logical           lsym

C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :    (see man-page <lsolpp>)        ***
C**   -------------------------                                     ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           restart,nores
      double precision  raf,ref,tf
      parameter  (restart = 20, nores = 5)
      parameter  (ref = 0.1, raf = 2., tf = 2.)

      double precision  spc(nores+1),alfa(nores),alf,phi,rrm(nores-1)
      double precision  rbrk(0:nores),r0iter,rseucn,stopit,stopit2,
     *                  rpoly,r2new,r2old,tau,taurev,beta
      integer           coun20,idoku,niter,niter2
      logical           lcrash,lfel,lc20mod,lctau

      external LL6AX
      logical  ladd,lsmo
      integer  adda,i,imvm,count,lout,myproc,lmyblk,z,ione,branch
      integer  nvt
      character*10  method
      integer ibr,ibrm(nores-1),ibrs,ibAr,ibx,ibxm(nores-1),
     *        ibxs,ibxp1,ibrp1,rsave,xsave,ibcom,
     *        ptrl(nores+1),ptrr(nores+1),swap,minres,lglobal
      double precision zero,one,help(nores+1),rshelp

      common /norms/ rseucn,rpoly(3)
C**                                                                 ***
C**        CONSTANTS :                                              ***
C**        ---------                                                ***
C**                                                                 ***
      parameter  (zero = 0.0, one = 1.0, ione = 1)
      parameter  (stopit = 0.5, stopit2 = 0.25)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   --------------------                                          ***
C**                                                                 ***
      method = '    PaP20 '

      ilin(13) = 2

      ladd = .false.
C**                                                                 ***
      imvm  = ilin(10)
      iconv = 0
C**                                                                 ***
      nvt    = ilin(5)
      lout   = ilin(12)
      myproc = ilin(17)
      lsmo   = ilin(18) .ne. 0
      lmyblk = lmatbk(myproc)
      lglobal= ilin(36)

C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** SET POINTERS :                                                ***
C**   ------------                                                  ***
C**                                                                 ***
      ibr=0*l+1
      do 100 i=1,nores-1
	ibrm(i) = i*l+1
  100 continue
      ibrs=5*l+1
      ibrp1=6*l+1
      ibAr=7*l+1
      ibx=8*l+1
      do 105 i=1,nores-1
	ibxm(i) = (nores+3+i)*l+1
  105 continue
      ibxs=13*l+1
      ibxp1 =14*l+1
      rsave =15*l+1
      xsave =16*l+1
      ibcom =17*l+1

C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   INITIAL VALUES                                                ***
C**                                                                 ***
      include "norec.h"
      do 110 i = 1,l
        x(i)  = zero
        dw(i+ibr-1) = - b(i) 
  110 continue

      include "norec.h"
      do 122 i=0,l-1
        dw(ibrs+i) = dw(ibr+i)
        dw(ibx+i) = x(i+1)
        dw(ibxs+i) = x(i+1)
        dw(rsave+i) = dw(ibr+i)
        dw(xsave+i) = x(i+1)
  122 continue

      count = 0

C**                                                                 ***
C***  COMPUTE ||r0||2                                               ***
C**                                                                 ***
      call LL3AXB(dw(ibrs),dw(ibr),dw(ibxs),dw(ibx),
     &            b,prec,dw(ibcom),l,lprec,lmyblk,epslin,
     &            ptrmbk,lmatbk,ptrinf,jump,mat,lmat,index,
     &            lindex,info,ia1,lsym,ladd,
     &            method,.true.,myproc,nproc,tids,nmsg,ilin,ierr,
     &            count,imvm,branch)
      goto (410,420,430) branch

C**                                                                 ***
C***  INITIAL VALUES                                                ***
C**                                                                 ***
      niter    = max(20,int(l*nproc/10000)*20)
      niter2   = max(100,int(l*nproc/2000)*20)
      r0iter   = rseucn
      coun20   = 0

      do 131 i = 1,nores+1
	spc(i) = zero
  131 continue
      do 142 i = 1,nores
	rbrk(i) = one
  142 continue

      do i=1,nvt
	if (info(i,1) == 1) then 
	  adda = info(i,2)
	  exit
	endif
      enddo

      tau  = 2.D0
      beta = zero

      taurev = one/tau
      do i=1,lmyblk
	mat(adda+i) = mat(adda+i) + taurev
      enddo

      if (ilin(17) .eq. 1) then
        write(lout,1301) raf, ref, tf, beta, tau
      endif

      r2old = rseucn

C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C***  START OF THE ITERATION-LOOP                                   ***
C**                                                                 ***

  111 continue
      count = count+1
      coun20 = coun20+1

C**                                                                 ***
C***  COMPUTATION OF A*r                                            ***
C**                                                                 ***
      call LL3AX(LL6AX,mat,dw(ibr),dw(ibAr),dw(ibcom),ptrmbk,lmatbk,
     #           ptrinf,l,nproc,tids,myproc,jump,ladd,
     #           lmat,lindex,ia1,info,index,nmsg)
      imvm=imvm+1

C**                                                                 ***
C***  COMPUTATION OF R_K_TRANS * R_K_STAR   AND                     ***
C***                 R_K_TRANS * A*R_K      AND                     ***
C***                 R_K-i_TRANS * A*R_K   (i=1,2,3,4)              ***
C**                                                                 ***

      minres = min(coun20,nores)

      ptrl(1)=ibr
      ptrr(1)=ibr
      ptrl(2)=ibr
      ptrr(2)=ibAr
      do 200 i=2,minres
        ptrl(i+1)=ibrm(i-1)
        ptrr(i+1)=ibAr
  200 continue
      call LL4SCP(lmyblk,minres+1,l,minres+1,dw,ptrl,dw,ptrr,spc,
     #            help,.true.,myproc,nproc,tids,nmsg)
      alfa(1) = -spc(2)/spc(1)
      do 210 i=2,minres
        alfa(i) = -spc(i+1)/rrm(i-1)
  210 continue

      alf = rbrk(1)*alfa(1)
      do 220 i=2,minres
        alf = alf + rbrk(i)*alfa(i)
  220 continue

      if (alf .eq. zero) then
        phi = one
        rbrk(0) = zero
      else
        phi = one/alf
        rbrk(0) = one
      endif

      include "norec.h"
      do 225 z=0,lmyblk-1
        dw(ibxp1+z) = dw(ibr+z) + alfa(1)*dw(ibx+z)
        dw(ibrp1+z) = dw(ibAr+z) + alfa(1)*dw(ibr+z)
 225  continue
      do 230 i=2,minres 
      include "norec.h"
        do 2005 z=0,lmyblk-1
          dw(ibxp1+z) = dw(ibxp1+z) + alfa(i)*dw(ibxm(i-1)+z)
          dw(ibrp1+z) = dw(ibrp1+z) + alfa(i)*dw(ibrm(i-1)+z)
 2005   continue
 230  continue
      include "norec.h"
      do 235 z=0,lmyblk-1
        dw(ibxp1+z) = phi*dw(ibxp1+z)
        dw(ibrp1+z) = phi*dw(ibrp1+z)
 235  continue

      do 501 i=1,nores
	rbrk(i) = rbrk(i-1)
  501 continue

      if (rbrk(1) .eq. zero) then
        if (ilin(13) .le. -2) write(lout,1300)
        if (ilin(13) .ge. 2) then
          if (myproc .eq. 1) write(lout,1300)
        endif
      endif

      lcrash = .true.
      do 502 i=1,nores
	if (rbrk(i) .eq. one) lcrash = .false.
  502 continue

      if (lcrash) then
         ierr = 1211
	 if (ilin(13) .lt. 0) then 
	   write(lout,1020)
	   write(lout,1021)
	   write(lout,1030)
         endif
	 if (ilin(13) .ge. 0) then
	   if (myproc .eq. 1) then
	     write(lout,1020)
	     write(lout,1021)
	     write(lout,1030)
	   endif
         endif
         goto 440
      endif

      do 503 i=min(minres,nores-1),2,-1
        rrm(i) = rrm(i-1)
  503 continue
      rrm(1) = spc(1)

      swap  = ibxm(nores-1)
      do 504 i=nores-1,2,-1
        ibxm(i) = ibxm(i-1)
  504 continue
      ibxm(1) = ibx
      ibx     = ibxp1
      ibxp1   = swap

      swap  = ibrm(nores-1)
      do 505 i=nores-1,2,-1
        ibrm(i) = ibrm(i-1)
  505 continue
      ibrm(1) = ibr
      ibr     = ibrp1
      ibrp1   = swap

      lc20mod = (MOD(coun20,restart) .eq. 0)
      if ((rbrk(1) .eq. zero) .and. .not. lc20mod) goto 111

C**                                                                 ***
C***  SMOOTHING OF THE SOLUTION X AND THE RESIDUUM R                ***
C**                                                                 ***
      if (lc20mod) then
        if (lsmo) then
          call LL8SMO(dw,rsave,ibr,xsave,ibx,ibcom,ldw,l,lmyblk,
     &                myproc,nproc,tids,nmsg)
          call LL4SCP(lmyblk,1,l,1,dw,rsave,dw,rsave,r2new,help,
     #                .true.,myproc,nproc,tids,nmsg)
        else
          call LL4SCP(lmyblk,1,l,1,dw,ibr,dw,ibr,r2new,help,
     #                .true.,myproc,nproc,tids,nmsg)
        endif
        r2new = SQRT(r2new)
        if (ilin(17) .eq. 1) then
          write(lout,1302) r2new
        endif
      else
	goto 111
      endif

     
      if (lc20mod) then

        do i=1,lmyblk
	  mat(adda+i) = mat(adda+i) - taurev
        enddo
        idoku = ilin(9)
	ilin(9) = 2
        call LL3AXB(dw(rsave),dw(ibr),dw(xsave),dw(ibx),
     &              b,prec,dw(ibcom),l,lprec,lmyblk,epslin,
     &              ptrmbk,lmatbk,ptrinf,jump,mat,lmat,index,
     &              lindex,info,ia1,lsym,ladd,
     &              method,.false.,myproc,nproc,tids,nmsg,ilin,ierr,
     &              count,imvm,branch)
	ilin(9) = idoku
        goto (410,420,430) branch

        beta  = r2new/r2old
	if (beta < ref/raf) then
	  tau = tf*tau
	else if (beta > raf*ref) then
	  tau = tau/tf
	endif
	
	if (beta <= raf*ref) then
	   do i = 0,l-1
	     dw(ibrs+i) = dw(rsave+i)
	     dw(ibxs+i) = dw(xsave+i)
	   enddo
	endif
	
        if (ilin(17) .eq. 1) then
          write(lout,1301) raf, ref, tf, beta, tau
        endif

        taurev = one/tau
        do i=1,lmyblk
	  mat(adda+i) = mat(adda+i) + taurev
        enddo

	r2old = rseucn

	if (lsmo) then
        include "norec.h"
          do 2006 z=0,lmyblk-1
            dw(ibx+z) = dw(ibxs+z)
	    dw(ibr+z) = dw(ibrs+z)
 2006     continue
        endif
	coun20 = 0
        do 512 i = 1,nores
	  rbrk(i) = one
  512   continue
      endif

      goto 111
C
C***  END OF THE ITERATION-LOOP
C
  410 iconv = 1
      if (ilin(13) .le. -2) write(lout,1410) imvm
      if (ilin(13) .ge. 2) then
	 if (myproc .eq. 1) write(lout,1410) imvm
      endif
      goto 500
  420 iconv = 2
      if (ilin(13) .le. -2) write(lout,1420) imvm
      if (ilin(13) .ge. 2) then
	 if (myproc .eq. 1) write(lout,1420) imvm
      endif
      goto 500
  430 iconv = 3
      if (ilin(13) .lt. 0) write(lout,1430) imvm
      if (ilin(13) .gt. 0) then
	 if (myproc .eq. 1) write(lout,1430) imvm
      endif
      goto 500
  440 iconv = 4
  500 ilin(10) = imvm
      ilin(11) = count
      ilin(3)  = nmsg
      if (lsmo) then
      include "norec.h"
        do 600 i = 1,lmyblk
	  x(i) = dw(ibxs+i-1)
  600   continue
      else
      include "norec.h"
        do 610 i = 1,lmyblk
	  x(i) = dw(ibx+i-1)
  610   continue
      endif
C
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
 1020 format(' *****************************************************'/
     &       ' ***  Error occured in LSOLPP:                     ***')
 1021 format(' ***  All alfa-coefficients are zero!              ***'/
     &       ' ***  PRES20  method not applicable                ***')
 1026 format(' ***   results from Backward Substitution or       ***'/
     &       ' ***   Forward Elimination are too large or not    ***'/
     &       ' ***   an arithmetic number!                       ***')
 1030 format(' *****************************************************')
 1300 format('    Step:',i7,'  Phi=0 !  Corrective action by'/    
     &       '                 setting phi=1 and alfa(1,k)=0')
 1301 format('    raf:',f6.2,'  ref:',f10.6,'  tf:',f6.2,'  beta:',
     &       f10.6,'  tau:',f10.6//)
 1302 format('    ||r(shifted)||2:',g12.4)
 1410 format('    Convergence after',i8,
     &       ' matrix-vector multiplications')
 1420 format('    Iteration reached maximum number of',
     &       ' matrix-vector multiplications:',i7)
 1430 format('    Divergence after',i9,
     &       ' matrix-vector multiplications')
C**                                                                 ***
C**---END OF LL1PAP20-----------------------------------------------***
C**                                                                 ***
      e    n    d
