C:::::      ,,,,,LL4ISM8.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL4ISM8(nc,nv,l,iv,isum,iw,myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 4 I S M 8   computes nv scalar sums out of the array   ***
C**                      of 8 BYTE integer vectors stored in array  ***
C**                      iv - all with length nc (nc<l).            ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 2002 University Karlsruhe                      ***
!**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer            nc,nv,l,myproc,nproc,nmsg 
      integer            tids(nproc)
C**                                                                 ***
      integer*8          iv(l,nv),isum(nv),iw(nv)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C nc     I  I   I in  I  number of components of iv
C--------I------I-----I------------------------------------------------
C nv     I  I   I in  I  number of vectors in iv
C--------I------I-----I------------------------------------------------
C l      I  I   I in  I  leading dimension of iv
C--------I------I-----I------------------------------------------------
C iv     I  I   I in  I  vector set                  array : > iv(l,nv)
C--------I------I-----I------------------------------------------------
C isum   I  I   I out I  vector with scalar sums      array : isum(nv)
C--------I------I-----I------------------------------------------------
C iw     I  I   I  -  I  integer work array           array : iw(nv)
C--------I------I-----I------------------------------------------------
C myproc I  I   I in  I  process(or) id
C--------I------I-----I------------------------------------------------
C tids   I  I   I in  I  set of tids               array : tids(nproc)
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i,il,lstr
      external          LL9ISM8
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      do 10 i=1,nv
        isum(i) = iv(1,i)
          do 10 il=2,nc
            isum(i)=isum(i)+iv(il,i)
   10 continue
C**                                                                 ***
C**   REDUCTION AND BROADCASTING OF SCALAR PRODUCT                  ***
C**                                                                 ***
      if (nproc .ne. 1) then
        lstr = nv*ireal
        call REDUCE(LL9ISM8,iw,isum,lstr,myproc,nproc,tids,nmsg)
      endif
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LL4ISM---------------------------------------------------
      e    n    d
