C:::::      ,,,,,LL4SUM.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL4SUM(l,nc,nv,v,ptrv,vsum,rw,myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 4 S U M   computes nv scalar sums out of the array of  ***
C**                    vectors stored in array v - all with length  ***
C**                    nc (nc<l) - accessed by pointers stored in   ***
C**                    ptrv.                                        ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer            nc,nv,l,myproc,nproc,nmsg 
      integer            ptrv(nv),tids(nproc)
C**                                                                 ***
      double precision   v(*),vsum(nv),rw(nv)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C nc     I  I   I in  I  number of components of v
C--------I------I-----I------------------------------------------------
C nv     I  I   I in  I  number of vectors in v
C--------I------I-----I------------------------------------------------
C l      I  I   I in  I  leading dimension of v
C--------I------I-----I------------------------------------------------
C v      I  R   I in  I  vector set                   array : > v(l*nv)
C--------I------I-----I------------------------------------------------
C ptrv   I  I   I in  I  pointers on a vector field >= vector set v   
C        I      I     I  pointers should be a multiple of l + offset 1
C        I      I     I                               array : ptrv(nv)
C--------I------I-----I------------------------------------------------
C vsum   I  R   I out I  vector with scalar sums      array : vsum(nv)
C--------I------I-----I------------------------------------------------
C rw     I  R   I  -  I  real work array              array : rw(nv)
C--------I------I-----I------------------------------------------------
C myproc I  I   I in  I  process(or) id
C--------I------I-----I------------------------------------------------
C tids   I  I   I in  I  set of tids               array : tids(nproc)
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      double precision  zero
      parameter         (zero=0.0)
      integer           i,il,lstr
      external          LL9SUM
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      do 10 i=1,nv
        vsum(i) = zero
          do 10 il=0,nc-1
            vsum(i)=vsum(i)+v(ptrv(i)+il)
   10 continue
C**                                                                 ***
C**   REDUCTION AND BROADCASTING OF SCALAR PRODUCT                  ***
C**                                                                 ***
      if (nproc .ne. 1) then
        lstr = nv*ireal
        call REDUCE(LL9SUM,rw,vsum,lstr,myproc,nproc,tids,nmsg)
      endif
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LL4SUM---------------------------------------------------
      e    n    d
