C:::::      ,,,,,LL5DIA.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL5DIA(lmat,lindex,ldw,l,lmain,main,ia1,mat,dw,info,
     #                  ilin,index,ptrinf,tids,nproc,myproc,nmsg,
     #                  lmyblk,ptsmyb)
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 5 D I A   stores the coefficients of the main diagonal ***
C**                    of the matrix MAT into a buffer of length l. ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1996 University Karlsruhe                      ***
C**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                    ***
C**   THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.               ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer           lmat,lindex,ldw,l,main,ia1,nproc,
     *                  myproc,lmyblk,ptsmyb,lmain,nmsg
      double precision  dw(ldw),mat(lmat)
      integer           info(ia1,ia2),ilin(nilin),ptrinf(ntyp+1,nproc)
      integer           index(lindex),tids(nproc)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**                                                                 ***
C**   see Manual Pages <lsolpp>                                     ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           i,jc,jr,k,adda,counvt,counel,lvt,indc,indr
      integer           couold,iac,iac1,iar,iar1,imax,lout,maxout
      integer           iinp(2),isum(2),ihlp(2)
      real              percnt
      double precision  zero
C**                                                                 ***
C**        CONSTANTS:                                               ***
C**        ---------                                                ***
C**                                                                 ***
      parameter (zero = 0., maxout = 50)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** START OF CALCULATION :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      lout = ilin(12)

      if ((ilin(13) .lt. 0) .and. (ilin(13) .ge. -maxout)) then
         write(lout,1000)
         write(lout,1001)
      endif
      if ((ilin(13) .gt. 0) .and. (ilin(13) .le. maxout)) then
        if (myproc .eq. 1) then
	  write(lout,1000)
	  write(lout,1001)
        endif
      endif

      do 10 i=1,l
        dw(main+i-1) = zero
   10 continue
C**                                                                 ***
      counvt = 0
      counel = 0
      do 20 k=ptrinf(2,myproc)+1,ptrinf(3,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac1 = info(k,4)-ptsmyb
	iar1 = info(k,5)-ptsmyb
	if (iac1 .ne. iar1) goto 20
	counvt = counvt + 1
        do 25 i=1,lvt
          dw(main+iar1+i-1) = dw(main+iar1+i-1) + mat(i+adda)
	  counel = counel + 1
   25   continue
   20 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(3,myproc) .gt. ptrinf(2,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1002) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1002) isum(1),isum(2)
        endif
      endif

C**
      counvt = 0
      counel = 0
      do 30 k=ptrinf(3,myproc)+1,ptrinf(4,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac1 = info(k,4)-ptsmyb
	iar1 = info(k,5)-ptsmyb
	if (iac1 .ne. iar1) goto 30
	counvt = counvt + 1
	indc = info(k,6)
        do 35 i=1,lvt
	  jc = index(i+indc)
          dw(main+iar1+jc-1) = dw(main+iar1+jc-1) + mat(i+adda)
	  counel = counel + 1
   35   continue
   30 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(4,myproc) .gt. ptrinf(3,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1003) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1003) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 40 k=ptrinf(4,myproc)+1,ptrinf(5,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iar  = info(k,5)
	iar1 = info(k,5)-ptsmyb
	indc = info(k,6)
        couold = counel
        do 45 i=1,lvt
	  jc = index(i+indc)
	  if (iar+i .eq. jc) then
            dw(main+iar1+i-1) = dw(main+iar1+i-1) + mat(i+adda)
	    counel = counel + 1
          endif
   45   continue
	if (counel .gt. couold) counvt = counvt + 1
   40 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(5,myproc) .gt. ptrinf(4,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1004)  isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1004) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 50 k=ptrinf(5,myproc)+1,ptrinf(6,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac  = info(k,4)
	iac1 = info(k,4)-ptsmyb
	indr = info(k,7)
        couold = counel
        do 55 i=1,lvt
	  jr = index(i+indr)
	  if (iac+i .eq. jr) then
            dw(main+iac1+i-1) = dw(main+iac1+i-1) + mat(i+adda)
	    counel = counel + 1
          endif
   55   continue
	if (counel .gt. couold) counvt = counvt + 1
   50 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(6,myproc) .gt. ptrinf(5,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1005) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1005) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 60 k=ptrinf(6,myproc)+1,ptrinf(7,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	indc = info(k,6)
	indr = info(k,7)
        couold = counel
        do 65 i=1,lvt
	  jc = index(i+indc)
	  jr = index(i+indr)
	  if (jc .eq. jr) then
            dw(main+jr-ptsmyb-1) = dw(main+jr-ptsmyb-1) + mat(i+adda)
	    counel = counel + 1
          endif
   65   continue
	if (counel .gt. couold) counvt = counvt + 1
   60 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(7,myproc) .gt. ptrinf(6,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1006) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1006) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 70 k=ptrinf(7,myproc)+1,ptrinf(8,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac1 = info(k,4)-ptsmyb
	iar1 = info(k,5)-ptsmyb
	if ((iac1 .gt. iar1) .or. (iac1+lvt .lt. iar1+1)) goto 70
        couold = counel
        do 75 i=1,lvt
	  if (iac1+i .eq. iar1+1) then
            dw(main+iar1) = dw(main+iar1) + mat(i+adda)
	    counel = counel + 1
          endif
   75   continue
	if (counel .gt. couold) counvt = counvt + 1
   70 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(8,myproc) .gt. ptrinf(7,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1007) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1007) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 80 k=ptrinf(8,myproc)+1,ptrinf(9,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac1 = info(k,4)-ptsmyb
	iar1 = info(k,5)-ptsmyb
	if ((iar1 .gt. iac1) .or. (iar1+lvt .lt. iac1+1)) goto 80
        couold = counel
        do 85 i=1,lvt
	  if (iar1+i .eq. iac1+1) then
            dw(main+iac1) = dw(main+iac1) + mat(i+adda)
	    counel = counel + 1
          endif
   85   continue
	if (counel .gt. couold) counvt = counvt + 1
   80 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(9,myproc) .gt. ptrinf(8,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1008) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1008) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 90 k=ptrinf(9,myproc)+1,ptrinf(11,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iar  = info(k,5)
	iar1 = info(k,5)-ptsmyb
	indc = info(k,6)
        couold = counel
        do 95 i=1,lvt
	  jc = index(i+indc)
	  if (iar+1 .eq. jc) then
            dw(main+iar1) = dw(main+iar1) + mat(i+adda)
	    counel = counel + 1
          endif
   95   continue
	if (counel .gt. couold) counvt = counvt + 1
   90 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(11,myproc) .gt. ptrinf(9,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1009) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1009) isum(1),isum(2)
        endif
      endif
C**
      counvt = 0
      counel = 0
      do 110 k=ptrinf(11,myproc)+1,ptrinf(12,myproc)
	adda = info(k,2)
	lvt  = info(k,3)
	iac  = info(k,4)
	iac1 = info(k,4)-ptsmyb
	indr = info(k,7)
        couold = counel
        do 115 i=1,lvt
	  jr = index(i+indr)
	  if (iac+1 .eq. jr) then
            dw(main+iac1) = dw(main+iac1) + mat(i+adda)
	    counel = counel + 1
          endif
  115   continue
	if (counel .gt. couold) counvt = counvt + 1
  110 continue
      iinp(1) = counvt
      iinp(2) = counel
      call LL4ISM(1,2,1,iinp,isum,ihlp,myproc,nproc,tids,nmsg)
      if (ptrinf(12,myproc) .gt. ptrinf(11,myproc)) then
        if ((ilin(13) .lt. 0) .and. (ilin(13) .gt. -3))
     &    write(lout,1011) isum(1),isum(2)
        if ((ilin(13) .gt. 0) .and. (ilin(13) .lt. 3)) then
          if (myproc .eq. 1) write(lout,1011) isum(1),isum(2)
        endif
      endif

      counel = 0
      lmain = 0
      do 120 i=1,lmyblk
        if (dw(main+i-1) .ne. zero) then
	  counel = counel + 1
	  lmain = 1
        endif
  120 continue
      call LL4ISM(1,1,1,counel,isum,ihlp,myproc,nproc,tids,nmsg)
      call LL4INM(1,1,1,lmain,imax,ihlp,myproc,nproc,tids,nmsg)
      lmain  = imax

      percnt = float(isum(1))/float(ilin(36))
      percnt = percnt*100
      if ((ilin(13) .lt. 0) .and. (ilin(13) .ge. -maxout)) then
        write(lout,1020) percnt
        write(lout,1021)
      endif
      if ((ilin(13) .gt. 0) .and. (ilin(13) .le. maxout)) then
        if (myproc .eq. 1) then
	  write(lout,1020) percnt
	  write(lout,1021)
        endif
      endif


 1000 format(/'   -------------------------------------------------- ')
 1001 format('  ||  NO explicit main diagonal (MD) for            ||',/
     &       '  ||  normalization !!!                             ||')
 1002 format('  ||  Storage pattern 2 <-> Full Diagonal:          ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1003 format('  ||  Storage pattern 3 <-> Packed Diagonal:        ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1004 format('  ||  Storage pattern 4 <-> Indexed Column:         ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1005 format('  ||  Storage pattern 5 <-> Indexed Row:            ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1006 format('  ||  Storage pattern 6 <-> Starry Sky:             ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1007 format('  ||  Storage pattern 7 <-> Full Row:               ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1008 format('  ||  Storage pattern 8 <-> Full Columns:           ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1009 format('  ||  Storage pattern 9 <-> Packed Row:             ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1011 format('  ||  Storage pattern 11 <-> Packed Columns:        ||',/
     &       '  ||   vector terms with MD-elements ..... : ',i6,' ||',/
     &       '  ||   elements mounted on MD-buffer . . . : ',i6,' ||')
 1020 format('  ||  Collective (over all storage patterns) :      ||',/
     &       '  ||   percentage of occupancy of the MD            ||',/
     &       '  ||   with non-zero elements ............ : ',f6.1,' ||')
 1021 format('   -------------------------------------------------- '/)

C**                                                                 ***
C**** END OF CALCULATION                                            ***
C**   ------------------                                            ***
C**                                                                 ***
      r e t u r n
C-----END OF LL5DIA----------------------------------------------------
      e    n    d
