C:::::      ,,,,,LL8CK1.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8CK1(lmat,lindex,l,nproc,nvt,info,ia1,ilin,ierr,
     &                  tids)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     L L 8 C K 1 :  CHECKS LSOLPP PARAMETERS CONCERNING THE      ***
c**                    MATRIX, THE OUTPUT AND NUMBER OF PROCESSORS  ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1995 University Karlsruhe                      ***
C**    Programmer: H. Haefner, F. Seegmueller                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer nproc,ia1,ierr,lmat,lindex,l
      integer info(ia1,ia2),ilin(nilin),tids(nproc)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <lsolpp>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    ione,i,lout,myproc,nmsg,nvt,iermax,ihelp,maxi,maxind
      integer    maxadd,idoku
      parameter (ione=1)
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      nmsg   = ilin(3)
      lout   = ilin(12)
      idoku  = ilin(13)
      myproc = ilin(17)
      ierr   = 0000
      iermax = 0000
C**                                                                 ***
C***  START OF PARAMETER CHECK                                      ***
C**                                                                 ***
      if (lout .lt. 0) then 
        ierr  = 8001
	if (myproc .eq. 1) then
	  write(*,1010)
	  write(*,1016)
	  write(*,1020)
        endif
        goto 999
      endif
c**
      if (nproc .lt. 1) then 
        ierr  = 8002
	write(lout,1010)
	write(lout,1017)
	write(lout,1020)
        goto 999
      endif
c**
      if (nproc .gt. maxnpe) then 
        ierr  = 8003
	if (myproc .eq. 1) then
	  write(lout,1010)
	  write(lout,1018) maxnpe
	  write(lout,1020)
        endif
        goto 999
      endif
c**
      if (ia1 .lt. nvt) then
        ierr  = 8004
	write(lout,1010)
	write(lout,1014) myproc
	write(lout,1020)
        goto 999
      endif
c**
c***********************************************************************
c**    Size of matrix, index array and info array on one processor   ***
c***********************************************************************

      if (nproc .eq. 1) then
c** Size of matrix on processor 1
        maxadd = 0
        do i = 1,nvt
          if (info(i,2) > maxadd) then
            maxadd = info(i,2)
            maxi   = i
          endif
        enddo
        ilin(33) = info(maxi,2) + info(maxi,3)
	ilin(30) = ilin(33)
c** Size of index array  on processor 1
       maxind = -1
       do 100 i = 1,nvt
        if (info(i,1) .eq. 3 .or. info(i,1) .eq. 4 .or.
     &      info(i,1) .eq. 9 .or.
     &      info(i,1) .eq. 30 .or. info(i,1) .eq. 40 .or.
     &      info(i,1) .eq. 90) then
          if (info(i,6) .gt. maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
        endif
        if (info(i,1) .eq. 5 .or. info(i,1) .eq. 11 .or.
     &      info(i,1) .eq. 50 .or. info(i,1) .eq. 110) then
          if (info(i,7) .gt. maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
        endif
        if (info(i,1) .eq. 6 .or. info(i,1) .eq. 60) then
          if (info(i,6) .gt. maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
          if (info(i,7) .gt. maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
        endif
  100  continue
       if (maxind .gt. -1) then
         ilin(34) = maxind + info(maxi,3)
       else
	 ilin(34) = 1
       endif
       ilin(31) = ilin(34)

c** Size of info array on processor 1
       ilin(35) = nvt
       ilin(32) = ilin(35)
c**
       if (lmat .lt. ilin(33)) then
         ierr  = 8005
	 write(lout,1010)
	 write(lout,1021)
	 write(lout,1020)
         goto 999
       endif
c**
       if (lindex .lt. ilin(34)) then
         ierr  = 8006
	 write(lout,1010)
	 write(lout,1022)
	 write(lout,1020)
         goto 999
       endif
      endif
c**
c***********************************************************************
c**    Size of matrix, index array and info array on many processors ***
c***********************************************************************

      if (nproc .gt. 1) then
c** Size of matrix on local processor
       maxadd = 0
       do i = 1,nvt
         if (info(i,2) > maxadd) then
           maxadd = info(i,2)
           maxi   = i
         endif
       enddo
       ilin(33) = info(maxi,2) + info(maxi,3)
c** Size of index array  on local processor
       maxind = -1
       do 110 i = 1,nvt
        if (info(i,1) .eq. 3 .or. info(i,1) .eq. 4 .or.
     &      info(i,1) .eq. 9 .or.
     &      info(i,1) .eq. 30 .or. info(i,1) .eq. 40 .or.
     &      info(i,1) .eq. 90) then
          if (info(i,6) .gt. maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
        endif
        if (info(i,1) .eq. 5 .or. info(i,1) .eq. 11 .or.
     &      info(i,1) .eq. 50 .or. info(i,1) .eq. 110) then
          if (info(i,7) .gt. maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
        endif
        if (info(i,1) .eq. 6 .or. info(i,1) .eq. 60) then
          if (info(i,6) .gt. maxind) then
            maxind = info(i,6)
            maxi   = i
          endif
          if (info(i,7) .gt. maxind) then
            maxind = info(i,7)
            maxi   = i
          endif
        endif
  110  continue
       if (maxind .gt. -1) then
         ilin(34) = maxind + info(maxi,3)
       else
	 ilin(34) = 1
       endif
c** Size of info array on processor 1
       ilin(35) = nvt
       ilin(38) = INT(REAL(l)/(REAL(nproc)*msgblkfac))
       if (ilin(38) < 1) ilin(38) = 1
       if (ilin(38) > l) ilin(38) = l
c**
       if (lmat .lt. ilin(33)) then
         ierr  = 8005
         if (idoku >= 0) then
           if (myproc == 1) then
	     write(lout,1010)
	     write(lout,1023)
	     write(lout,1020)
           endif
	 else
	   write(lout,1010)
	   write(lout,1023)
	   write(lout,1020)
	 endif
         goto 999
       endif
c**
       if (lindex .lt. ilin(34)) then
         ierr  = 8006
         if (idoku >= 0) then
           if (myproc == 1) then
	     write(lout,1010)
	     write(lout,1023)
	     write(lout,1020)
           endif
	 else
	   write(lout,1010)
	   write(lout,1023)
	   write(lout,1020)
	 endif
         goto 999
       endif
      endif


  999 call LL4INM(ione,ione,ione,ierr,iermax,ihelp,myproc,nproc,
     *            tids,nmsg)
      ierr = iermax
      ilin(3) = nmsg
c**
c*** FORMATS
c**
 1010 format(' **************************************************'/
     &       ' ***  LL8CK1: error detected;                   ***')
 1014 format(' ***   First dim. of array INFO on proc. ',i6,' ***'/
     &       ' ***   too small: ia1 is less than nvt.         ***')
 1016 format(' ***   Output unit number LOUT has to           ***'/
     &       ' ***   be non-negative.                         ***')
 1017 format(' ***   Number of processors NPROC has           ***'/
     &       ' ***   to be greater than zero.                 ***')
 1018 format(' ***   Number of processors NPROC has           ***'/
     &       ' ***   to be less or equal than ',i6,'          ***')
 1020 format(' **************************************************'/)
 1021 format(' ***   Array MAT too small:                     ***'/
     &       ' ***   lmat is less than size of matrix.        ***')
 1022 format(' ***   Array INDEX too small:                   ***'/
     &       ' ***   lindex is less than size of index array. ***')
 1023 format(' ***   Array MAT too small on processor  ',i6,' ***'/
     &       ' ***   lmat is less than size of matrix.        ***')
 1024 format(' ***   Array INDEX too small on proc.    ',i6,' ***'/
     &       ' ***   lindex is less than size of index array. ***')
c**
c*** 
c**
      r e t u r n
c-----END OF LL8CK1---------------------------------------------------      
      e n d
