C:::::      ,,,,,LL8CK2.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8CK2(l,ldw,liw,lsym,maxnvp,nvt,ilin,ierr,nproc,
     *                  tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     L L 8 C K 2 : CHECKS LSOLPP PARAMETERS CONCERNING THE       ***
C**                   CG - METHOD                                   ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1995 University Karlsruhe                      ***
C**    Programmer: H. Haefner, F. Seegmueller                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer l,ldw,liw,ierr,nproc,maxnvp,nmsg,nvt
      integer ilin(nilin),tids(nproc)
      logical lsym
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <lsolpp>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    lout,ms,isprec,noprec,misc,msprec,myproc
      integer    ione,iermax,ihelp,optim
      parameter (ione=1)
C**                                                                 ***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      ms     = ilin(1)
      isprec = ilin(6)
      noprec = ilin(9)
      lout   = ilin(12)
      msprec = ilin(15)
      myproc = ilin(17)
      misc   = ilin(19)
      optim  = ilin(20)
      ierr   = 0
      iermax = 0
c**
c***  START OF PARAMETER CHECK
c**
c**
c***  CHECK METHOD
c**
      if (((ms .le. 0) .or. (ms .gt. 7)) .and.
     #    (ms .ne. 15) .and. (ms .ne. 16) .and. (ms .ne. 100) .and.
     #    (ms .eq. 100 .and. .not. lsym) .and.
     #    (ms .eq. 101 .and. .not. lsym) .and.
     #    (ms .ne. 101) .and. (ms .ne. 200) .and. (ms .ne. 201) .and.
     #    (ms .ne. 202) .and. (ms .ne. 203) .and.
     #    (ms .ne. 204) .and. (ms .ne. 210) .and.
     #    (ms .ne. 211) .and. (ms .ne. 212) .and.
     #    (ms .ne. 9) .and.
     #    (ms .eq. 220 .and. .not. lsym) .and.
     #    (ms .eq. 221 .and. .not. lsym) .and.
     #    (ms .ne. 220) .and. (ms .ne. 221) .and. (ms .ne. 999)) then
	 ierr  = 8006
	 if (myproc .eq. 1) then
	    write(lout,1030)
	    write(lout,1035)
	    write(lout,1036) ms
	    write(lout,1037)
	    write(lout,1040)
         endif
	 if (lsym) then
           ilin(1) = 100
           ms      = ilin(1)
         else
           ilin(1) = 200
           ms      = ilin(1)
         endif
      endif
c**
c***  CHECK WORKSPACE LDW
c**
      if ((ms .eq. 14)) then
	if (ldw .lt. 15*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1015)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if ((ms .eq. 1) .or. (ms .eq. 200) .or. (ms .eq. 201) .or.
     *    (ms .eq. 11) .or.
     *    (ms .eq. 100 .and. .not. lsym)) then
	if (ldw .lt. 22*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1022)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if ((ms .eq. 2) .or. (ms .eq. 3) .or.(ms .eq. 4) .or. (ms .eq. 6)
     *    .or. (ms .eq. 101) .or. (ms .eq. 220) .or. (ms .eq. 221)) then
	if (ldw .lt. 18*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1018)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if (ms .eq. 7) then
	if (ldw .lt. 22*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1020)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if (ms .eq. 5) then
	if (ldw .lt. 19*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1019)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if ((ms .eq. 15) .or. (ms .eq. 202) .or. (ms .eq. 203) .or.
     *    (ms .eq. 210) .or. (ms .eq. 211) .or.
     *    (ms .eq. 101 .and. .not. lsym) .or. (ms .eq. 220 .and.
     *    .not. lsym) .or. (ms .eq. 221 .and. .not. lsym)) then
	if (ldw .lt. 24*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1024)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if ((ms .eq. 16) .or. (ms .eq. 204) .or. (ms .eq. 212)) then
	if (ldw .lt. 54*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1054)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if ((ms .eq. 9) .or. (ms .eq. 100 .and. lsym)) then
	if (ldw .lt. 17*l) then
	  ierr  = 8007
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1017)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
c**
c***  CHECK WORKSPACE LIW
c**
      if ((optim .ne. 100) .and. (optim .ne. 200)) then
	if (liw .lt. 2*nproc) then
	  ierr  = 8013
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1023)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if (optim .eq. 100) then
	if (liw .lt. max(2*nproc,maxnvp*nvt*ia2)) then
	  ierr  = 8014
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1026)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
      if (optim .eq. 200) then
	if (liw .lt. max(2*nproc,maxnvp*nvt*ia2,4*l)) then
	  ierr  = 8015
	  if (myproc .eq. 1) then
	    write(lout,1010)
	    write(lout,1025)
	    write(lout,1050)
          endif
          goto 999
        endif
      endif
c**
c***  CHECK MISC (ILIN(19))
c**
      if (mod(misc,10000) .ge. 1000) then
	if ((nproc .ne. 1) .or. (ilin(4) .ne. -1)) then
          ierr  = 8006
	  if (myproc .eq. 1) then
	    write(lout,1030)
	    write(lout,1031)
	    write(lout,1032)
	    write(lout,1033)
	    write(lout,1040)
          endif
	  ilin(19) = ilin(19) - 1000
        endif
      endif
c**
c***  CHECK ISPREC
c**
      if ((MOD(isprec,100) .ne. 0) .and. (MOD(isprec,100) .ne. 1)
     *    .and. (MOD(isprec,100) .ne. 10) .and.
     *    (MOD(isprec,100) .ne. 11)) then
        ierr  = 8010
	if (myproc .eq. 1) then
	  write(lout,1010)
	  write(lout,1011)
	  write(lout,1050)
        endif
        goto 999
      endif
c**
c***  CHECK NOPREC
c**
      if ((noprec .lt. 0) .or. (noprec .gt. 2)) then
        ierr  = 8011
	if (myproc .eq. 1) then
	  write(lout,1010)
	  write(lout,1012)
	  write(lout,1050)
        endif
        goto 999
      endif
c**
c***  CHECK MSPREC
c**
      if (((msprec .gt. 4) .and. (msprec .lt. 11)) .or.
     #     (msprec .gt. 14) .or. (msprec .lt. 0)) then
        ierr  = 8012
	if (myproc .eq. 1) then
	  write(lout,1010)
	  write(lout,1013)
	  write(lout,1050)
        endif
        goto 999
      endif
c**
c***
c** 
  999 call LL4INM(ione,ione,ione,ierr,iermax,ihelp,myproc,nproc,
     *            tids,nmsg)
      if (iermax .ne. 0) then
	if (ierr .ne. iermax) then
	  write(lout,1014) myproc
	endif
        if (iermax .eq. 8006) then
	  ierr = 0
	else
	  ierr = iermax
	endif
      endif
c**
c**
c***  FORMATS
c**
 1010 format(' *****************************************'/
     &       ' ***  LL8CK2: error detected;          ***')
 1015 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 15*l           ***')
 1017 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 17*l           ***')
 1018 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 18*l           ***')
 1019 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 19*l           ***')
 1020 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 20*l           ***')
 1022 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 22*l           ***')
 1024 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 24*l           ***')
 1054 format(' ***   Not enough workspace!           ***'/
     &       ' ***   ldw is less than 54*l           ***')
 1011 format(' ***   ilin(6) must be 0, 1, 10 or 11! ***')
 1012 format(' ***   ilin(9) can only be set to      ***'/
     &       ' ***           zero, one or two!       ***')
 1013 format(' ***   ilin(15) can only be set to     ***'/
     &       ' ***      0,1,2,3,4 or 11,12,13,14!    ***')
 1014 format(' ***   Parameters which have to be     ***'/
     &       ' ***   global are local on proc.',i6,' ***')
 1050 format(' *****************************************'/)
 1023 format(' ***   Not enough workspace! liw is    ***'/
     &       ' ***   less than 2*nproc               ***')
 1026 format(' ***   Not enough workspace!           ***'/
     &       ' ***   liw is less than                ***'/
     &       ' ***   max(2*nproc,nvt*ia2)            ***')
 1025 format(' ***   Not enough workspace!           ***'/
     &       ' ***   liw is less than                ***'/
     &       ' ***   max(2*nproc,nvt*ia2,4*l)        ***')
 1030 format(' *******************************************'/
     &       ' ***  LL8CK2 : Warning!                  ***') 
 1031 format(' ***   Output of error only possible for ***')
 1032 format(' ***   <nproc> == 1 and <nrhs> == -1 !   ***')
 1033 format(' ***   No output of error!               ***')
 1035 format(' ***   Wrong method selection parameter: ***')
 1036 format(' ***     ilin(1) = ',i6,'                ***')
 1037 format(' ***     changing to polyalgorithm or    ***'/
     &       ' ***     CG-method, if matrix is symm.   ***') 
 1040 format(' *******************************************')
      r e t u r n
c-----END OF LL8CK2---------------------------------------------------      
      e n d
