C:::::      ,,,,,LL8EPS.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      double precision function LL8EPS(start)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 8 E P S    determines the accuracy of the arithmetic   ***
C**                     of the mantisse.                            ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1995 University Karlsruhe                      ***
C**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      double precision     start
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                        ***
C**      ----------------                                          ***
C**                                                                 ***
      double precision     eps,eps2,one,two
      parameter (one=1.0,two=2.0)
C**                                                                 ***

      eps = start
      if ((one+eps) .ne. one) then
  111   eps2 = eps/two
        if ((one+eps2) .ne. one) then
	  eps = eps2
	  goto 111
        endif
      endif
      LL8EPS = eps
C**                                                                 ***
      r e t u r n
C-----END OF LL8EPS----------------------------------------------------
      e    n    d
