c***********************************************************************
c        1         2         3         4         5         6         7 *
c***********************************************************************
c**                                                                  ***
c**                                                                  ***
      subroutine LL8GLB(ilin,myproc,nproc,tids,nmsg)
c**                                                                  ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
c**    L L 8 G L B     computes global parameters like lmat, lindex  ***
c**                    and the number of vector terms                ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
c**    Copyright (C) 1997 University Karlsruhe                       ***
c**    Programmer: H. Haefner                                        ***
!**                                                                  ***
!**    This file is part of LINSOL.                                  ***
!**    LINSOL is free software; you can redistribute it and/or       ***
!**    modify it under the terms of the GNU General Public License   ***
!**    as published by the Free Software Foundation; either          ***
!**    version 2 of the License, or (at your option) any later       ***
!**    version.                                                      ***
!**                                                                  ***
!**    LINSOL is distributed in the hope that it will be useful,     ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty   ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.       ***
!**    See the GNU General Public License for more details.          ***
!**                                                                  ***
!**    You should have received a copy of the GNU General Public     ***
!**    License along with LINSOL; if not, write to the Free          ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,       ***
!**    Boston, MA  02111-1307, USA.                                  ***
c**                                                                  ***
c***********************************************************************
c**                                                                  ***
      USE constants

      implicit none
c**                                                                  *** 
c***********************************************************************
c**                                                                  ***
c**    Formal Parameters :                                           ***
c**                                                                  ***
c***********************************************************************
      integer            myproc,nproc,nmsg
      integer            ilin(nilin),tids(nproc)
c***********************************************************************
c**                                                                  ***
c**    List of Formal Parameters :                                   ***
c**                                                                  ***
c**                                                                  ***
c---------I------I-----I------------------------------------------------
c NAME    I TYPE I I/O I MEANING
c---------I------I-----I------------------------------------------------
c ilin(30)I int  I out I global size of matrix
c---------I------I-----I------------------------------------------------
c ilin(31)I int  I out I global size of index array
c---------I------I-----I------------------------------------------------
c ilin(32)I int  I out I global number of vector terms
c---------I------I-----I------------------------------------------------
c ilin(33)I int  I in  I local size of matrix 
c---------I------I-----I------------------------------------------------
c ilin(34)I int  I in  I local size of index array  
c---------I------I-----I------------------------------------------------
c ilin(35)I int  I in  I local number of vector terms
c---------I------I-----I------------------------------------------------
c ilin(50)I int  I in  I shows if global parameters have been stored
c         I      I     I in the main program <linsol>
c---------I------I-----I------------------------------------------------
c**                                                                  ***
c**                                                                  ***
c**    Local Variables :                                             ***
c**                                                                  ***
      integer        ih(3)


c***********************************************************************
c**    Start of Calculation                                          ***
c***********************************************************************


      call LL4ISM(1,3,1,ilin(33),ilin(30),ih,myproc,nproc,tids,nmsg)


c***********************************************************************
c**    End of Calculation                                            ***
c***********************************************************************

       r e t u r n
C---- END OF LL8GLB --------------------------------------------------
       e    n    d
