C:::::      ,,,,,LL8MS.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8MS(ilin1,ms,lsym,iconv)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 8 M S     LSOLPP method selection                      ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1995 University Karlsruhe                      ***
C**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer          ilin1,ms,iconv
      logical          lsym
C**                                                                 ***
C**   IF MATRIX IS SYMMETRIC, THEN THE METHOD IS CG                 ***
C**                                                                 ***
C**                                                                 ***
      if (lsym) then

        if (ilin1 .eq. 220) then
	  if (ms .eq. 101) ms = 100
	  if (ms .eq.   0) ms = 101
	  goto 999
        endif

        if (ilin1 .eq. 221) then
	  if (ms .eq. 101) then
	    ms = 100
	    goto 999
	  endif
	  if (ms .eq. 0 .or. ms .eq. 100) ms = 101
	  goto 999
        endif

	if (ilin1 .ne. 100 .and. ilin1 .ne. 101) ilin1 = 100

	ms = ilin1
	goto 999

      else
        if (ilin1 .eq. 100) ilin1 = 205
        if (ilin1 .eq. 101) ilin1 = 202
        if (ilin1 .eq. 220) ilin1 = 210
        if (ilin1 .eq. 221) ilin1 = 211
      endif
C**                                                                 ***
      if ((ilin1 .gt. 0) .and. (ilin1 .lt. 10 .or. ilin1 .eq. 15 .or.
     &    ilin1 .eq. 16)) then
	ms = ilin1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 200) then
	if (ms .eq. 7) ms = 4 
	if (ms .eq. 1) ms = 7
	if (ms .eq. 0) ms = 1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 201) then
	if (ms .eq. 4) then
	  ms = 7
	  goto 999
	endif
	if (ms .eq. 7 .and. iconv .eq. 5) ms = 4 
	if (ms .eq. 7 .and. iconv .eq. 6) then
	  ms = 1 
	  goto 999
	endif
	if (ms .eq. 1) ms = 7
	if (ms .eq. 0) ms = 1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 202) then
	if (ms .eq.15) ms = 4 
	if (ms .eq. 7) ms = 15
	if (ms .eq. 1) ms = 7
	if (ms .eq. 0) ms = 1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 203) then
	if (ms .eq. 15) then
	  ms = 4 
	  goto 999
	endif
	if (ms .eq. 7 .or. ms .eq. 4) ms = 15
	if (ms .eq. 1) ms = 7
	if (ms .eq. 0) ms = 1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 204) then
	if (ms .eq.16) ms = 4 
	if (ms .eq. 7) ms = 16
	if (ms .eq. 1) ms = 7
	if (ms .eq. 0) ms = 1
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 210) then
	if (ms .eq. 15) ms = 4
	if (ms .eq. 0) ms = 15
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 211) then
	if (ms .eq. 15) then
	  ms = 4 
	  goto 999
	endif
	if (ms .eq. 0 .or. ms .eq. 4) ms = 15
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 212) then
	if (ms .eq. 16) ms = 4
	if (ms .eq. 0) ms = 16
	goto 999
      endif
C**                                                                 ***
      if (ilin1 .eq. 999) then
	ms = ilin1
	goto 999
      endif
C**                                                                 ***
  999 continue
      r e t u r n
C-----END OF LL8MS----------------------------------------------------
      e    n    d
