C:::::      ,,,,,LL8NME.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8NME(work,xs,x,r,esnorm,enorm,rnorm,l,lmyblk,
     &                  nproc,myproc,tid,nmsg)
C     subroutine LL8NME(work,xs,x,r,prec,esnorm,enorm,rnorm,l,lmyblk,
C    &                  lprec,ilin,nproc,myproc,tid,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 8 N M E  calculates the norm of the error              ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE solex
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -------------------                                        ***
C**                                                                 ***

C     integer          l,lmyblk,lprec,nproc,myproc,nmsg
      integer          l,lmyblk,nproc,myproc,nmsg
C     integer          tid(nproc),ilin(nilin)
      integer          tid(nproc)
C     double precision work(l),xs(l),x(l),r(l),prec(lprec),
      double precision work(l),xs(l),x(l),r(l),esnorm,enorm,rnorm
C**                                                                 ***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   ---------------------------                                   ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C work   I  R   I  -  I  vector containing the difference of actual 
C        I      I     I  and exact solution
C--------I------I-----I------------------------------------------------
C x      I  R   I IN  I  vector containing the actual solution (not 
C        I      I     I  smoothed)
C--------I------I-----I------------------------------------------------
C xs     I  R   I IN  I  vector containing the actual smoothed solution
C--------I------I-----I------------------------------------------------
C prec   I  R   I IN  I  normalization and preconditioning vector
C--------I------I-----I------------------------------------------------
C xexact I  R   I IN  I  vector containing the exact solution 
C--------I------I-----I------------------------------------------------
C esnorm I  R   I OUT I  euclidian norm of the smoothed error
C--------I------I-----I------------------------------------------------
C enorm  I  R   I OUT I  euclidian norm of the error
C--------I------I-----I------------------------------------------------
C rnorm  I  R   I OUT I  euclidian norm of the residual (not smoothed)
C--------I------I-----I------------------------------------------------

      integer           i,ione
      double precision  rpoly,rseucn,help
      logical           lsym

      common /norms/ rseucn,rpoly(3),lsym

      parameter (ione = 1)
C**-----------------------------------------------------------------***

C     if ((ilin(1) .eq. 9) .or. lsym .or. (ilin(15) .gt. 10)) then
C       do 50 i=1,lmyblk
C         work(i) = (prec(i)*xs(i)-xexact(i))/prec(i)
C 50    continue
C     else
        do 100 i=1,lmyblk
          work(i) = xs(i)-xexact(i)
 100    continue
C     endif

      call LL4SCP(lmyblk,ione,l,ione,work,1,work,1,esnorm,help,
     *            .false.,myproc,nproc,tid,nmsg)
      esnorm = sqrt(esnorm)

C     if ((ilin(1) .eq. 9) .or. lsym .or. (ilin(15) .gt. 10)) then
C       do 150 i=1,lmyblk
C         work(i) = (prec(i)*x(i)-xexact(i))/prec(i)
C150    continue
C     else
        do 200 i=1,lmyblk
          work(i) = x(i)-xexact(i)
 200    continue
C     endif

      call LL4SCP(lmyblk,ione,l,ione,work,1,work,1,enorm,help,
     *            .false.,myproc,nproc,tid,nmsg)
      enorm = sqrt(enorm)

      call LL4SCP(lmyblk,ione,l,ione,r,1,r,1,rnorm,help,
     *            .false.,myproc,nproc,tid,nmsg)
      rnorm = sqrt(rnorm)
c**
c**
c**   END OF CALCULATION
c**   ------------------ 
c**
      r e t u r n
c**                                                                 ***
c**---END OF LL8NME-------------------------------------------------***
c**                                                                 ***
      e    n    d
  
