C:::::      ,,,,,LL8SC7.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8SC7(info,nvt,ivt,ia1,lmatbk,ptrmbk,ptrinf,
     *                  maxnvp,cachln,myproc,nproc,tid,lout,ierr)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 8 S C 7   separates full rows in <maxnvp>              ***
C**                    column blocks.                               ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer    ia1,ivt,nvt,nproc,myproc,ierr,lout,maxnvp,cachln
      integer    info(ia1,ia2),tid(nproc),lmatbk(nproc),
     *           ptrmbk(nproc+1),ptrinf(ntyp+1,nproc)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   Arrays info(ia1,ia2),tid(nproc),lmatbk(nproc),ptrmbk(nproc+1) ***
C**   Variables ia1,ia2,nproc,myproc,ierr:                          ***
C**              see Manual-Pages <lsolpp>                          ***
C**                                                                 ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C ivt    I  I   I in  I  number of vector term to separate
C        I      I     I  Note: it can vary on different processors
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer    i,iermax,iar,iac,iacend,nvtmin
      integer    adda,glvt,s_addr,s_ptr,e_ptr
C**                                                                 ***
C----------------------------------------------------------------------
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      ierr = 0
      adda = info(ivt,2)
      iac  = info(ivt,4)
      iar  = info(ivt,5)
      info(ivt,6) = 0
      do 5 i=1,nproc
        if ((ivt .gt. ptrinf(7,i)) .and. (ivt .le. ptrinf(8,i))) then
	  info(ivt,7) = 10000*i
	endif
    5 continue

      do 10 i=maxnvp,1,-1
        glvt = info(ivt,3)
        iacend = iac+glvt
        s_ptr = ptrmbk(myproc)+(i-1)*cachln
	if (i .eq. maxnvp) then
          e_ptr = ptrmbk(myproc)+lmatbk(myproc)
        else
          e_ptr = ptrmbk(myproc)+i*cachln
        endif
	if (iac .lt. s_ptr) then
	  if (iacend .gt. s_ptr) then
	    nvt    = nvt+1
	    nvtmin = min(nvt,ia1)
	    s_addr = s_ptr-iac
            info(nvtmin,1) = info(ivt,1)
            info(nvtmin,2) = adda+s_addr
            info(nvtmin,4) = s_ptr
            info(nvtmin,5) = iar
            info(nvtmin,6) = 0
            info(nvtmin,7) = info(ivt,7)+i
	    if (iacend .le. e_ptr) then
	      info(nvtmin,3) = iacend-s_ptr
            else
	      ierr = 8070+myproc
              write(lout,1000)
              write(lout,1010) myproc
              write(lout,1020)
	      goto 999
            endif
	    info(ivt,3) = glvt-info(nvtmin,3)
          endif
        endif
        if ((iac .ge. s_ptr) .and. (iacend .le. e_ptr)) then
          info(ivt,7) = info(ivt,7)+i
        endif
   10 continue

  999 continue
 1000 format(' **********************************************'/
     &       ' ***  Error occured in LSOLPP (LL8SC7):     ***')
 1010 format(' ***   LL8SC7: Implementation error         ***'/
     &       ' ***           on processor ',i6,'          ***')
 1020 format(' **********************************************')
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LL8SC7---------------------------------------------------
      e    n    d
