C:::::      ,,,,,LL8SMQ.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LL8SMQ(dw,ibrs,ibrp1,ibxs,ibxp1,ibcom,ldw,l,lmyblk,
     #                  break,count,myproc,nproc,tid,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L L 8 S M Q   computes the smoothed solution and           ***
C**      residual of the normalized system for the QMR-Simulator.   ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1995 University Karlsruhe                      ***
!**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**   the implicit none-instruction has the aim,                    ***
C**   that all variables must be declared explicitly.               ***
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      integer           count,l,ldw,lmyblk,myproc,nproc,nmsg
      integer           ibrs,ibrp1,ibxs,ibxp1,ibcom
      integer           tid(nproc)
      logical           break
      double precision  dw(ldw)
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
C**                    >                                            ***
      integer           i,n,m
      double precision  zero,gamma,gammah,gammar,gammam,rwork
C**                                                                 ***
C**       CONSTANTS:                                                ***
C**       ---------                                                 ***
C**                                                                 ***
      parameter (zero=0, n=1, m=1)

      save gammar
C**                                                                 ***
C**-----------------------------------------------------------------***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
C
      if (count .eq. 1 .or. break) then
        call LL4SCP(lmyblk,n,l,m,dw,ibrs,dw,ibrs,gammar,rwork,
     #              .false.,myproc,nproc,tid,nmsg)
	gammar = 1.d0/gammar
      endif

      call LL4SCP(lmyblk,n,l,m,dw,ibrp1,dw,ibrp1,gammah,rwork,
     #            .false.,myproc,nproc,tid,nmsg)
      gammar = gammar + 1.d0/gammah
      gamma = 1.d0/gammar*1.d0/gammah
      gammam = 1.d0-gamma
      include "norec.h"
      do 40 i=0,lmyblk-1
        dw(ibxs+i) = gammam*dw(ibxs+i) + gamma*dw(ibxp1+i)
        dw(ibrs+i) = gammam*dw(ibrs+i) + gamma*dw(ibrp1+i)
   40 continue
C
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF LL8SMQ----------------------------------------------------
      e    n    d
