C:::::      ,,,,,LSOLPP.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine LSOLPP(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
     &                  lsym,ia1,info,mat,prec,x,b,dw,iprec,
     &                  index,iw,rlin,ilin,lmatbk,ptrinf,tids,
     &                  iconv,ierr)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      L S O L P P   LINSOL-MAIN-PROGRAM for physically and       ***
C**                    logically distributed matrices               ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    Copyright (C) 1996 University Karlsruhe                      ***
C**    Programmer: H. Haefner                                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
C**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
C**                                                                 ***
      USE solex
      USE constants

      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***

      integer           lmat,lprec,liprec,lindex,l,ldw,liw,ia1,
     #                  iconv,ierr,nproc
      double precision  mat(lmat),prec(lprec),x(l),b(l),dw(ldw),
     #                  rlin(nrlin)
      integer
     #                  index(lindex),info(ia1,ia2),
     #                  iw(liw),ilin(nilin),lmatbk(nproc),
     #                  ptrinf(ntyp+1,nproc),tids(nproc),iprec(liprec)
      logical           lsym
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C**   (see Manual-Pages <lsolpp>)                                   ***
C**                                                                 ***
C**                                                                 ***
C**      LOCAL PARAMETERS :                                         ***
C**      -----------------                                          ***
C**                                                                 ***
      integer            ptrmbk(maxnpe+1),jump(maxnpe)
      integer            ispoly(4),lglobal
      integer            ihlp(3)
      integer            j,i,ione,lout,ms,ilin16,idoku,imvm,nmsg,nvt,
     &                   ibcom,lmyblk,myproc,maxnvp,cachln,ivt,nvtold,
     &                   nvtmax,ityp,ihelp,iermax,optim,optimt,csepfc
      integer            ibAx,ibAtx,ibPLb,ibborg,ibplbg,ibNb,ibxorg
      logical            ladd,lfel 
      double precision   LL8EPS,one,zero
      double precision   bmax,eps,help,rseucn,rpoly,epsrel
      double precision   tlpp,telpp,tnrm,tenrm,tpre,tepre,tcpu,tclk
      double precision   tcuse,tecuse,titer,teiter,mflops,mflope,noop

      common /norms/ rseucn,rpoly(3),epsrel
C**                                                                 ***
      parameter (one = 1.0, zero=0.0, ione=1)
C
      external LL6AX,LL6ATX
C
C**** START OF CALCULATION :
C     ---------------------
C
C**
C***  SET POINTERS
C**
      if ((mod(ilin(20),10) .eq. 1) .and. (ilin(17) .eq. 1)) then
        call SECONDS(tlpp,telpp)
      endif

      ibAx  =1
      ibAtx =l+1
      ibPLb =2*l+1
      ibcom =3*l+1

      ibxorg=1+1*l
      ibborg=1+2*l
      ibplbg=1+3*l
      ibNb  =1+4*l
C
C
      lout = ilin(12)
C
      ladd = .false.

      rseucn   = zero
      rpoly(1) = zero
      rpoly(2) = zero
      rpoly(3) = zero
      epsrel   = rlin(1)

      ispoly(1) = 0
      ispoly(2) = 0
      ispoly(3) = 0
      ispoly(4) = 0
      ierr   = 0
      maxnvp = 1
c**
      if (lout .lt. 0) then
	 ierr = 0001
	 iconv = 99
	 write(*,1000)
	 write(*,1001)
	 write(*,1002)
	 write(*,1020)
	 write(*,1035)
	 write(*,1021)
	 write(*,1030)
         goto 999
      endif
c**
      include 'nprocs.h'
      if (nproc .eq. 1) then
        ilin(17) = 1
      endif
c**
      if ((ilin(13) .gt. 0) .and. (ilin(17) .eq. 1)) then
        write(lout,1000)
        write(lout,1001)
        include 'nproc.h'
        write(lout,1002)
      endif
      if (ilin(13) .lt. 0) then
        write(lout,1000)
        write(lout,1001)
        include 'nproc.h'
        write(lout,1002)
      endif

      nvt = 0
      do 2 i=1,nproc
	nvt = max(ptrinf(ntyp+1,i),nvt)
   2  continue

c**
c***  CHECK OF PARAMETERS CONCERNING MATRIX AND NUMBER OF PROC.
c**
      if (ilin(50) .ne. -2) then
        call LL8CK1(lmat,lindex,l,nproc,nvt,info,ia1,ilin,ierr,tids)
        if (ierr .ne. 0) then
	  iconv = 99
          if (ilin(17) .eq. 1) then
	    write(lout,1020)
	    write(lout,1021)
	    write(lout,1030)
          endif
	  goto 999 
        endif
      endif
C**                                                                 ***
C**   CHECK OF GLOBAL LSOLPP-PARAMETERS                             ***
C**                                                                 ***
      if (nproc .gt. 1) then
        call LL8CK3(l,liw,nproc,lsym,ilin,iw,lmatbk,ptrinf,tids,
     *              rlin(1),ierr)
        if (ierr .ne. 0) then
          iconv = 99
          if (ilin(17) .eq. 1) then
            write(lout,1020)
            write(lout,1021)
            write(lout,1030)
          endif
          goto 999
        endif
      endif
c**
c***
c**
      eps  = LL8EPS(one * 1.d-10)

      if (ilin(1) .eq. 9) then
	 lsym = .false.
	 if (ilin(15) .ge. 11) then
	    ilin(15) = ilin(15) - 10
         endif
      endif

      if (nproc .eq. 1) then
	ilin(3)   = 0
	lmatbk(1) = l
	jump(1)   = 1
	tids(1)    = 9999
      endif

      nmsg   = ilin(3)
      idoku  = abs(ilin(13))
      ilin16 = ilin(16)
      myproc = ilin(17)
      optim  = ilin(20)
      lmyblk = lmatbk(myproc)

      ptrmbk(1) = 0
      do 3 i=1,nproc
        ptrmbk(i+1) = ptrmbk(i)+lmatbk(i)
    3 continue
      do 4 i=nproc+1,maxnpe
        ptrmbk(i+1) = 0
    4 continue
C***  ilin(36) is the global dimension of the lin. system (lglobal) ***
      ilin(36)    = ptrmbk(nproc+1)
      lglobal     = ilin(36)
      ilin(10)    = 0
      imvm        = 0
      ms          = 0

C**                                                                 ***
C***  PRINT, IF INITIAL GUESS IS USED                               ***
C**                                                                 ***
      if (ilin(16) .eq. 4711) then
        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1101)
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1101)
        endif
      endif

C**                                                                 ***
C***  CREATE JUMP-VECTOR                                            ***
C**                                                                 ***
      if (nproc .gt. 1) then
        call LL4JMP(jump,ptrinf,iw,liw,lsym,myproc,nproc,tids,nmsg)
      endif

C**                                                                 ***
C***  CACHE REUSE, IF ILIN(20) == 100 (200)                         ***
C**                                                                 ***
      optimt = mod(optim,1000)
      if (optimt .ge. 100) then
        if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1))
     &    call SECONDS(tcuse,tecuse)

        if (ilin(13) .gt. 0) then 
	  if (optimt .eq. 100) then
            if (myproc .eq. 1) write(lout,1104)
	  endif
	  if (optimt .eq. 200) then
            if (myproc .eq. 1) write(lout,1105)
	  endif
        endif
        if (ilin(13) .lt. 0) then 
          if (optimt .eq. 100) write(lout,1104)
          if (optimt .eq. 200) write(lout,1105)
        endif

        csepfc = int(3.5*l/cusfac) 
        if (csepfc .le. cachsz) goto 111
	maxnvp = csepfc/cachsz
	if (mod(csepfc,cachsz) .ne. 0) maxnvp = maxnvp+1
	cachln = l/maxnvp
	if (mod(l,maxnvp) .ne. 0) cachln = cachln+1

        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1111) cachsz
          if (myproc .eq. 1) write(lout,1112) cusfac
          if (myproc .eq. 1) write(lout,1113) cachln
          if (myproc .eq. 1) write(lout,1106) maxnvp
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1111) cachsz
          write(lout,1112) cusfac
          write(lout,1113) cachln
          write(lout,1106) maxnvp
        endif

	nvtold = nvt
	do 10 ivt=1,nvtold
	  ityp = info(ivt,1)
	  if (ityp .eq. 2 .or. ityp .eq. 20) then
            call LL8SR2(info,nvt,ivt,ia1,lmatbk,ptrmbk,ptrinf,
     &                  maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
	  if (ityp .eq. 3 .or. ityp .eq. 30) then
           call LL8SR3(index,lindex,info,nvt,ivt,ia1,lmatbk,
     &     ptrmbk,ptrinf,maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
	  if (ityp .eq. 4 .or. ityp .eq. 40) then
           do 61 i=1,nproc
	    if ((ivt.gt.ptrinf(4,i)) .and. (ivt.le.ptrinf(5,i))) then
              info(ivt,7) = 10000*i
	      goto 10
	    endif
   61      continue
          endif
	  if (ityp .eq. 5 .or. ityp .eq. 50) then
           do 62 i=1,nproc
	    if ((ivt.gt.ptrinf(5,i)) .and. (ivt.le.ptrinf(6,i))) then
              info(ivt,5) = 10000*i
	      goto 10
	    endif
   62      continue
          endif
	  if (ityp .eq. 6 .or. ityp .eq. 60) then
            if (mod(optim,1000) .eq. 200) then
              call LL8SR6(mat,index,dw,iw,l,lmat,lindex,info,nvt,
     &                    ivt,ia1,lmatbk,ptrmbk,ptrinf,maxnvp,
     &                    cachln,myproc,nproc,tids,lout,ierr)
	    else
              do 63 i=1,nproc
	        if ((ivt .gt. ptrinf(6,i)) .and.
     &              (ivt .le. ptrinf(7,i))) then
                  info(ivt,5) = 10000*i
		  goto 10
		endif
   63         continue
            endif
          endif
	  if (ityp .eq. 7 .or. ityp .eq. 70) then
            call LL8SC7(info,nvt,ivt,ia1,lmatbk,ptrmbk,ptrinf,
     &                  maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
	  if (ityp .eq. 8 .or. ityp .eq. 80) then
            call LL8SR8(info,nvt,ivt,ia1,lmatbk,ptrmbk,ptrinf,
     &                  maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
	  if (ityp .eq. 9 .or. ityp .eq. 90) then
           call LL8SC9(index,lindex,info,nvt,ivt,ia1,lmatbk,
     &     ptrmbk,ptrinf,maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
	  if (ityp .eq. 11 .or. ityp .eq. 100) then
           call LL8SR1(index,lindex,info,nvt,ivt,ia1,lmatbk,
     &     ptrmbk,ptrinf,maxnvp,cachln,myproc,nproc,tids,lout,ierr)
          endif
   10   continue

        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1107) nvt-nvtold
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1107) nvt-nvtold
        endif
        if (nvt .gt. ia1) then
          ierr = 0002+myproc
        endif
        call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
	if (iermax .gt. 0) then
	  ierr = iermax
	  if (myproc .eq. 1) then
            write(lout,1020)
            write(lout,1024) ia1,nvt,iermax-0002
            write(lout,1030)
          endif
	  iconv = 99
	  goto 999
        endif
        if (liw .lt. nvt*ia2) then
          ierr = 0003+myproc
        endif
        call LL4INM(1,1,1,ierr,iermax,ihelp,myproc,nproc,tids,nmsg)
	if (iermax .gt. 0) then
          call LL4INM(1,1,1,nvt,nvtmax,ihelp,myproc,nproc,tids,nmsg)
	  ierr = iermax
	  if (myproc .eq. 1) then
            write(lout,1020)
            write(lout,1025) liw,nvtmax*ia2,iermax-0003
            write(lout,1030)
          endif
	  iconv = 99
	  goto 999
        endif
        if (nvt .gt. nvtold) then
          call LL8IRS(index,lindex,info,ia1,ptrinf,iw,liw,nproc,maxnvp,
     &                nvtold,nvt,myproc,tids,nmsg,optim,lout,ierr)
	  if (ierr .gt. 0) then
	    iconv = 99
	    goto 999
          endif
        endif

        if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1)) then
 	  call SECONDS(tcpu,tclk)
	  tcuse  = tcpu - tcuse
	  tecuse = tclk - tecuse
          write(lout,1140)
          write(lout,1130) tcuse
          write(lout,1131) tecuse
	endif
      endif

  111 continue

C**                                                                 ***
C**   CHECK OF PARAMETERS CONCERNING CG - METHOD                    ***
C**                                                                 ***
      call LL8CK2(l,ldw,liw,lsym,maxnvp,nvt,ilin,ierr,nproc,tids,nmsg)
      if (ierr .ne. 0) then
	 iconv = 99
         if (ilin(17) .eq. 1) then
	    write(lout,1020)
	    write(lout,1021)
	    write(lout,1030)
         endif
	 goto 999
      endif
C**                                                                 ***
C***  COMPUTATION OF GLOBAL PARAMETERS                              ***
C**                                                                 ***
      if ((mod(optim,10) .eq. 1) .and. (nproc .gt. 1)) then
        call LL8GLB(ilin,myproc,nproc,tids,nmsg)
      endif
C**                                                                 ***
C***  PRINTING OF STATISTICS                                        ***
C**                                                                 ***
      if (mod(optim,100) .ge. 10) then
        call LL8STATP(l,lglobal,lmat,mat,lindex,lprec,liprec,prec,
     &                iprec,info,ia1,nvt,ilin,rlin,lsym,maxnvp,idoku,
     &                lout,myproc,nproc,tids,nmsg)
      endif

C**
C***  STORE THE ORIGINAL INITIAL GUESS
C**
      if (ilin(16) .eq. 4711) then
      include "norec.h"
        do 5 i=1,l
          prec(ibxorg+i-1) = x(i)
    5   continue
        if (mod(ilin(19),10000) >= 1000) then
      include "norec.h"
          do 17 i=1,lmyblk
	    xexact(i) = xexact(i) - x(i)
   17     continue
	endif
      else
      include "norec.h"
        do 6 i=1,l
          prec(ibxorg+i-1) = zero
    6   continue
      endif
C**
C***  STORE THE ORIGINAL RIGHT_HAND_SIDE (RHS)
C**
      include "norec.h"
      do 15 i=1,l
        prec(ibborg+i-1) = b(i)
   15 continue
C**                                                                 ***
C***  NORMALIZATION                                                 ***
C**                                                                 ***
      if (ilin(15) .gt. 0) then
        if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1))
     &    call SECONDS(tnrm,tenrm)
      endif

      call LL1NRM(lmat,lprec,lindex,l,ldw,liw,nproc,
     &            lsym,ia1,info,mat,prec,x,b,dw,index,iw,
     &            ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,nmsg,
     &            iconv,ierr)
      if (iconv .eq. 99) then
         if (ilin(17) .eq. 1) then
	    write(lout,1020)
	    write(lout,1022)
	    write(lout,1030)
         endif
	 goto 999
      endif
      if (ilin(15) .gt. 0) then
        if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1)) then
          call SECONDS(tcpu,tclk)
          tnrm  = tcpu - tnrm
          tenrm = tclk - tenrm
          write(lout,1140)
          write(lout,1132) tnrm
          write(lout,1133) tenrm
        endif
      endif

C**                                                                 ***
C***  PRINTING OF VECTOR TERMS ON UNIT <ILIN(41)>                   ***
C**                                                                 ***
      if ((mod(ilin(19),10) .eq. 2).or.(mod(ilin(19),10) .eq. 3)) then
        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1108) ilin(41)
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1108) ilin(41)
        endif
        call SHOWVT(MAT,lmat,index,lindex,info,ia1,nvt,l,lsym,
     &              myproc,nproc,lmatbk,ilin(41),ierr)
      endif

C**                                                                 ***
C***  STORE THE MATRIX <MAT> IN LINSOL-FORMAT ON UNIT <ILIN(43)>    ***
C**                                                                 ***
      ihelp = mod(ilin(19),1000)
      if (ihelp .ge. 300 .and. ihelp .lt. 400) then
        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1109) ilin(43)
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1109) ilin(43)
        endif
        call LINOUT(mat,lmat,index,lindex,info,ia1,nvt,lmyblk,lsym,
     &              ilin,ilin(43),ierr)
      endif
      if (ihelp .ge. 400) then
        if (ilin(13) .gt. 0) then 
          if (myproc .eq. 1) write(lout,1114) ilin(43)
        endif
        if (ilin(13) .lt. 0) then 
          write(lout,1114) ilin(43)
        endif
        call LINBOUT(mat,lmat,index,lindex,info,ia1,nvt,lmyblk,lsym,
     &               ilin,ilin(43),ierr)
      endif
 

      if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1))
     #  call SECONDS(titer,teiter)

  222 continue

      if ((ilin(16) .eq. 4711) .and. (iconv .ge. 5)) then
        if ((ms .eq. 9) .or. lsym .or. (ilin(15) .gt. 10)) then
      include "norec.h"
          do 9 i = 1,lmyblk
             x(i) = prec(i) * x(i)
    9     continue
        endif
      include "norec.h"
        do 7 i = 1,lmyblk
          x(i) = x(i) + prec(ibxorg+i-1)
    7   continue
      include "norec.h"
        do 8 i=1,l
          prec(ibxorg+i-1) = x(i)
    8   continue
        if ((ms .eq. 9) .or. lsym .or. (ilin(15) .gt. 10)) then
      include "norec.h"
          do 11 i = 1,lmyblk
             x(i) = x(i) / prec(i)
   11     continue
        endif
      endif

      if (iconv .ge. 5) then
      include "norec.h"
        do 16 i=1,l
          b(i) = prec(i)*prec(ibborg+i-1)
   16   continue
      endif
	
      if (ilin(16) .eq. 4711) then
        if (ilin(1) .eq. 9) then
          call LL3ATX(LL6ATX,mat,x,dw(ibAtx),dw(ibcom),ptrmbk,lmatbk,
     #                ptrinf,l,nproc,tids,myproc,jump,
     #                ladd,lmat,lindex,ia1,info,index,nmsg)
          imvm  = imvm  + 1
        endif
        if (ilin(1) .ne. 9) then
         do 24 i = 1,l
           dw(ibAtx+i-1) = x(i)
   24    continue
        endif
	if (lsym) then
          call LL3ASX(mat,dw(ibAtx),dw(ibAx),dw(ibcom),ptrmbk,
     #                lmatbk,ptrinf,l,nproc,tids,myproc,jump,
     #                ladd,lmat,lindex,ia1,info,index,nmsg)
        else
	  call LL3AX(LL6AX,mat,dw(ibAtx),dw(ibAx),dw(ibcom),ptrmbk,
     #               lmatbk,ptrinf,l,nproc,tids,myproc,jump,
     #               ladd,lmat,lindex,ia1,info,index,nmsg)
	endif
        imvm  = imvm  + 1
      include "norec.h"
        do 25 i = 1,lmyblk
          b(i) = b(i) - dw(ibAx+i-1)
   25   continue
      endif
C**
C***  STORE  N * RHS
C**
      include "norec.h"
      do 26 i=1,l
        prec(ibNb+i-1) = b(i)
   26 continue
C**                                                                 ***
C***  PRECONDITIONING                                               ***
C**                                                                 ***
C     if (iconv .ne. 5) then
C      if ((ilin(8) .ge. 31) .and. (ilin(8) .le. 90)) then
C       if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1))
C    &    call SECONDS(tpre,tepre)
C       call LL1PRE(lmat,lprec,liprec,lindex,l,ldw,liw,nproc,
C    &              lsym,ia1,info,mat,prec,x,b,dw,iprec,index,iw,
C    &              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,myproc,
C    &              iconv,ierr)
C       if (iconv .eq. 4) goto 999
C       if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1)) then
C         call SECONDS(tcpu,tclk)
C         tpre  = tcpu - tpre
C         tepre = tclk - tepre
C         write(lout,1140)
C         write(lout,1134) tpre
C         write(lout,1135) tepre
C       endif
C      endif
C     endif

C**                                                                 ***
C***  IF MAXIMUM OF B = 0, THEN THE SOLUTION IS THE INITIAL GUESS   ***
C**                                                                 ***
      call LL4RNM(lmyblk,ione,l,b,bmax,help,myproc,nproc,tids,nmsg)
      if (bmax .eq. zero) then
         do 53 i = 1,l
           x(i) = prec(ibxorg+i-1)
   53    continue
         iconv=1
	 if (ilin(13) .ge. 0) then 
	    if (myproc .eq. 1) then
	       write(lout,1110)
	       write(lout,1120)
            endif
         else
	    write(lout,1110)
	    write(lout,1120)
         endif
         goto 999
      endif
       
C**
C***  IF PL <> I ==>  PL * b is computed
C**
      if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #    (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then 
C     if(mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then 
C       call LL3AX(LL6AX,prec(iprec(7)+1),b,dw(ibPLb),dw(ibcom),
C    #             ptrmbk,lmatbk,iprec(iprec(11)+1),l,nproc,tids,
C    #             myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
C    #             iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
        lfel = .true.
	if (nproc == 1) then
	  if (lsym) then
            call FELBWSSYM1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                      iprec(2),iprec(iprec(13)+1),
     #                      iprec(3),b,dw(ibPLb),l,lfel,ierr)
          else
	    call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                   iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                   iprec(3),b,dw(ibPLb),iprec(iprec(15)+1),l,
     #                   lfel,ierr)
          endif
	else
	  call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                iprec(3),b,dw(ibPLb),iprec(iprec(15)+1),ptrmbk,l,
     #                lglobal,ilin(38),lfel,myproc,nproc,tids,nmsg,ierr)
	endif
	if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
          lfel = .false.
	  if (nproc == 1) then
            if (lsym) then
              call FELBWSSYM1(prec(iprec(7)+1),iprec(1),
     #                   iprec(iprec(9)+1),iprec(2),iprec(iprec(13)+1),
     #                   iprec(3),dw(ibPLb),dw(ibPLb),l,lfel,ierr)
            else
	      call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                  iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                  iprec(3),dw(ibPLb),dw(ibPLb),
     #                  iprec(iprec(15)+1),l,lfel,ierr)
            endif
	  else
	    call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                  iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                  iprec(3),dw(ibPLb),dw(ibPLb),iprec(iprec(15)+1),
     #                  ptrmbk,l,lglobal,ilin(38),lfel,
     #                  myproc,nproc,tids,nmsg,ierr)
	  endif
	endif
        if (ierr .ne. 0) then
          iconv = 99
          if (ilin(17) .eq. 1) then
            write(lout,1020)
            write(lout,1026)
            write(lout,1030)
          endif
          goto 999
        endif
        include "norec.h"
        do 35 i = 1,lmyblk
          b(i) = dw(i+ibPLb-1)
   35   continue
      endif
C**
C***  IF PL <> I   ==>  PL*N*borg  is computed
C**
      if (iconv .ne. 5) then
      include "norec.h"
        do 36 i=1,lmyblk
          dw(ibPLb+i-1) = prec(i) * prec(ibborg+i-1)
   36   continue

        if ((ilin(8) .eq. 63) .or. (ilin(8) .eq. 69) .or.
     #      (ilin(8) .eq. 72) .or. (ilin(8) .eq. 78)) then 
C       if(mod(ilin(8),3) .ne. 2 .and. ilin(8) .ne. 0) then 
C         imvm  = imvm  + 1
C         call LL3AX(LL6AX,prec(iprec(7)+1),dw(ibPLb),prec(ibplbg),
C    #               dw(ibcom),ptrmbk,lmatbk,iprec(iprec(11)+1),l,
C    #               nproc,tids,
C    #               myproc,jump,ladd,iprec(1),iprec(2),iprec(3),
C    #               iprec(iprec(10)+1),iprec(iprec(9)+1),nmsg)
          lfel = .true.
	  if (nproc == 1) then
	    if (lsym) then
              call FELBWSSYM1(prec(iprec(7)+1),iprec(1),
     #                   iprec(iprec(9)+1),iprec(2),iprec(iprec(13)+1),
     #                   iprec(3),dw(ibPLb),dw(ibplbg),l,lfel,ierr)
            else
	      call FELBWS1(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                   iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                   iprec(3),dw(ibPLb),prec(ibplbg),
     #                   iprec(iprec(15)+1),l,lfel,ierr)
	    endif
	  else
	    call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                  iprec(2),iprec(iprec(10)+1),iprec(iprec(13)+1),
     #                  iprec(3),dw(ibPLb),prec(ibplbg),
     #                  iprec(iprec(15)+1),ptrmbk,l,lglobal,ilin(38),
     #                  lfel,myproc,nproc,tids,nmsg,ierr)
	  endif
	  if ((ilin(8) .eq. 69) .or. (ilin(8) .eq. 78)) then
            lfel = .false.
	    if (nproc == 1) then
              if (lsym) then
                call FELBWSSYM1(prec(iprec(7)+1),iprec(1),
     #                    iprec(iprec(9)+1),iprec(2),iprec(iprec(13)+1),
     #                    iprec(3),dw(ibplbg),dw(ibplbg),l,lfel,ierr)
              else
	        call FELBWS1(prec(iprec(7)+1),iprec(1),
     #                    iprec(iprec(9)+1),iprec(2),iprec(iprec(10)+1),
     #                    iprec(iprec(13)+1),iprec(3),prec(ibplbg),
     #                    prec(ibplbg),iprec(iprec(15)+1),l,lfel,ierr)
	      endif
	    else
	      call FELBWS(prec(iprec(7)+1),iprec(1),iprec(iprec(9)+1),
     #                    iprec(2),iprec(iprec(10)+1),
     #                    iprec(iprec(13)+1),iprec(3),prec(ibplbg),
     #                    dw(ibplbg),iprec(iprec(15)+1),ptrmbk,l,
     #                    lglobal,ilin(38),lfel,
     #                    myproc,nproc,tids,nmsg,ierr)
	    endif
	  endif
          if (ierr .ne. 0) then
            iconv = 99
            if (ilin(17) .eq. 1) then
              write(lout,1020)
              write(lout,1026)
              write(lout,1030)
            endif
            goto 999
          endif
	else
        include "norec.h"
          do 38 i=1,lmyblk
            prec(ibplbg+i-1) = dw(ibPLb+i-1)
   38     continue
        endif
      endif
 
C**                                                                 ***
C**   METHOD SELECTION                                              ***
C**                                                                 ***

      call LL8MS(ilin(1),ms,lsym,iconv)
 
      if (ms.eq.1) then
        call LL1P20(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
         go to 333
      endif
      if (ms.eq.2 .or. ms.eq.6) then
        call LL1BCO(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              ms,eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.3) then
        call LL1CGB(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.4) then
        call LL1ATP(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.5) then
        call LL1CGS(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.7) then
        call LL1CGB2(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #               mat,prec,x,b,
     #               iprec,index,ia1,info,dw,iw,
     #               ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #               eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.9) then
        call LL1CGT(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.11) then
        call LL1PAP20(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #                mat,prec,x,b,
     #                iprec,index,ia1,info,dw,iw,
     #                ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #                eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.14) then
        call LL1ATPR(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #               mat,prec,x,b,
     #               iprec,index,ia1,info,dw,iw,
     #               ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #               eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.15) then
        call LL1GME5(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.16) then
        call LL1GME20(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
      if (ms.eq.999) then
        call LL1TST(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif

      if (ms.eq.100) then
        call LL1CG(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #             mat,prec,x,b,
     #             iprec,index,ia1,info,dw,iw,
     #             ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #             eps,rlin(1),iconv,ierr)
        go to 333
      endif

      if (ms .eq. 101) then
        call LL1GMS(ldw,liw,lmat,lprec,liprec,lindex,l,lsym,nproc,
     #              mat,prec,x,b,
     #              iprec,index,ia1,info,dw,iw,
     #              ilin,lmatbk,ptrmbk,ptrinf,jump,tids,nmsg,
     #              eps,rlin(1),iconv,ierr)
        go to 333
      endif
 
  333 continue
 
      if (ilin(18) .eq. 0) then
	if (ilin(13) .lt. 0) write(lout,1103)
	if (ilin(13) .gt. 0) then
	  if (myproc .eq. 1) write(lout,1103)
        endif
      else
	if (ilin(13) .lt. 0) write(lout,1102)
	if (ilin(13) .gt. 0) then
	  if (myproc .eq. 1) write(lout,1102)
        endif
      endif
C
C     IF NO CONVERGENCE SEARCH FOR NEW METHOD
C
      if (iconv .eq. 5 .or. iconv .eq. 6) then
	ilin(16) = 4711
	if (ilin(1) >= 200 .and. ilin(1) <= 221) then
	  if (ms .eq. 1) then 
	    ispoly(1) = ispoly(1) + ilin(11)
          endif
	  if (ms .eq. 7) then 
	    ispoly(2) = ispoly(2) + ilin(11)
          endif
	  if (ms .eq. 15 .or. ms .eq. 16 .or. ms .eq. 101) then 
	    ispoly(3) = ispoly(3) + ilin(11)
          endif
	  if (ms .eq. 4 .or. ms .eq. 100) then 
	    ispoly(4) = ispoly(4) + ilin(11)
          endif
        endif
	goto 222
      endif
C
      if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1)) then
        call SECONDS(tcpu,tclk)
        call LL8OPS(l,rlin,ilin,ispoly,ms,noop,nproc)
        titer   = tcpu - titer
        if (titer .ne. zero) mflops  = noop*1.d-6/titer
        teiter  = tclk - teiter
        if (teiter .ne. zero) mflope  = noop*1.d-6/teiter
        write(lout,1140)
        write(lout,1136) titer
        if (titer .ne. zero) write(lout,1141) mflops
        write(lout,1137) teiter
        if (teiter .ne. zero) write(lout,1142) mflope
      endif

      if ((ms .eq. 9) .or. lsym .or. (ilin(15) .gt. 10)) then
        do 65 i = 1,lmyblk
           x(i) = prec(i) * x(i)
   65   continue
      endif

C      
C     COMPUTATION OF THE SOLUTION X     
C      
      if (ilin(16) .eq. 4711) then
         do 75 i = 1,lmyblk
            x(i) = x(i) + prec(ibxorg+i-1)
   75    continue
      endif
      
      include "norec.h"
      do 85 i = 1,l
        b(i) = prec(ibborg+i-1)
   85 continue

  999 ilin(16)=ilin16
      ilin(3) = nmsg

      if ((mod(optim,10) .eq. 1) .and. (myproc .eq. 1)) then
        call SECONDS(tcpu,tclk)
        tlpp  = tcpu - tlpp
        telpp = tclk - telpp
        write(lout,1138) tlpp
        write(lout,1139) telpp
      endif
C
C
C**** END OF CALCULATION
C     ------------------
C
 1000 format('  ---------------------------------------------------- '/
     &       ' | -------------------------------------------------- |')
 1001 format(' ||      L S O L P P - Version 1.0  (January 2002)   ||')
 1003 format(' ||      installed on a NON-PARALLEL computer        ||')
 1004 format(' ||      installed on a PARALLEL computer            ||')
 1002 format(' | -------------------------------------------------- |'/
     &       '  ---------------------------------------------------- '/)
 1020 format(' **************************************************'/
     &       ' ***  Error occured in LSOLPP:                  ***')
 1021 format(' ***   check input parameters!                  ***')
 1022 format(' ***   normalization failed!                    ***')
 1024 format(' ***   <ia1> is ',i6,', but must be greater     ***'/
     &       ' ***   than ',i6,' on process ',i6,' for        ***'/
     &       ' ***   for cache reuse!                         ***')
 1025 format(' ***   <liw> is ',i6,', but must be greater     ***'/
     &       ' ***   than ',i6,' on process ',i6,'            ***'/
     &       ' ***   for cache reuse!                         ***')
 1026 format(' ***   results from Backward Substitution or    ***'/
     &       ' ***   Forward Elimination are too large or not ***'/
     &       ' ***   an arithmetic number!                    ***')
 1030 format(' **************************************************')
 1035 format(' ***   Output unit number LOUT has              ***'/
     &       ' ***   to be greater than zero.                 ***')
 1101 format('  Initial guess used')
 1102 format('  Smoothed solution used'/)
 1103 format('  Original solution used'/)
 1104 format('  Safe cache reuse switched on')
 1105 format('  Unsafe cache reuse switched on')
 1111 format('  Cache size (in 64-bit words) is ',i6)
 1112 format('  Cache use factor is ',f4.1,' --> length of vector')
 1113 format('  .... terms is broken down to max. ',i6,' elements')
 1106 format('  Matrix is subdivided logically into ',i4,' blocks')
 1107 format('  ---> ',i6,' additional vector terms are created')
 1108 format('  Vector terms are checked and printed on unit ',i3/)
 1109 format('  Matrix(part) is printed on unit ',i3,' in ASCII-format')       
 1114 format('  Matrix(part) is printed on unit ',i3,/
     &       '  in binary format (single precision)')       
 1110 format('  All elements of the Right Hand Side are zero!')
 1120 format('  Solution is the initial guess!')
 1130 format('   CPU-Time     for cache reuse      (in seconds):',f8.2)
 1131 format('   Elapsed Time for cache reuse      (in seconds):',f8.2/)
 1132 format('   CPU-Time     for normalization    (in seconds):',f8.2)
 1133 format('   Elapsed Time for normalization    (in seconds):',f8.2/)
 1134 format('   CPU-Time     for preconditioning  (in seconds):',f8.2)
 1135 format('   Elapsed Time for preconditioning  (in seconds):',f8.2/)
 1136 format('   CPU-Time     for iterative solver (in seconds):',f8.2)       
 1137 format('   Elapsed Time for iterative solver (in seconds):',f8.2)
 1138 format('   CPU-Time     for LSOLPP           (in seconds):',f8.2)
 1139 format('   Elapsed Time for LSOLPP           (in seconds):',f8.2/)
 1140 format(/'  TIME STATISTICS: ')
 1141 format('   MFLOPS-rate regarding the just meas. CPU-time :',f8.2)       
 1142 format('   MFLOPS-rate reg. the just meas. elapsed time  :',f8.2/)
      r e t u r n
C-----END OF LSOLPP----------------------------------------------------
      e    n    d
