#include <sys/types.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/param.h>
#include <stdio.h>
#include <unistd.h>

#ifdef FTNLINKSUFFIX
#define FTNNAME(n) n ## _
#else
#define FTNNAME(n) n
#endif

/*****************************************************************************/
#ifdef UPPERCASE
void FTNNAME(SECONDS)(double *cpu, double *wall)
#else
void FTNNAME(seconds)(double *cpu, double *wall)
#endif
/*********************************************************************/
/**                                                                 **/
/**    Copyright (C) 2000 University Karlsruhe                      **/
/**    Programmer: H. Haefner                                       **/
/**                                                                 **/
/**    This file is part of LINSOL.                                 **/
/**    LINSOL is free software; you can redistribute it and/or      **/
/**    modify it under the terms of the GNU General Public License  **/
/**    as published by the Free Software Foundation; either         **/
/**    version 2 of the License, or (at your option) any later      **/
/**    version.                                                     **/
/**                                                                 **/
/**    LINSOL is distributed in the hope that it will be useful,    **/
/**    but WITHOUT ANY WARRANTY; without even the implied warranty  **/
/**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      **/
/**    See the GNU General Public License for more details.         **/
/**                                                                 **/
/**    You should have received a copy of the GNU General Public    **/
/**    License along with LINSOL; if not, write to the Free         **/
/**    Software Foundation, Inc., 59 Temple Place - Suite 330,      **/
/**    Boston, MA  02111-1307, USA.                                 **/
/**                                                                 **/
/*********************************************************************/
{
 struct timeval tp;
 struct timezone tzp;
 extern int errno;
 long int clktck;
 double h;
 struct tms buffer;

 clktck = sysconf(_SC_CLK_TCK);
 h = 1.0/clktck;

 gettimeofday(&tp, &tzp);
 *wall = ((double) tp.tv_sec + 0.000001 * (double) tp.tv_usec);
 if (times(&buffer) == -1)
 {
  printf(" Error in second %d \n", errno);
  exit(1);
 }
 else
 *cpu = (double) (buffer.tms_utime * h + buffer.tms_stime * h);
 return;
}
/*****************************************************************************/
