!:::::     ,,,,,SHOWVT.....
!
!
!
!**********************************************************************
!        1         2         3         4         5         6         7*
!**********************************************************************
!**                                                                 ***
!**                                                                 ***
      subroutine SHOWVT(MAT,lmat,index,lindex,info,ia1,nvt,l,lsym,
     &                  myproc,nproc,lmatbk,lout,ierr)
!**                                                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**   SHOWVT   Output and check of vector terms of the matrix,      ***
!**            which is defined by the arrays MAT, INFO and INDEX.  ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**    Copyright (C) 1994 University Karlsruhe                      ***
!**    Programmer: H. Haefner, F. Seegmueller                       ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
!**                                                                 ***
!**********************************************************************
!**                                                                 ***
!**     THE IMPLICIT NONE-INSTRUCTION HAS THE AIM,                  ***
!**     THAT ALL VARIABLES MUST BE DECLARED EXPLICITLY.             ***
!**                                                                 ***
      USE constants

      implicit none
!**                                                                 ***
!**-----------------------------------------------------------------***
!**                                                                 ***
!**      FORMAL PARAMETERS :                                        ***
!**      -----------------                                          ***
!**                                                                 ***
      integer, intent(in) :: lmat,lindex,l,lout,ia1,nvt,myproc,nproc
      integer, intent(out):: ierr
      integer, intent(in) :: index(lindex),info(ia1,ia2),lmatbk(nproc)
      double precision, intent(in) :: MAT(lmat)
      logical, intent(in) :: lsym
!**                                                                 ***
!**   LIST OF FORMAL PARAMETERS :                                   ***
!**   -------------------------                                     ***
!**                                                                 ***
!**   (see Manual-Pages <lsolpp>)                                   ***
!**                                                                 ***
!**                                                                 ***
!**      LOCAL PARAMETERS :                                         ***
!**      -----------------                                          ***
!**                                                                 ***
      integer i,j,pos,posidx,length,row,column,indr,indc
      integer posidc,posidr,typ,llout
      integer ptrmbk(nproc+1)
      logical intest     
      character*16 ctyp
!     character*80 name
!**
!**                                                                 ***
!**** START OF CALCULATION :
!**   ----------------------
!**
      ierr = 0
      llout = lout
!**
!***  output file settling
!**
!     if (nproc .eq. 1) then
!
! output in standard output with unit number LOUT
!
      if ((llout .le. 0) .or. (llout .gt. 99)) llout = 6 
!     else if ((nproc .gt. 1) .and. (nproc .le. maxnpe)) then
!
! output in file 'output.proc.nr<MYPROC>'
!
!        llout = 60 + myproc
!        write(name,500) myproc
!        open(llout,file=name)
!     else 
!        if ((llout .lt. 0) .or. (llout .gt. 99)) llout = 6 
!        write(llout,2000) maxnpe
!        ierr = 1
!        goto 9999
!     endif
!**
!***  check array bounds of array INFO
!**
      if (ia1 .lt. nvt) then
	 write(llout,410) 
	 ierr = 1
	 goto 9999
      endif
!     
      if (ia2 .lt. 7) then
	 write(llout,420) 
	 ierr = 1
	 goto 9999
      endif

      ptrmbk(1) = 0
      do i=1,nproc
        ptrmbk(i+1) = ptrmbk(i)+lmatbk(i)
      enddo

!**
!***  Output of vector terms 
!**
      write(llout,100) 
      write(llout,110)
      write(llout,990) myproc
      do 200 i=1,nvt
         intest = .false.
         typ = info(i,1)
!
   	 if ((typ .eq. 10) .or. (typ .eq. 1)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' main diagonal'
	    pos    = info(i,2)
            length = info(i,3)
	    column = info(i,4) + 1
	    row    = info(i,5) + 1
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 10 j=1,length
	       column = info(i,4) + j
	       row    = info(i,5) + j
               write(llout,1020) row,column,mat(pos+j)
   10       continue
! 
   	 elseif ((typ .eq. 20) .or. (typ .eq. 2)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' full diagonal'
	    pos    = info(i,2)
	    length = info(i,3)
	    column = info(i,4) + 1
	    row    = info(i,5) + 1
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 20 j=1,length
               column = info(i,4) + j
 	       row    = info(i,5) + j
               write(llout,1020) row,column,mat(pos+j)
   20       continue
!
   	 elseif ((typ .eq. 30) .or. (typ .eq. 3)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' packed diagonal'
	    pos    = info(i,2)
	    length = info(i,3)
	    indc   = info(i,6)
	    posidx = index(indc+1)
	    column = info(i,4) + posidx
	    row    = info(i,5) + posidx
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 30 j=1,length 
	       posidx = index(indc+j)
 	       column = info(i,4) + posidx
 	       row    = info(i,5) + posidx
               write(llout,1030) posidx,row,column,mat(pos+j)
   30       continue
!
   	 elseif ((typ .eq. 40) .or. (typ .eq. 4)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' indexed column'
            pos    = info(i,2)
            length = info(i,3)
            posidx = info(i,6)
            indc   = index(posidx+1)
            column = info(i,4) + indc
            row    = info(i,5) + 1
            write(llout,1000) real(i),ctyp,typ
            write(llout,1010) row,column,length 
            do 40 j=1,length
               indc   = index(posidx+j)
 	       column = info(i,4) + indc
 	       row    = info(i,5) + j
               write(llout,1033) indc,row,column,mat(pos+j)
   40       continue
!
   	 elseif ((typ .eq. 50) .or. (typ .eq. 5)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' indexed row'
	    pos    = info(i,2)
	    length = info(i,3)
	    posidx = info(i,7)
            indr   = index(posidx+1)
	    column = info(i,4) + 1
	    row    = info(i,5) + indr
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 50 j=1,length
	       indr   = index(posidx+j)
 	       row    = info(i,5) + indr
 	       column = info(i,4) + j
               write(llout,1037) indr,row,column,mat(pos+j)
   50       continue
!
         elseif ((typ .eq. 60) .or. (typ .eq. 6)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' starry sky'
	    pos    = info(i,2)
	    length = info(i,3)
	    posidc = info(i,6)
	    posidr = info(i,7)
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1016) length 
 	    do 60 j=1,length
	       indc   = index(posidc+j)
               indr   = index(posidr+j)
               column = indc
               row    = indr
               write(llout,1040) indr,indc,row,column,mat(pos+j)
   60       continue
!
         elseif ((typ .eq. 70) .or. (typ .eq. 7)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' full row'
	    pos    = info(i,2)
	    length = info(i,3)
	    column = info(i,4) + 1
	    row    = info(i,5) + 1
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 70 j=1,length
 	       column = info(i,4) + j
              write(llout,1020) row,column,mat(pos+j)
   70       continue
!
   	 elseif ((typ .eq. 80) .or. (typ .eq. 8)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' full column'
	    pos    = info(i,2)
	    length = info(i,3)
	    column = info(i,4) + 1
	    row    = info(i,5) + 1
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 80 j=1,length
 	       row = info(i,5) + j
               write(llout,1020) row,column,mat(pos+j)
   80       continue
!
         elseif ((typ .eq. 90) .or. (typ .eq. 9)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' packed row'
	    pos    = info(i,2)
	    length = info(i,3)
            posidx = info(i,6)
            indc   = index(posidx+1)
	    column = info(i,4) + indc
	    row    = info(i,5) + 1
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 90 j=1,length
               indc   = index(posidx+j)
 	       column = info(i,4) + indc
               write(llout,1033) indc,row,column,mat(pos+j)
   90       continue
!
   	 elseif ((typ .eq. 100) .or. (typ .eq. 11)) then
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
	    ctyp   = ' packed column'
	    pos    = info(i,2)
	    length = info(i,3)
	    posidx = info(i,7)
	    indr   = index(posidx+1)
	    column = info(i,4) + 1
	    row    = info(i,5) + indr
	    write(llout,1000) real(i),ctyp,typ
	    write(llout,1010) row,column,length 
 	    do 101 j=1,length
	       indr   = index(posidx+j)
 	       row    = info(i,5) + indr
               write(llout,1037) indr,row,column,mat(pos+j)
  101       continue
!
         else
            call TESTVT(ia1,lindex,nproc,myproc,l,lmat,info,
     &                  index,lmatbk,ptrmbk,i,intest,llout) 
	    if (intest) goto 199 
!	    
         endif
         write(llout,*) ' '
!
  199    continue
         if (intest) then 
	    write(llout,4000) 
	    ierr = ierr + 1
         endif
!
  200 continue
!**
!***  Check if symmetric matrix is given
!**
      write(llout,1050) lsym
      if (lsym) then
         write(llout,1060) 
      else
         write(llout,1070) 
      endif
!**
!***
!**
      if (ierr .eq. 0) then
         write(llout,4010)
      else 
	 write(llout,4020) ierr
      endif
!**
!***
!**
 9999 continue
!**
!***  END OF CALCULATION
!***  ------------------
!**
!
  100 format('Vector terms of matrix M = m(i,j) defined by',
     &       ' arrays MAT, INFO and INDEX.')
  110 format('--------------------------------------------',
     &       '----------------------------' /)
  410 format(' *** SHOWVT: error detected;',/
     &       '             first dimension of array INFO',/
     &       '             too small: IA1 is less than NVT.'/)
  420 format(' *** SHOWVT: error detected;',/
     &       '             second dimension of array INFO',/
     &       '             too small: IA2 is less than 7.'/)
! 500 format('output.proc.nr',i5.5)
  990 format(' Vector terms of matrix on processor ',i5,':' /)
 1000 format(f5.0,' vector term is ',a16,' (type = ',i2,') : ')
 1010 format(7x,'starting in row ',i6,' , column ',i6,
     &       ' , length: ',i6)
 1016 format(7x,'with length: ',i6)
 1020 format(7x,'m(',i6,',',i6,') = ',d17.10)
 1030 format(7x,'index = ',i6,' , m(',i6,',',i6,') = ',d17.10)
 1033 format(7x,'col-index = ',i6,' , m(',i6,',',i6,') = ',d17.10)
 1037 format(7x,'row-index = ',i6,' , m(',i6,',',i6,') = ',d17.10)
 1040 format(7x,'row-index = ',i6,' , col-index = ',i6,
     &       ' , m(',i6,',',i6,') = ',d17.10)
 1050 format(' LSYM = ',l1)
 1060 format(' ==> LSOLPP uses a symmetric matrix A with elements',
     &       ' m(i,j)+m(j,i)', /
     &       '     in row i, column j and row j, column i for i<>j ',
     &       'and with ',/
     &       '     m(i,i) in the main diagonal.'/)
 1070 format(' ==> LSOLPP uses the given unsymmetric matrix M',/
     &       '     (defined by the arrays MAT, INFO, INDEX).'/)
 2000 format(' *** SHOWVT: error detected; ',/
     &       '             NPROC = number of used processors ',
     &       '             has to be >= 1 and <=',i5)
 4000 format(
     & '      No output because of incorrect defined vector term.'/)
 4010 format(' All vector terms checked: no error detected.'/)
 4020 format(' *** SHOWVT: errors detected; ',/
     &       '            ',i6,' vector terms incorrect defined.'/
     &       '             Check input parameters and ',
     &       'arrays INFO, INDEX.'/)
!
      r e t u r n
!-----END OF SHOWVT---------------------------------------------------      
      e n d
