C:::::      ,,,,,MPSCAT.....
C
C
C
C**********************************************************************
C        1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      subroutine MPSCAT(svect,lstr,myproc,nproc,tids,nmsg)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      M P S C A T   broadcasts the computed values stored in     ***
C**                    <svect> to all processes (processors).       ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
!**    Copyright (C) 1996 University Karlsruhe                      ***
!**    PROGRAMMER:    H. Haefner                                    ***
!**                                                                 ***
!**    This file is part of LINSOL.                                 ***
!**    LINSOL is free software; you can redistribute it and/or      ***
!**    modify it under the terms of the GNU General Public License  ***
!**    as published by the Free Software Foundation; either         ***
!**    version 2 of the License, or (at your option) any later      ***
!**    version.                                                     ***
!**                                                                 ***
!**    LINSOL is distributed in the hope that it will be useful,    ***
!**    but WITHOUT ANY WARRANTY; without even the implied warranty  ***
!**    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      ***
!**    See the GNU General Public License for more details.         ***
!**                                                                 ***
!**    You should have received a copy of the GNU General Public    ***
!**    License along with LINSOL; if not, write to the Free         ***
!**    Software Foundation, Inc., 59 Temple Place - Suite 330,      ***
!**    Boston, MA  02111-1307, USA.                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
      implicit none
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      FORMAL PARAMETERS :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
      integer            lstr,myproc,nproc,nmsg 
      integer            tids(nproc)
C**                                                                 ***
      character*1        svect(lstr)                
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   LIST OF FORMAL PARAMETERS :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C NAME   I TYPE I I/O I     MEANING
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C svect  I  C   I i/o I  string vector for routine <ROUTIN>          
C--------I------I-----I------------------------------------------------
C lstr   I  I   I in  I  length of the above mentioned vectors in Bytes 
C--------I------I-----I------------------------------------------------
C myproc I  I   I in  I  process(or) id
C--------I------I-----I------------------------------------------------
C nproc  I  I   I in  I  number of processes (processors)
C--------I------I-----I------------------------------------------------
C tids   I  I   I in  I  set of tids                array : tids(nproc)
C--------I------I-----I------------------------------------------------
C nmsg   I  I   I i/o I  global message counter, must have the same
C        I      I     I  value on all processes (processors) on entry
C--------I------I-----I------------------------------------------------
C**                                                                 ***
C**                                                                 ***
C**        LOCAL PARAMETERS :                                       ***
C**        ----------------                                         ***
C**                                                                 ***
      integer           j,a,b,info,msgtp,mids,midr,frtid,topid
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C
C
C**** START OF CALCULATION :
C     ---------------------
C
      msgtp=0
      a=1
      b=0
   20 continue
      if (a .lt. nproc) then
	b=b-a
	a=2*a
        goto 20
      endif
 
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   THE COMPUTED VALUES ARE BROADCASTED WITH CASCADE              ***
C**   -----------------------------------------------               ***
C**                                                                 ***
      a=a/2
      b=b+a
  120 continue
      if (a .gt. 0) then
        msgtp=msgtp+1
	j=(myproc-b)/(2*a)
	if (a*2*j+b .eq. myproc) then
	  frtid=tids(a*(2*j-1)+b)
	  call MPRCVA(frtid,nmsg+msgtp,lstr,svect,midr,info)
	  call MPRCVW(frtid,nmsg+msgtp,lstr,svect,midr,info)
        endif
	j=(myproc-b+a)/(2*a)
	if (a*(2*j-1)+b .eq. myproc) then
	  topid=a*2*j+b
	  if (topid .le. nproc) then
	    call MPSNDA(tids(topid),nmsg+msgtp,lstr,svect,mids,
     #                  info)
	    call MPSNDW(tids(topid),nmsg+msgtp,lstr,svect,mids,
     #                  info)
	  endif
	endif
	a=a/2
	b=b+a
        goto 120
      endif
C
      nmsg = nmsg+msgtp
C
C**** END OF CALCULATION
C     ------------------
C
      r e t u r n
C-----END OF MPSCAT---------------------------------------------------
      e    n    d
